/*
 *
 * File:		crsv.c
 * Datum:		11 oktober 2015
 * Versie:		6.01
 * Ontwerp:		M.J.M. Fick
 * Copyright:		Movensis (c) 1998-2015
 *
 */

/* define RWSC_old */

#include "crsg.h"	/* tbv bepaling aanwezigheid confl.ontr.tijden	*/
#include "cif.inc"

#define NIET    -1	/* tbv definitie's				*/
#define	BIT0     1	/* tbv bitsgewijze aansturing variabelen	*/
#define	BIT1     2
#define	BIT2     4
#define	BIT3     8
#define	BIT4    16
#define	BIT5    32
#define	BIT6    64
#define	BIT7   128

#define FIXATIE  0	        /* tbv definitie ingreep fixatie        */

#define MA_CRSV       0         /* bestuur MA_optie                     */
#define PPS_CRSV      1         /* bestuur PPS_optie                    */
#define RWR_CRSV      2         /* bestuur RWR_optie                    */
#define VRVG_CRSV     3         /* bestuur VRVG_optie                   */
#define VVAG2e_CRSV   4         /* bestuur VVAG2e_optie                 */
#define RVAG2e_CRSV   5         /* bestuur RVAG2e_optie                 */
#define VMVG_CRSV     6         /* bestuur VMVG_optie                   */
#define AFK_CRSV      7         /* bestuur AFK_optie                    */

#define CRSV_versie    601      /* Versie CRSV module                   */

extern struct CONFLICT CONFLICT_tabel[];
extern struct DIMENSIES DIMENSIE_tabel[];

static Bool  HFIX;		/* Fixatie toegestaan			*/
static Bool  TS,_TS;		/* Start seconde			*/
static Bool  SPR;		/* Start programma			*/
static Bool  SVAS;		/* Start VAS-programma			*/
static Bool  OMSCH;		/* Start omschakeling			*/
static Bool  SSYNC;		/* Start synchronisatie			*/

static Int16 TE;		/* Tienden van seconden                 */
static Int16 CIF_TE_SECONDE;	/* Actuele waarde CIF_KLOK              */
static Int16 BUF_TE_SECONDE;	/* Buffer waarde vorige systeemronde    */

static Int16 GEWPRG;		/* Gewenst VAS-programma		*/
static Int16 AKTPRG;		/* Aktief  VAS-programma		*/
static Int16 CKODE,HKODE,LKODE;	/* Hulpwaarden tbv prog.keuze		*/
static Int16 MKODE;		/* Prog.keuze complexcoordinator	*/

static Int16 CTYD;		/* Aktuele cyclustijd			*/
static Int16 IPNT;		/* Aktueel inschakelpunt		*/
static Int16 OPNT;		/* Aktueel omschakelpunt		*/
static Int16 CPNT;		/* Aktueel synchronisatiepunt		*/
static Int16 STAP;		/* Stappenteller VAS			*/

static Bool  Straag;		/* Vertraag stappenraster		*/
static Bool  Svsnel;		/* Versnel  stappenraster		*/
static Bool  Sstart;		/* Herstart stappenraster		*/
static Bool  Sblok;		/* Blokkeer stappenraster		*/
static Bool  Sdubb;		/* Verhoog  stappenraster		*/
static Int16 Sverschil;		/* Aktueel  sync.verschil		*/
static Int16 Sversnel;		/* Hulpwaarde tbv vernellen		*/
static Bool  N_ts;		/* Hulpwaarde tbv vernellen		*/

static Int16 aant_gcf[NUMSG];	/* Aantal primaire conflicten		*/
static Int16 aant_dgc[NUMSG];	/* Inclusief doorgeschreven conflicten  */
static Int16 aant_fcf[NUMSG];	/* Aantal fictieve conflicten		*/
static Int16 aant_dfc[NUMSG];	/* Inclusief doorgeschreven conflicten  */
static Int16 gcf[NUMSG][MAX_SG];/* Primaire conflict-matrix		*/
static Int16 fcf[NUMSG][MAX_SG];/* Fictieve conflict-matrix		*/
static Int16 fts[NUMSG][5];	/* Def.fts.vtg.koppelingen		*/
static Int16 bbv[NUMSG][9];	/* Def.vtg.koppelingen [ progressief ]	*/
static Int16 gov[NUMSG][29];	/* Def.vtg.koppelingen [ gescheiden  ]	*/
static Int16 hki[NUMSG][21];	/* Def.hki.koppelingen [ serieel ]	*/
static Int16 ovp[NUMSG][19];	/* Def.OV-prioriteit			*/
static Int16 aant_fts;		/* Aantal aanwezige fts.vtg.koppelingen */
static Int16 aant_bbv,aant_gov;	/* Aantal aanwezige vtg.koppelingen	*/
static Int16 aant_hki;		/* Aantal aanwezige hki.koppelingen	*/

static Bool   K[NUMSG];		/* Conflicterende (ontruimingen) aanw.	*/
static Int16 HG[NUMSG];		/* Hulpwaarde groen voedende richting	*/
static Int16 HG_hki[NUMSG][MAX_SG]; /* HG[] uitgesplitst naar koppeling */
static Bool  _HG[NUMSG];	/* Voedende richting hki heeft HG[]     */
static Bool  _TTR_HK[NUMSG];	/* Volgrichting hki nog realiseren      */
static Int16 VA[NUMSG];		/* Buffer aanvraag signaalgroep		*/
static Int16  B[NUMSG];		/* Overgang van WR naar ROG gewenst	*/
static Int16  X[NUMSG];		/* Blokkeer overgang van RVG naar VG	*/
static Int16 RR[NUMSG];		/* Terugkeren van ROG/RVG naar WR	*/
static Int16 RW[NUMSG];		/* Aanhouden/terugkeren naar VAG2e	*/
static Int16 RW_hki[NUMSG][MAX_SG]; /* RW[] uitgesplitst naar koppeling */
static Int16 BW_hki[NUMSG][MAX_SG]; /* Bewaak doorkoppeling fc1->2->fc3 */
static Int16 YV[NUMSG];		/* Aanhouden VAG2e			*/
static Int16 YM[NUMSG];		/* Aanhouden meeverlenggroen		*/
static Int16  Z[NUMSG];		/* Afkappen groenfase			*/

static Bool  BAR[NUMSG];	/* Blokkeer alternatieve realisatie	*/
static Bool  BHK[NUMSG];	/* Blokkeer tbv inschakelen hki         */
static Bool  BLW[NUMSG];	/* Blokkeer wachtstand aanvraag		*/
static Bool  VG1[NUMSG];	/* YV ogv H1e_TIJD tijdens PRIM.real.   */
static Int16  KG[NUMSG];	/* Klokgroen				*/
static Int16 KRA[NUMSG];	/* Klokrood na aanvraag			*/
static Int16 KNP[NUMSG];	/* Klok na prioriteit			*/
static Int16 KNP_hki[NUMSG][MAX_SG];/* KNP[] uitgesplitst naar koppeling*/
static Int16 FCA[NUMSG];	/* Fictieve aanvraag aanwezig		*/
static Int16 FCA_hki[NUMSG][MAX_SG];/* FCA[] uitgesplitst naar koppeling*/
static Int16 TEG[NUMSG];	/* Tijd tot einde groen			*/
static Int16 TSPR[NUMSG];	/* Tijd tot start primaire realisatie	*/
static Int16 TEPR[NUMSG];	/* Tijd tot einde primaire realisatie	*/
static Int16 PEG[NUMSG];	/* Tijd tot einde groen bij confl.prio. */
static Int16 TTK[NUMSG];	/* Tijd tot kappen			*/
static Int16 TTR[NUMSG];	/* Tijd tot alternatieve realisatie	*/
static Int16 TTR_WV[NUMSG];	/* Tijd tot alternatieve realisatie	*/
static Int16 TTR_HK[NUMSG];	/* Tijd tot hki realisatie	        */
static Int16 TTR_HK_oud[NUMSG];	/* Tijd tot hki realisatie              */
static Int16 TTW[NUMSG];	/* Tijd tot realisatie bij SVAS		*/
static Int16 TTP[NUMSG];	/* Tijd tot primaire realisatie		*/
static Int16 VTTP[NUMSG];	/* TTP ten behoeve van vooruitschakelen	*/
static Int16 UTTP[NUMSG];	/* Uiterste tijd tot primaire realisatie*/
static Int16 TTU[NUMSG];	/* Tijd tot einde uitstel		*/
static Int16 TPVU[NUMSG];	/* Max.tijd voor einde.uitst. tbv prio. */
static Int16 TTPG[NUMSG];	/* Tijd tot primair.gr tbv WTvoorspeller*/
static Int16 ALTM[NUMSG];	/* Ondergr. V.A.-groen bij ALT.real.	*/
static Int16 KAPM[NUMSG];	/* Ondergr. V.A.-groen bij KAP.door OV	*/
static Int16 MAXG[NUMSG];	/* Maximum. V.A.-groen volgens raster	*/
static Int16 VAS1[NUMSG];	/* VAS array -> einde uitstel		*/
static Int16 VAS2[NUMSG];	/* VAS array -> start primair		*/
static Int16 SVS2[NUMSG];	/* VAS array -> start primair bij SVAS  */
static Int16 VAS3[NUMSG];	/* VAS array -> start verleng		*/
static Int16 VAS4[NUMSG];	/* VAS array -> einde primair		*/
static Int16 VAS5[NUMSG];	/* VAS array -> einde groen		*/
static Int16 HVAS[NUMSG];	/* VAS array -> hulpwaarden		*/
static Int16 PVAS[NUMSG];	/* VAS array -> tbv prioriteit OV	*/
static Int16 PVAS_hki[NUMSG][MAX_SG];/* PVAS[] uitgesplitst op koppeling*/
static Int16 PVS2[NUMSG];	/* VAS array -> tbv prioriteit OV	*/
static Int16 TTPR[NUMSG];	/* Tijd tot prioriteitsrealisatie       */
static Int16 CTTP[NUMSG];	/* Correctie TTP[] ivm OV.prioriteit	*/
static Int16 SDSN[NUMSG];	/* Tijd tot start doorsnijden           */
static Int16 EDSN[NUMSG];	/* Uiterste tijd tot terugkomen         */
static Int16 PRGR[NUMSG];	/* Klok primair groen                   */
static Int16 DSSP[NUMSG];	/* Tijd tot doorsnijden start OV.prio.  */
static Int16 DSEP[NUMSG];	/* Tijd tot doorsnijden einde OV.prio.  */

static Int16 TSP[NUMSG];	/* Tijd tot start OV.prio.mogelijkheid  */
static Int16 TEP[NUMSG];	/* Tijd tot einde OV.prio.mogelijkheid  */
static Int16 TEG_OV[NUMSG];	/* Tijd tot einde groen agv OV.prio.    */
static Int16 VS2M[NUMSG];	/* VAS array -> uiterste start primair  */

static Int16 _tts;		/* bijbehorende tijd tot stopstreep     */
static Int16 _vtg;		/* bijbehorende voertuignummer          */
static Int16 _vgr;		/* bijbehorende groentijd voor passage  */
static Int16 _pri;		/* bijbehorende prioriteitsvlag         */

static Int16 TTK_hki[NUMSG];	/* TTK door eerstvolgend conflict       */
static Int16 TEG_hki[NUMSG];	/* TEG van  lopend       conflict       */

static Bool  WTV_SG[NUMSG];	/* Wachttijdvoorspeller aanwezig        */
static Bool  CON_BUS[NUMSG];	/* Conflicterende BUS ingreep aktief    */
static Int16 HALT[NUMSG];	/* Halteer aflopen wachttijdvoorspeller */
static Int16 Adwt[NUMSG];	/* Aktuele tijdsduur sinds doven led    */
static Int16 Tdwt[NUMSG];	/* Tijdsduur tussen doven van twee leds */

static Int16 ALED[NUMSG];	/* Aantal leds wachttijdvoorspeller AAN */
static Bool  ABUS[NUMSG];	/* Led conflicterende bus aanwezig  AAN */
static Bool  HKV[NUMSG];        /* Hulpvlag harde interne koppeling     */
static Bool  DRK[NUMD];         /* Hulpvlag drukknop bediend            */

static Int16 NUMSG_CS;		/* Aantal signaalgroepen tbv CRSV       */
static Int16 PROGKEUZE_CS;	/* Programmakeuze CRSV                  */

Int16 CRSV_TO_CR[NUMSG][8];     /* Array opties CRSV naar C-regelaar    */

/* Hulpfunctie bepaal (fictief) conflicterend gewenst groen */
/* -------------------------------------------------------- */
Bool somfbk(Int16 fc);


/* Hulpfunctie bepaal conflicterend groen */
/* -------------------------------------- */
Bool somgk(Int16 fc);


/* Hulpfuncties bepaal aanhouden meeverlenggroen toegestaan */
/* -------------------------------------------------------- */
Bool hf_mvg(void);	/* Algemeen					*/
Bool hfkp_mvg(void);	/* Specifiek voor "voedende" signaalgroepen 	*/
			/* ... binnen een koppeling			*/

Bool hf_mvg_krp(Int16 fc1,Int16 fcn);	/* Algemeen bij meerdere krp"s	*/
					/* ... per regelaar		*/

/* Hulpfuncties leg conflicten vast t.b.v. CRSV-module */
/* --------------------------------------------------- */
void proc_init_conflict(void);			/* Primaire conflicten      */
void proc_fict_conflict(Int16 fc1,Int16 fc2);	/* Fictieve conflicten      */
void proc_door_conflict(Int16 fc1,Int16 fc2);	/* Doorschrijven conflicten */


/* Hulpfunctie initialiseer CRSV */
/* ----------------------------- */
void proc_init_crsv(Int16 fx, Int16 progkeuze, Int16 CRSVversie);


/* Hulpfuncties definitie signaalgroep-koppelingen t.b.v. CRSV-module */
/* ------------------------------------------------------------------ */
void proc_def_vtg_fts(          /* Vtg.fts.koppeling            */
	Int16 fc1,              /* Signaalgroep 1 (voetganger)  */
	Int16 fc2,              /* Signaalgroep 2 (fietser 1)   */
	Int16 fc3,              /* Signaalgroep 3 (fietser 2)   */
	Int16 mre23,            /* Meerea. fietser 2 met 3      */
	Int16 mre32);           /* Meerea. fietser 3 met 2      */

void proc_def_vtg_bb(           /* BB.vtg.koppeling             */
	Int16 fc1,              /* Signaalgroep 1               */
	Int16 fc2,              /* Signaalgroep 2               */
	Int16 kpt12,            /* KoppelTIJD eg1 -> eg2        */
	Int16 gkg,              /* Geen KoppelGarantie bij alt  */
	Int16 fc3,              /* Gekoppelde fietsrichting 3   */
	Int16 fc4,              /* Gekoppelde fietsrichting 4   */
	Int16 mre34,            /* Meerea. fietser 3 met 4      */
	Int16 mre43,            /* Meerea. fietser 4 met 3      */
	Int16 gkg_pri);	        /* Geen KoppelGarantie bij prio */

void proc_def_vtg_go(           /* GO.vtg.koppeling             */
	Int16 fc1,              /* Signaalgroep 1	        */
	Int16 fc2,              /* Signaalgroep 2	        */
	Int16 kpa12,            /* Kop.aanvr. sg1 -> sg2        */
	Int16 kpa21,            /* Kop.aanvr. sg2 -> sg1        */
	Int16 kpt12,            /* KoppelTIJD sg1 -> eg2        */
	Int16 kpt21,            /* KoppelTIJD sg2 -> eg1        */
	Int16 gkg,              /* Geen KoppelGarantie bij alt  */
	Int16 fc3,              /* Gekoppelde fietsrichting 3   */
	Int16 fc3v,             /* Volgrichting van fietser 3   */
	Int16 mr33v,            /* Naloop nooit zonder voeding  */
	Int16 kpt3s,            /* Koppeltijd vanaf start fc3   */
	Int16 kpt3e,            /* Koppeltijd vanaf einde fc3   */
	Int16 hfk3e,            /* (HF)start naloop einde fc3   */
	Int16 fc4,              /* Gekoppelde fietsrichting 4   */
	Int16 fc4v,             /* Volgrichting van fietser 4   */
	Int16 mr44v,            /* Naloop nooit zonder voeding  */
	Int16 kpt4s,            /* Koppeltijd vanaf start fc4   */
	Int16 kpt4e,            /* Koppeltijd vanaf einde fc4   */
	Int16 hfk4e,            /* (HF)start naloop einde fc4   */
	Int16 mre34,            /* Meerea. fietser 3 met 4      */
	Int16 mre43,            /* Meerea. fietser 4 met 3      */
	Int16 gkg_pri, 	        /* Geen KoppelGarantie bij prio */

                                /* 3e vtg is de middelste vtg!  */
	Int16 vtg3,             /* Signaalgroep 3e voetganger   */
	Int16 kpa31,            /* Kop.aanvr. sg3 -> sg1        */
	Int16 kpa32,            /* Kop.aanvr. sg3 -> sg2        */
	Int16 kpt13,            /* KoppelTIJD sg1 -> eg3        */
	Int16 kpt23,            /* KoppelTIJD sg2 -> eg3        */
	Int16 kpt31,            /* KoppelTIJD sg3 -> eg1        */
	Int16 kpt32);           /* KoppelTIJD sg3 -> eg2        */

void proc_def_hki(		/* HKI.koppeling  [serieel] */
	Int16 fc1,              /* Signaalgroep 1 [voedend] */
	Int16 fc2,              /* Signaalgroep 2 [volg sg1]*/
	Int16 kptvs12,          /* Max.voorst.sg1 -> sg2    */
	Int16 kptsg12,          /* KoppelTIJD sg1 -> eg2    */
	Int16 kpteg12,          /* KoppelTIJD eg1 -> eg2    */
	Int16 kptdm12,          /* KoppelTIJD dm2 na hki    */
	Int16 de11,             /* Det.1 sg1 tbv start.teg  */
	Int16 de12,             /* Det.2 sg1 tbv start.teg  */
	Int16 de13,             /* Det.3 sg1 tbv start.teg  */
	Int16 fc3,              /* Signaalgroep 3 [volg sg2]*/
	Int16 kptvs23,          /* Max.voorst.sg2 -> sg3    */
	Int16 kptsg23,          /* KoppelTIJD sg2 -> eg3    */
	Int16 kpteg23,          /* KoppelTIJD eg2 -> eg3    */
	Int16 kptdm23,          /* KoppelTIJD dm3 na hki    */
	Int16 de21,             /* Det.1 sg2 tbv start.teg  */
	Int16 de22,             /* Det.2 sg2 tbv start.teg  */
	Int16 de23,             /* Det.3 sg2 tbv start.teg  */
	Int16 hf_hki);          /* Hulpfunctie hki aktief   */


/* Hulpfunctie definitie OV-prioriteit t.b.v. CRSV-module */
/* ------------------------------------------------------ */
void proc_def_ov(               /* Definitie OV-prioriteit           */
	Int16 fc,               /* Signaalgroep                      */
	Int16 deftts,           /* Default tijd      tot  stopstreep */
	Int16 defvgr,           /* Default groentijd voor stopstreep */
	Int16 uitbew,           /* Uitmeldbewaking                   */
	Int16 maxveu);          /* Max.tijd voor einde uitstel       */


/* Hulpfunctie seconde behandeling */
/* ------------------------------- */
void proc_crsv_per_seconde(void);


/* Hulpfuncties bepaal aktief stappenraster -> keuze en status */
/* ----------------------------------------------------------- */
void proc_crsv_progkeuze_slaaf( /* Programma-keuze SLAAF    */
	const Int16 atp,	/* Aantal CRSV-stap.rasters */
	Int16 dpr,		/* Default stappenraster    */
	Int16 tt1,		/* Tijdvertr. omschakelen   */
	Int16 ks1,		/* Koppelsignaal 1 "IN"     */
	Int16 ks2,		/* Koppelsignaal 2 "IN"     */
	Int16 ks3,		/* Koppelsignaal 3 "IN"     */
	Int16 ks4);		/* Koppelsignaal 4 "IN"     */

void proc_crsv_progkeuze_master(/* Programma-keuze MASTER   */
	const Int16 atp,	/* Aantal CRSV-stap.rasters */
	Int16 dpr,		/* Default stappenraster    */
	Int16 tt1,		/* Tijdvertr. omschakelen   */
	Int16 ks1,		/* Koppelsignaal 1 "UIT"    */
	Int16 ks2,		/* Koppelsignaal 2 "UIT"    */
	Int16 ks3,		/* Koppelsignaal 3 "UIT"    */
	Int16 ks4,		/* Koppelsignaal 4 "UIT"    */
	Int16 Vas);		/* Gewenst stappenraster    */

void proc_crsv_parm(		/* Aktuele instellingen     */
	Int16 ctyd,		/* Cyclustijd	            */
	Int16 insc,		/* Inschakelpunt            */
	Int16 omsc,		/* Omschakelpunt            */
	Int16 sync);		/* Synchronisatiepunt       */

void proc_crsv_stappenraster(	/* Stat.stap.raster SLAAF   */
	Int16 sync);		/* Koppelsignaal 5 "IN"     */

void proc_crsv_master_raster(	/* Stat.stap.raster MASTER  */
	Int16 ks5,		/* Koppelsignaal 5 "UIT"    */
	Int16 tt_s);		/* Tijdsduur sync.signaal   */


/* Hulpfunctie t.b.v. resetten variabelen bij start CRSV-module */
/* ------------------------------------------------------------ */
void proc_reset_crsv_start(void);


/* Hulpfuncties t.b.v. in- en uitmelden en sorteren OV-meldingen */
/* ------------------------------------------------------------- */
void proc_ov_inm(Int16 _sg);	/* Signaalgroep                */
void proc_ov_uit(Int16 _sg);	/* Signaalgroep                */

void proc_sorteer_bus(
	Int16 fc,		/* Signaalgroep                */
	Int16 nr1,		/* Volgnummer 1                */
	Int16 nr2);		/* Volgnummer 2                */


/* Hulpfuncties t.b.v. signaalgroepsturing CRSV-module         */
/* ---------------------------------------------------         */
void proc_akt_crsv(		/* Bepaal aktuele prim.gebieden*/
	Int16 fc,		/* Signaalgroep                */
	Int16 cyc,		/* SG cyclisch                 */
	Int16 tl1,		/* Einde uitstel               */
	Int16 tl2,		/* Start primair               */
	Int16 tl3,		/* Start verleng               */
	Int16 tl4,		/* Einde primair               */
	Int16 tl5,		/* Einde groen                 */
	Int16 abm,		/* Afbreekmethode              */
	Int16 pri);		/* Prio.buiten primair gebied  */

void proc_min_prim_crsv(void);	/* Min.gebied tbv OV-ingrepen  */

void proc_min_prim_vtg(		/* Corr.agv fts.vtg.oversteken */
	Int16 fc1,		/* Signaalgroep 1              */
	Int16 fc2,		/* Signaalgroep 2              */
	Int16 fc3,		/* Signaalgroep 3              */
	Int16 fc4,		/* Signaalgroep 4              */
	Int16 fc5,		/* Signaalgroep 5              */
	Int16 fc6,		/* Signaalgroep 6              */
	Int16 fc7);		/* Signaalgroep 7              */

void proc_min_prim_hki(void);	/* Corr.agv seriele koppeling  */

void init_kapm_crsv(void);	/* Initialiseer ALTM[]-KAPM[]  */

void proc_kapm_crsv(		/* Bepaal ALTM[] en KAPM[]     */
	Int16 fc,		/* Signaalgroep                */
	Int16 alt,		/* EPARM(ALTVA)                */
	Int16 kap);		/* EPARM(KAPOV)                */

void proc_corr_kapm(void);	/* Cor.ALTM-KAPM ivm oversteken*/

void proc_kapm_crsv_bb(		/* Bep.ALTM-KAPM voor bb.vtg.  */
	Int16 fc1,		/* Signaalgroep 1	       */
	Int16 fc2,		/* Signaalgroep 2	       */
	Int16 kpt12,		/* KoppelTIJD eg1 -> eg2       */
	Int16 gkpg_a,		/* Geen kop.garantie bij alt   */
	Int16 gkpg_p);		/* Geen kop.garantie bij prio  */

void proc_kapm_crsv_go(		/* Bep.ALTM-KAPM voor go.vtg.  */
	Int16 fc1,		/* Signaalgroep 1	       */
	Int16 fc2,		/* Signaalgroep 2	       */
	Int16 kpt12,		/* KoppelTIJD sg1 -> eg2       */
	Int16 kpt21,		/* KoppelTIJD sg2 -> eg1       */
	Int16 gkpg_a,		/* Geen kop.garantie bij alt   */
	Int16 fc3,		/* Gekoppelde fietser 1        */
	Int16 fc4,		/* Gekoppelde fietser 1 volg   */
	Int16 kpt3s,		/* Koppeltijd vanaf start fc3  */
	Int16 kpt3e,		/* Koppeltijd vanaf einde fc3  */
	Int16 fc5,		/* Gekoppelde fietser 2        */
	Int16 fc6,		/* Gekoppelde fietser 2 volg   */
	Int16 kpt5s,		/* Koppeltijd vanaf start fc5  */
	Int16 kpt5e,		/* Koppeltijd vanaf einde fc5  */
	Int16 gkpg_p,		/* Geen kop.garantie bij prio  */

	Int16 vtg3,             /* Signaalgroep 3e voetganger  */
	Int16 kpt13,            /* KoppelTIJD sg1 -> eg3       */
	Int16 kpt23,            /* KoppelTIJD sg2 -> eg3       */
	Int16 kpt31,            /* KoppelTIJD sg3 -> eg1       */
	Int16 kpt32);           /* KoppelTIJD sg3 -> eg2       */

void proc_open_prim_appl(	/* Bep.openhouden prim.gebied  */
	Int16 fc,		/* Signaalgroep	               */
	Int16 hf_op_pr);	/* Hulpfunctie op.prim.gebied  */

void proc_open_prim(		/* Corr.open.prim.fts.vtg.kop  */
	Int16 fc1,		/* Signaalgroep 1              */
	Int16 fc2,		/* Signaalgroep 2              */
	Int16 fc3,		/* Signaalgroep 3              */
	Int16 fc4,		/* Signaalgroep 4              */
	Int16 fc5,		/* Signaalgroep 5              */
	Int16 fc6,		/* Signaalgroep 6              */
	Int16 fc7);		/* Signaalgroep 7              */

void proc_open_hki_prim(void);	/* Corr.open.prim.hki.kop.     */

void proc_bteg_crsv(void);      /* Bepaal TEG[]                */

void corr_bbtegcrsv(            /* Corr.TEG[] voor bb.vtg.kop. */
	Int16 fc1,              /* Signaalgroep 1              */
	Int16 fc2,              /* Signaalgroep 2              */
	Int16 kpt12);           /* KoppelTIJD eg1 -> eg2       */

void corr_gotegcrsv(            /* Corr.TEG[] voor go.vtg.kop. */
	Int16 fc1,              /* Signaalgroep 1              */
	Int16 fc2,              /* Signaalgroep 2              */
	Int16 kpt12,            /* KoppelTIJD sg1 -> eg2       */
	Int16 kpt21,            /* KoppelTIJD sg2 -> eg1       */
	Int16 fc3,		/* Gekoppelde fietser 1        */
	Int16 fc4,		/* Gekoppelde fietser 1 volg   */
	Int16 kpt3s,		/* Koppeltijd vanaf start fc3  */
	Int16 kpt3e,		/* Koppeltijd vanaf einde fc3  */
	Int16 fc5,		/* Gekoppelde fietser 2        */
	Int16 fc6,		/* Gekoppelde fietser 2 volg   */
	Int16 kpt5s,		/* Koppeltijd vanaf start fc5  */
	Int16 kpt5e,		/* Koppeltijd vanaf einde fc5  */

	Int16 vtg3,             /* Signaalgroep 3e voetganger  */
	Int16 kpa31,            /* Kop.aanvr. sg3 -> sg1       */
	Int16 kpa32,            /* Kop.aanvr. sg3 -> sg2       */
	Int16 kpt13,            /* KoppelTIJD sg1 -> eg3       */
	Int16 kpt23,            /* KoppelTIJD sg2 -> eg3       */
	Int16 kpt31,            /* KoppelTIJD sg3 -> eg1       */
	Int16 kpt32);           /* KoppelTIJD sg3 -> eg2       */

void corr_hkitegcrsv(void);     /* Corr.TEG[] voor hki.kop.    */

void proc_bttr_crsv(void);      /* Bepaal TTR[]                */

void proc_cttr_crsv_vtg_fts(	/* Corr.TTR[] -> vtg.fts.koppelingen */
	Int16 fc1,		/* Signaalgroep 1 (voetganger)       */
	Int16 fc2,		/* Signaalgroep 2 (voetganger)       */
	Int16 fc3,		/* Gekoppelde fietsrichting 1	     */
	Int16 fc4,		/* Gekoppelde fietsrichting 2	     */
	Int16 fc5,		/* Gekoppelde fietsrichting 3	     */
	Int16 fc6,		/* Gekoppelde fietsrichting 4	     */
	Int16 fc7);		/* Signaalgroep 3e voetganger        */

void proc_cttr_crsv_hki(void);	/* Corr.TTR[] voor hki.koppeling     */

void proc_bttp_crsv(void);      /* Bepaal TTP[]                      */
void proc_prio_crsv(void);      /* Bepaal prioriteit openbaar vervoer*/
void proc_bcob_crsv(void);	/* Bepaal bit confl.prio.in aantocht */
void proc_btsp_crsv(void);	/* (her)Bereken TSP[]                */
void proc_bdsn_crsv(Int16 fc);  /* Bepaal DSSP[] en DSEP[]           */

void proc_ctep_crsv_hki(void);  /* Corr.TEP[] voor hki.koppeling     */
void proc_ctsp_crsv_hki(void);	/* Corr.TSP[] voor hki.koppeling     */
void proc_cdssp_crsv_hki(void);	/* Corr.DSSP[] voor hki.koppeling    */
void proc_cpvas_crsv_hki(void);	/* Corr.PVAS[] voor hki.koppeling    */
void proc_ctegov_crsv_hki(void);/* Corr.TEG_OV[] voor hki.koppeling  */
void proc_knp_crsv_hki(void);	/* Bepaal klok na prioriteit         */

void proc_cttp_crsv_vtg_fts(	/* Corr.TTP[] en CTTP voor vtg.fts.  */
	Int16 fc1,		/* Signaalgroep 1 (vtg)              */
	Int16 fc2,		/* Signaalgroep 2 (vtg)              */
	Int16 fc3,		/* Gekoppelde.fietsr. 1              */
	Int16 fc4,		/* Gekoppelde.fietsr. 2              */
	Int16 fc5,		/* Gekoppelde.fietsr. 3              */
	Int16 fc6,		/* Gekoppelde.fietsr. 4              */
	Int16 fc7);		/* Signaalgroep 3e voetganger        */

void proc_cttp_crsv_hki(void);	/* Corr.TTP[] voor seriele koppeling */
void proc_prim_crsv(void);      /* Bepaal primaire realisatie        */

void proc_covs_crsv_vtg_fts(    /* Corr.overslag bij vtg.fts.kop.    */
	Int16 fc1,              /* Signaalgroep 1                    */
	Int16 fc2);             /* Signaalgroep 2                    */

void proc_cprm_crsv_vtg_fts(	/* Corr.prim. -> vtg.fts.koppelingen */
	Int16 fc1,              /* Signaalgroep 1                    */
	Int16 fc2,              /* Signaalgroep 2                    */
	Int16 fc3,              /* Signaalgroep 3                    */
	Int16 fc4,              /* Signaalgroep 4                    */
	Int16 fc5,              /* Signaalgroep 5                    */
	Int16 fc6,              /* Signaalgroep 6                    */
	Int16 fc7);		/* Signaalgroep 3e voetganger        */

void proc_altt_crsv(void);      /* Bepaal BAR[] door CRSV-module     */

void proc_altt_appl(		/* Bepaal BAR[] door applicate	     */
	Int16 fc,		/* Signaalgroep			     */
	Int16 hfbar);		/* Hulpfunctie BAR		     */

void proc_cbar_crsv_vtg_fts(	/* Corr.BAR[] -> vtg.fts.koppelingen */
	Int16 fc1,		/* Signaalgroep 1 (voetganger)       */
	Int16 fc2,		/* Signaalgroep 2 (voetganger)       */
	Int16 fc3,		/* Gekoppelde fietsrichting 1	     */
	Int16 fc4,		/* Gekoppelde fietsrichting 2	     */
	Int16 fc5,		/* Gekoppelde fietsrichting 3	     */
	Int16 fc6,		/* Gekoppelde fietsrichting 4	     */
	Int16 fc7);		/* Signaalgroep 3e voetganger        */

void proc_TTK_hki_crsv(void);	/* Bepaal hulpwaarden voor inrijden  */
void proc_cbar_crsv_hki(void);  /* Corr.BAR[] voor hki.koppelingen   */
void proc_altr_crsv(void);      /* Bepaal alternatieve realisatie    */

void proc_vtg_fts_crsv(         /* Vtg.fts.koppeling        */
	Int16 fc1,              /* Signaalgroep 1 (vtg)     */
	Int16 fc2,              /* Signaalgroep 2 (fts 1)   */
	Int16 fc3,              /* Signaalgroep 3 (fts 2)   */
	Int16 mre23,            /* Meerea.fts 1 met fts 2   */
	Int16 mre32);           /* Meerea.fts 2 met fts 1   */

void proc_bb_vtg_crsv(          /* BB.vtg.kop.inc.fiets     */
	Int16 fc1,              /* Signaalgroep 1           */
	Int16 fc2,              /* Signaalgroep 2           */
	Int16 kpt12,            /* KoppelTIJD eg1 -> eg2    */
	Int16 fc3,              /* Gekoppelde fietser 1     */
	Int16 fc4,              /* Gekoppelde fietser 2     */
	Int16 mre34,            /* Meerea. fietser 1 met 2  */
	Int16 mre43);           /* Meerea. fietser 2 met 1  */

void proc_go_vtg_crsv(          /* GO.vtg.kop.inc.fiets        */
	Int16 fc1,              /* Signaalgroep 1              */
	Int16 fc2,              /* Signaalgroep 2              */
	Int16 kpa12,            /* Koppelaanvraag sg1 -> sg2   */
	Int16 kpa21,            /* Koppelaanvraag sg2 -> sg1   */
	Int16 kpt12,            /* KoppelTIJD     sg1 -> eg2   */
	Int16 kpt21,            /* KoppelTIJD     sg2 -> eg1   */
	Int16 fc3,              /* Gekoppelde fietser 1        */
	Int16 fc4,              /* Gekoppelde fietser 1 volg   */
	Int16 mre34,            /* Naloop nooit zonder voeding */
	Int16 kpt3s,            /* Koppeltijd vanaf start fc3  */
	Int16 kpt3e,            /* Koppeltijd vanaf einde fc3  */
	Int16 hfk3e,            /* (HF)start naloop einde fc3  */
	Int16 fc5,              /* Gekoppelde fietser 2        */
	Int16 fc6,              /* Gekoppelde fietser 2 volg   */
	Int16 mre56,            /* Naloop nooit zonder voeding */
	Int16 kpt5s,            /* Koppeltijd vanaf start fc5  */
	Int16 kpt5e,            /* Koppeltijd vanaf einde fc5  */
	Int16 hfk5e,            /* (HF)start naloop einde fc5  */
	Int16 mre35,            /* Meerea. fietser 1 met 2     */
	Int16 mre53,            /* Meerea. fietser 2 met 1     */

	Int16 vtg3,             /* Signaalgroep 3e voetganger  */
	Int16 kpa31,            /* Kop.aanvr. sg3 -> sg1       */
	Int16 kpa32,            /* Kop.aanvr. sg3 -> sg2       */
	Int16 kpt13,            /* KoppelTIJD sg1 -> eg3       */
	Int16 kpt23,            /* KoppelTIJD sg2 -> eg3       */
	Int16 kpt31,            /* KoppelTIJD sg3 -> eg1       */
	Int16 kpt32);           /* KoppelTIJD sg3 -> eg2       */

void proc_hki_crsv(void);	/* HKI.koppeling  [serieel] */
void proc_wsgr_fca_crsv(void);	/* Bep.fic.wachtstand.gr.a. */

void proc_wsgr_crsv(            /* Afw.wachtgroen           */
	Int16 fc,               /* Signaalgroep             */
	Int16 wgr);             /* SCH(WGR)                 */

void proc_mvgr_crsv(            /* Afw.meeverlenggroen      */
	Int16 fc,               /* Signaalgroep             */
	Int16 mvg);             /* SCH(MVG)                 */

void proc_reset_crsv_einde(void);
void proc_ttpg_crsv(void);      /* Bepaal TTPG[] tbv WTvoorspeller */
void proc_wt_voorspeller_crsv(void); /* Wachttijdvoorspeller CRSV  */


/* Hulpfunctie koppeling CRSV-module -> CRS */
/* ---------------------------------------- */
void proc_crsv_to_crs(void);    /* Bestuur SG-opties        */


/* Hulpfuncties t.b.v. combinering functie-aanroepen */
/* ------------------------------------------------- */
void CRSV_SG_main_1(void);
void CRSV_SG_main_2(void);

/* FUNCTIE BEPAAL (FICTIEF) CONFLICTEREND GEWENST GROEN */
/* ==================================================== */

Bool somfbk(
	Int16 fc)
{
 Int16 j,k;

 for (j=0; j<aant_dgc[fc]; j++) {	/* Primaire conflicten */
   k = gcf[fc][j];
   if (B[k] || ROG(k) || RVG(k) || G(k) && (!MVG(k) || RW[k])) return TRUE;
 }
 for (j=0; j<aant_dfc[fc]; j++) {	/* Fictieve conflicten */
   k = fcf[fc][j];
   if (B[k] || ROG(k) || RVG(k)) return TRUE;
 }
 return FALSE;
}

/* FUNCTIE BEPAAL CONFLICTEREND GROEN */
/* ================================== */

Bool somgk(
	Int16 fc)
{
 Int16 j,k;

 for (j=0; j<aant_dgc[fc]; j++) {	/* Primaire conflicten */
   k = gcf[fc][j];
   if (G(k)) return TRUE;
 }
 return FALSE;
}

/* FUNCTIES BEPAAL MEEVERLENGGROEN TOEGESTAAN */
/* ========================================== */

/* Hulpfunctie meeverlenggroen in geval van 1 kruispunt */
/* ---------------------------------------------------- */

Bool hf_mvg()
{
 Int16 i;

 for (i=0; i<NUMSG_CS; i++) {
   if (R(i) && VA[i] || HG[i] || G(i) && !WG(i) && (!MVG(i) || RW[i])
#ifdef RWSC_old
           || MVG(i) && (H1e_TIJD(i)  || H2e_TIJD(i) )) return TRUE;
#else
	   || MVG(i) && (H1e_loopt(i) || H2e_loopt(i))) return TRUE;
#endif
 }
 return FALSE;
}

/* Hulpfunctie meeverlenggroen in geval van meerdere kruispunten */
/* ------------------------------------------------------------- */

Bool hf_mvg_krp(
	Int16 fc1,	/* Signaalgroep 1 van kruispunt x */
	Int16 fcn)	/* Signaalgroep n van kruispunt x */
{
 Int16 i;

 for (i=fc1; i<=fcn; i++) {
  if (i<NUMSG_CS) {	/* Beveiliging tegen array-overschrijding */
   if (R(i) && VA[i] || HG[i] || G(i) && !WG(i) && (!MVG(i) || RW[i])
#ifdef RWSC_old
		     || MVG(i) && (H1e_TIJD(i)  || H2e_TIJD(i) )) return TRUE;
#else
		     || MVG(i) && (H1e_loopt(i) || H2e_loopt(i))) return TRUE;
#endif
  }
 }
 return FALSE;
}

/* Hulpfunctie mvg voor voedende signaalgroepen binnen een koppeling */
/* ----------------------------------------------------------------- */

Bool hfkp_mvg()
{
 Int16 i;

 for (i=0; i<NUMSG_CS; i++) {
   if (R(i) && VA[i] || HG[i] || G(i) && !WG(i) && (!MVG(i) || RW[i]) && !(YM[i]&BIT2)
#ifdef RWSC_old
		     || MVG(i) && (H1e_TIJD(i)  || H2e_TIJD(i) )) return TRUE;
#else
		     || MVG(i) && (H1e_loopt(i) || H2e_loopt(i))) return TRUE;
#endif
 }
 return FALSE;
}

/* FUNCTIE VERSNELD DOORLOPEN STAPPENRASTER BIJ LOKAAL BEDRIJF */
/* =========================================================== */

Bool snel_lokaal()
{
 Int16 i,j,k;
 Int16 prog_keuze = (Int16)inst_EPARM(PROGKEUZE_CS);
 Bool  wens = FALSE;
 Bool  doorschakel = TRUE;
 Int16 tijd_tot_groen = 0;

 if ((prog_keuze == 11) && (!FIX || !HFIX) &&
					!SPR && !SVAS && !OMSCH && AKTPRG) { 
   for (i=0; i<NUMSG_CS; i++) {
     if (R(i) && VA[i]) wens = TRUE;
#ifdef RWSC_old
     if (G(i) && (!MVG(i) || H1e_TIJD(i)  || H2e_TIJD(i) ) && (TTP[i] > 0)) wens = TRUE;
     if (G(i) && (TTP[i] ==0) && (VG1[i]  || H2e_TIJD(i)  || VAG_OP(i) || RVAG_OP(i) || !(VA[i]&BIT5))) doorschakel = FALSE;
#else
     if (G(i) && (!MVG(i) || H1e_loopt(i) || H2e_loopt(i)) && (TTP[i] > 0)) wens = TRUE;
     if (G(i) && (TTP[i] ==0) && (VG1[i]  || H2e_loopt(i) || VVAG2e_OP(i) || CRSV_TO_CR[i][VVAG2e_CRSV] 
                                                          || RVAG2e_OP(i) || CRSV_TO_CR[i][RVAG2e_CRSV] || !(VA[i]&BIT5))) doorschakel = FALSE;
#endif 
     if (G(i) && (TTPR[i]==0)) doorschakel = FALSE;
     if (G(i) && begin_G(i))   doorschakel = FALSE;

     if (!G(i) && (GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5) || FCA[i])) {
	if (TTR[i]>=TTP[i]) doorschakel = FALSE;
     }
     if (!G(i) && (GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5) || FCA[i] || (TTPR[i]<255))) {
	if (TTR[i]>=TTPR[i]) doorschakel = FALSE;
     }
   }
   if (wens && doorschakel) {
     for (i=0; i<NUMSG_CS; i++) {
       if (G(i)) {
         for (j=0; j<aant_dgc[i]; j++) {	/* Primaire conflicten */
           k = gcf[i][j];
           if (HG[k] || _HG[k] || G(k)) doorschakel = FALSE;
           tijd_tot_groen = (Int16)(TEG[i] + inst_GL_TIJD(i)/10 + inst_O_TIJD(i,k)/10);
           if (( TTP[k]<=tijd_tot_groen) && (GL(k) || GR_TIJD(k) || VA[k] || (HVAS[k]&BIT5) || FCA[k])) doorschakel = FALSE;
           if ((TTPR[k]<=tijd_tot_groen) && (GL(k) || GR_TIJD(k) || VA[k] || (HVAS[k]&BIT5) || FCA[k] || (TTPR[k]<255))) doorschakel = FALSE;
         }
         for (j=0; j<aant_dfc[i]; j++) {	/* Fictieve conflicten */
           k = fcf[i][j];
           if (HG[k] || _HG[k] || G(k)) doorschakel = FALSE;
         }
       }
     }
   }
 }
 if (wens && doorschakel) return TRUE;
 return FALSE;
}

/* PROCEDURE BEPAAL CONFLICT_MATRIX T.B.V. CRSV-MODULE */
/* =================================================== */

void proc_init_conflict()
{
 Int16 i;
 Int16 _van_sg;
 Int16 _naar_sg;

 for (i=0; i<NUMSG_CS; i++) {
   aant_gcf[i] = 0;
   aant_fcf[i] = 0;
 }

 for (i=0; CONFLICT_tabel[i].van_sg != STOP; i++) {

   _van_sg  = CONFLICT_tabel[i].van_sg;
   _naar_sg = CONFLICT_tabel[i].naar_sg;

   gcf[_van_sg][aant_gcf[_van_sg]] = _naar_sg;
   aant_gcf[_van_sg]++;
 }

 for (i=0; i<NUMSG_CS; i++) {
   aant_dgc[i] = aant_gcf[i];
   aant_dfc[i] = aant_fcf[i];
 }
}

/* PROCEDURE BEPAAL FICTIEVE CONFLICTEN */
/* ==================================== */

void proc_fict_conflict(
	Int16 fc1,
	Int16 fc2)
{
 Int16 i;
 Int16 _van_sg;
 Int16 _naar_sg;

 for (i=0; CONFLICT_tabel[i].van_sg != STOP; i++) {

   _van_sg  = CONFLICT_tabel[i].van_sg;
   _naar_sg = CONFLICT_tabel[i].naar_sg;
   
   if (_van_sg == fc1) {

     fcf[fc2][aant_dfc[fc2]] = _naar_sg;
     fcf[_naar_sg][aant_dfc[_naar_sg]] = fc2;
     aant_fcf[fc2]++;
     aant_dfc[fc2]++;
     aant_fcf[_naar_sg]++;
     aant_dfc[_naar_sg]++;
   }
   if (_van_sg == fc2) {

     fcf[fc1][aant_dfc[fc1]] = _naar_sg;
     fcf[_naar_sg][aant_dfc[_naar_sg]] = fc1;
     aant_fcf[fc1]++;
     aant_dfc[fc1]++;
     aant_fcf[_naar_sg]++;
     aant_dfc[_naar_sg]++;
   }
 }
}

/* PROCEDURE BEPAAL DOORGESCHREVEN CONFLICTEN */
/* ========================================== */

void proc_door_conflict(
	Int16 fc1,	/* voedende richting  */
	Int16 fc2)	/* volgrichting       */
{
 Int16 i,j;
 Int16 _van_sg;
 Int16 _naar_sg;
 Bool aanwezig;

 for (i=0; CONFLICT_tabel[i].van_sg != STOP; i++) {

   _van_sg  = CONFLICT_tabel[i].van_sg;
   _naar_sg = CONFLICT_tabel[i].naar_sg;
   
   if (_van_sg == fc1) {

     aanwezig = FALSE;
     for (j=0; j<aant_dfc[fc2]; j++) {
	if (fcf[fc2][j] == _naar_sg) aanwezig = TRUE;
     }
     if (!aanwezig){
	fcf[fc2][aant_dfc[fc2]] = _naar_sg;
	aant_dfc[fc2]++;
     }
     aanwezig = FALSE;
     for (j=0; j<aant_dfc[_naar_sg]; j++) {
	if (fcf[_naar_sg][j] == fc2) aanwezig = TRUE;
     }
     if (!aanwezig){
	fcf[_naar_sg][aant_dfc[_naar_sg]] = fc2;
	aant_dfc[_naar_sg]++;
     }
   }

   if (_van_sg == fc2) {

     aanwezig = FALSE;
     for (j=0; j<aant_dgc[fc1]; j++) {
	if (gcf[fc1][j] == _naar_sg) aanwezig = TRUE;
     }
     if (!aanwezig){
	gcf[fc1][aant_dgc[fc1]] = _naar_sg;
	aant_dgc[fc1]++;
     }
     aanwezig = FALSE;
     for (j=0; j<aant_dgc[_naar_sg]; j++) {
	if (gcf[_naar_sg][j] == fc1) aanwezig = TRUE;
     }
     if (!aanwezig){
	gcf[_naar_sg][aant_dgc[_naar_sg]] = fc1;
	aant_dgc[_naar_sg]++;
     }
   }
 }
}

/* PROCEDURE INITIALISEER REGELING */
/* =============================== */

void proc_init_crsv(
	Int16 fx,
	Int16 progkeuze,	/* Fixatie toegestaan */
	Int16 CRSVversie)	/* CRSV versie */
{
 Int16 i,j;

 if (fx < 0) HFIX = FALSE;
 else	     HFIX = TRUE;

 if (CRSVversie >= 0)
 {
   wijzig_EGGPARM(CRSVversie, CRSV_versie);
 }

 NUMSG_CS = DIMENSIE_tabel[0].num_sg;
 PROGKEUZE_CS = progkeuze;

 TE = 0;
 CIF_TE_SECONDE = (Int16)CIF_KLOK[CIF_TSEC_TELLER];
 BUF_TE_SECONDE = CIF_TE_SECONDE;

 SPR   = TRUE;
 SVAS  = AKTPRG = STAP = TS = FALSE;
 LKODE = HKODE  = FALSE;

 for (i=0; i<NUMSG_CS; i++) {
   KG[i] = KNP[i] = KRA[i] = FCA[i] = TTR[i] = TTR_WV[i] = TTR_HK[i] = TTR_HK_oud[i] = FALSE;
   TTW[i] = TTPG[i] = HG[i] = YM[i] = HKV[i] = FALSE;
   _HG[i]= _TTR_HK[i] = FALSE;
   TTPR[i] = VTTP[i] = TPVU[i] = 255;
   SDSN[i] = 255;
   EDSN[i] = 0;
   PRGR[i] = 0;
   DSSP[i] = DSEP[i] = 0;

   /* Initialiseer signaalgroep-koppelingen */

   aant_fts = aant_bbv = aant_gov = aant_hki = FALSE;

   fts[i][0] =fts[i][1] =fts[i][2] =fts[i][3] =fts[i][4] =FALSE;
   bbv[i][0] =bbv[i][1] =bbv[i][2] =bbv[i][3] =bbv[i][4] =bbv[i][5] =FALSE;
   bbv[i][6] =bbv[i][7] =bbv[i][8] =FALSE;
   gov[i][0] =gov[i][1] =gov[i][2] =gov[i][3] =gov[i][4] =gov[i][5] =FALSE;
   gov[i][6] =gov[i][7] =gov[i][8] =gov[i][9] =gov[i][10]=gov[i][11]=FALSE;
   gov[i][12]=gov[i][13]=gov[i][14]=gov[i][15]=gov[i][16]=gov[i][17]=FALSE;
   gov[i][18]=gov[i][19]=gov[i][20]=gov[i][21]=FALSE;
   gov[i][22]=gov[i][23]=gov[i][24]=gov[i][25]=gov[i][26]=gov[i][27]=gov[i][28]=FALSE;

   for (j=0; j<21; j++) {
	hki[i][j] =FALSE;
   }
   for (j=0; j<NUMSG_CS; j++) {
	RW_hki[j][i]  = FALSE;
	BW_hki[j][i]  = FALSE;
	HG_hki[j][i]  = FALSE;
	FCA_hki[j][i] = FALSE;
	KNP_hki[j][i] = FALSE;
	PVAS_hki[j][i]= FALSE;
   }
   for (j=0; j<8; j++) {	
	CRSV_TO_CR[i][j] = 0;
   }

   /* Default OV-prioriteit NIET aanwezig */
   ovp[i][0] =ovp[i][1] =ovp[i][2] =ovp[i][3] =ovp[i][4] =ovp[i][5] =NIET;
   ovp[i][6] =ovp[i][7] =ovp[i][8] =ovp[i][9] =ovp[i][10]=ovp[i][11]=NIET;
   ovp[i][12]=ovp[i][13]=ovp[i][14]=ovp[i][15]=ovp[i][16]=ovp[i][17]=ovp[i][18]=NIET;

   SVS2[i] = VS2M[i] = TEG_OV[i] = CTTP[i] = FALSE;
   PVAS[i] = PVS2[i] = 0;

   TTK_hki[i] = TEG_hki[i] = TSPR[i] = TEPR[i] = 0;
   BHK[i]  = FALSE;

   WTV_SG[i]  = FALSE;
   CON_BUS[i] = ABUS[i] = FALSE;
   ALED[i] = HALT[i] = 0;
   Adwt[i] = Tdwt[i] = 0;
 }
 /* for (i=0; i<NUMD_CS; i++) { */
 /*   DRK[i] = FALSE;           */
 /* }                           */
 proc_init_conflict();
}

/* PROCEDURE BEPAAL VTG.FTS.KOPPELING */
/* ================================== */

void proc_def_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 (voetganger)*/
	Int16 fc2,	/* Signaalgroep 2 (fietser 2) */
	Int16 fc3,	/* Signaalgroep 3 (fietser 1) */
	Int16 mre23,	/* Meerea. fietser 2 met 3    */
	Int16 mre32)	/* Meerea. fietser 3 met 2    */
{
 if (aant_fts < NUMSG_CS) {
	fts[aant_fts][0] = fc1;
	fts[aant_fts][1] = fc2;
	fts[aant_fts][2] = fc3;
	fts[aant_fts][3] = mre23;
	fts[aant_fts][4] = mre32;
	aant_fts++;
 }
}

/* PROCEDURE BEPAAL VTG.KOPPELING [ PROGRESSIEF ] */
/* ============================================== */

void proc_def_vtg_bb(
	Int16 fc1,	/* Signaalgroep 1               */
	Int16 fc2,	/* Signaalgroep 2               */
	Int16 kpt12,	/* KoppelTIJD eg1 -> eg2        */
	Int16 gkg,	/* Geen KoppelGarantie bij alt  */
	Int16 fc3,	/* Gekoppelde fietsrichting 3   */
	Int16 fc4,	/* Gekoppelde fietsrichting 4   */
	Int16 mre34,	/* Meerea. fietser 3 met 4      */
	Int16 mre43,	/* Meerea. fietser 4 met 3      */
	Int16 gkg_pri)	/* Geen KoppelGarantie bij prio */
{
 if (aant_bbv < NUMSG_CS) {
	bbv[aant_bbv][0] = fc1;
	bbv[aant_bbv][1] = fc2;
	bbv[aant_bbv][2] = kpt12;
	bbv[aant_bbv][3] = gkg;
	bbv[aant_bbv][4] = fc3;
	bbv[aant_bbv][5] = fc4;
	bbv[aant_bbv][6] = mre34;
	bbv[aant_bbv][7] = mre43;
	bbv[aant_bbv][8] = gkg_pri;
	aant_bbv++;
 }
}

/* PROCEDURE BEPAAL VTG.KOPPELING [ GESCHEIDEN ] */
/* ============================================= */

void proc_def_vtg_go(
	Int16 fc1,	/* Signaalgroep 1	        */
	Int16 fc2,	/* Signaalgroep 2	        */
	Int16 kpa12,	/* Kop.aanvr. sg1 -> sg2        */
	Int16 kpa21,	/* Kop.aanvr. sg2 -> sg1        */
	Int16 kpt12,	/* KoppelTIJD sg1 -> eg2        */
	Int16 kpt21,	/* KoppelTIJD sg2 -> eg1        */
	Int16 gkg,	/* Geen KoppelGarantie bij alt  */
	Int16 fc3,	/* Gekoppelde fietsrichting 3   */
	Int16 fc3v,	/* Volgrichting van fietser 3   */
	Int16 mr33v,	/* Naloop nooit zonder voeding  */
	Int16 kpt3s,	/* Koppeltijd vanaf start fc3   */
	Int16 kpt3e,	/* Koppeltijd vanaf einde fc3   */
	Int16 hfk3e,	/* (HF)start naloop einde fc3   */
	Int16 fc4,	/* Gekoppelde fietsrichting 4   */
	Int16 fc4v,	/* Volgrichting van fietser 4   */
	Int16 mr44v,	/* Naloop nooit zonder voeding  */
	Int16 kpt4s,	/* Koppeltijd vanaf start fc4   */
	Int16 kpt4e,	/* Koppeltijd vanaf einde fc4   */
	Int16 hfk4e,	/* (HF)start naloop einde fc4   */
	Int16 mre34,	/* Meerea. fietser 3 met 4      */
	Int16 mre43,	/* Meerea. fietser 4 met 3      */
	Int16 gkg_pri, 	/* Geen KoppelGarantie bij prio */

                        /* 3e vtg is de middelste vtg!  */
	Int16 vtg3,     /* Signaalgroep 3e voetganger   */
	Int16 kpa31,    /* Kop.aanvr. sg3 -> sg1        */
	Int16 kpa32,    /* Kop.aanvr. sg3 -> sg2        */
	Int16 kpt13,    /* KoppelTIJD sg1 -> eg3        */
	Int16 kpt23,    /* KoppelTIJD sg2 -> eg3        */
	Int16 kpt31,    /* KoppelTIJD sg3 -> eg1        */
	Int16 kpt32)    /* KoppelTIJD sg3 -> eg2        */
{
 if (aant_gov < NUMSG_CS) {
	gov[aant_gov][0] = fc1;
	gov[aant_gov][1] = fc2;
	gov[aant_gov][2] = kpa12; if (kpa12 >= 0) DRK[kpa12] = FALSE;
	gov[aant_gov][3] = kpa21; if (kpa21 >= 0) DRK[kpa21] = FALSE;
	gov[aant_gov][4] = kpt12;
	gov[aant_gov][5] = kpt21;
	gov[aant_gov][6] = gkg;
	gov[aant_gov][7] = fc3;
	gov[aant_gov][8] = fc3v;
	gov[aant_gov][9] = mr33v;
	gov[aant_gov][10]= kpt3s;
	gov[aant_gov][11]= kpt3e;
	gov[aant_gov][12]= hfk3e;
	gov[aant_gov][13]= fc4;
	gov[aant_gov][14]= fc4v;
	gov[aant_gov][15]= mr44v;
	gov[aant_gov][16]= kpt4s;
	gov[aant_gov][17]= kpt4e;
	gov[aant_gov][18]= hfk4e;
	gov[aant_gov][19]= mre34;
	gov[aant_gov][20]= mre43;
	gov[aant_gov][21]= gkg_pri;

	gov[aant_gov][22]= vtg3;
	gov[aant_gov][23]= kpa31; if (kpa31 >= 0) DRK[kpa31] = FALSE;
	gov[aant_gov][24]= kpa32; if (kpa32 >= 0) DRK[kpa32] = FALSE;
	gov[aant_gov][25]= kpt13;
	gov[aant_gov][26]= kpt23;
	gov[aant_gov][27]= kpt31;
	gov[aant_gov][28]= kpt32;

	aant_gov++;

        /* Bepaal fictieve en            */
        /* ... doorgeschreven conflicten */
        if ((fc1 >= 0) && (fc2  >= 0)) proc_fict_conflict(fc1,fc2 );	
        if ((fc1 >= 0) && (fc3  >= 0)) proc_fict_conflict(fc1,fc3 );	
        if ((fc2 >= 0) && (fc3  >= 0)) proc_fict_conflict(fc2,fc3 );	

	if ((fc3 >= 0) && (fc3v >= 0)) proc_door_conflict(fc3,fc3v);
	if ((fc4 >= 0) && (fc4v >= 0)) proc_door_conflict(fc4,fc4v);
 }
}

/* PROCEDURE BEPAAL SERIELE KOPPELING */
/* ================================== */

void proc_def_hki(
	Int16 fc1,	/* Signaalgroep 1 [voedend] */
	Int16 fc2,	/* Signaalgroep 2 [volg sg1]*/
	Int16 kptvs12,	/* Max.voorst.sg1 -> sg2    */
	Int16 kptsg12,	/* KoppelTIJD sg1 -> eg2    */
	Int16 kpteg12,	/* KoppelTIJD eg1 -> eg2    */
	Int16 kptdm12,	/* KoppelTIJD dm2 na hki    */
	Int16 de11,	/* Det.1 sg1 tbv start.teg  */
	Int16 de12,	/* Det.2 sg2 tbv start.teg  */
	Int16 de13,	/* Det.3 sg3 tbv start.teg  */
	Int16 fc3,	/* Signaalgroep 3 [volg sg2]*/
	Int16 kptvs23,	/* Max.voorst.sg2 -> sg3    */
	Int16 kptsg23,	/* KoppelTIJD sg2 -> eg3    */
	Int16 kpteg23,	/* KoppelTIJD eg2 -> eg3    */
	Int16 kptdm23,	/* KoppelTIJD dm3 na hki    */
	Int16 de21,	/* Det.1 sg2 tbv start.teg  */
	Int16 de22,	/* Det.2 sg2 tbv start.teg  */
	Int16 de23,	/* Det.3 sg2 tbv start.teg  */
	Int16 hf_hki)	/* Hulpfunctie hki aktief   */
{
 if (aant_hki < NUMSG_CS) {
	hki[aant_hki][0] = fc1;
	hki[aant_hki][1] = fc2;
	hki[aant_hki][2] = kptvs12;
	hki[aant_hki][3] = kptsg12;
	hki[aant_hki][4] = kpteg12;
	hki[aant_hki][5] = kptdm12;
	hki[aant_hki][6] = de11;
	hki[aant_hki][7] = de12;
	hki[aant_hki][8] = de13;
	hki[aant_hki][9] = 0;		/* buffer tijd groen sg1 en niet groen sg2 */

	hki[aant_hki][10]= fc3;
	hki[aant_hki][11]= kptvs23;
	hki[aant_hki][12]= kptsg23;
	hki[aant_hki][13]= kpteg23;
	hki[aant_hki][14]= kptdm23;
	hki[aant_hki][15]= de21;
	hki[aant_hki][16]= de22;
	hki[aant_hki][17]= de23;
	hki[aant_hki][18]= 0;		/* buffer tijd groen sg2 en niet groen sg3 */

	hki[aant_hki][19]= hf_hki;

	/* status hki -> 0 = uit; 1= insch; 2= aan; 3= uitsch; */

	if HF(hf_hki) hki[aant_hki][20]= 2;
	else          hki[aant_hki][20]= 0;

	aant_hki++;
 }
}

/* PROCEDURE DEFINITIE OV-PRIORITEIT */
/* ================================= */

void proc_def_ov(               /* Definitie OV-prioriteit           */
	Int16 fc,               /* Signaalgroep                      */
	Int16 deftts,           /* Default tijd      tot  stopstreep */
	Int16 defvgr,           /* Default groentijd voor stopstreep */
	Int16 uitbew,           /* Uitmeldbewaking                   */
	Int16 maxveu)           /* Max.tijd voor einde uitstel       */
{
 if ((fc >= 0) && (fc < NUMSG_CS)) {
	ovp[fc][0] = deftts; /* Als geen definitie dan TTS verplicht */
	ovp[fc][1] = defvgr; /* Als geen definitie dan garantiegroen */
	ovp[fc][2] = uitbew; /* Verplicht anders definitie ongeldig! */
	ovp[fc][18]= maxveu; /* Als geen definitie dan gelijk aan 255*/
 }
}

/* PROCEDURE SECONDE BEHANDELING */
/* ============================= */

void proc_crsv_per_seconde()
{
 Int16 i;

 TS = TRUE;	/* Start seconde */

 /* Werk klokken bij */
 for (i=0; i<NUMSG_CS; i++) {
   if ( R(i) && (KRA[i]<255) && VA[i] && !Straag && (!FIX || !HFIX)) KRA[i]++;
   if ( G(i) ||  !VA[i] || BL_OP(i)) KRA[i] = FALSE;

   if ( G(i) && (KG[i]<255)) KG[i]++;
   if (!G(i))		     KG[i] = FALSE;
 }
}

/* PROCEDURE BEPAAL PROGRAMMA-KEUZE SLAAF */
/* ====================================== */

void proc_crsv_progkeuze_slaaf(
	const Int16 atp,	/* Aantal CRSV-programma's */
	Int16 dpr,		/* Default programma	   */
	Int16 t_o,		/* Tijdvertr. omschakelen  */
	Int16 ks1,		/* Koppelsignaal 1 "IN"    */
	Int16 ks2,		/* Koppelsignaal 2 "IN"	   */
	Int16 ks3,		/* Koppelsignaal 3 "IN"	   */
	Int16 ks4)		/* Koppelsignaal 4 "IN"	   */
{
 Int16 def_prg = (Int16)inst_EPARM(dpr)/10;
 Bool  start_t =  FALSE;

	/* CKODE -> kode vanaf complex-coordinator		    */
	/* HKODE -> buffer CKODE t.b.v. start-puls		    */
	/* LKODE -> kode in lokale automaat (volgt vertraagt CKODE) */

 CKODE = FALSE;
 if (HF(ks1)) CKODE++;
 if (HF(ks2)) CKODE+=2;
 if (HF(ks3)) CKODE+=4;
 if (HF(ks4)) CKODE+=8;

 if  (HKODE != CKODE) { HKODE   = CKODE;
		        herstart_TIJD(t_o);
			start_t = TRUE;
		      }
 if ((LKODE != CKODE) && !TIJD(t_o) && !start_t || SPR) LKODE = CKODE;

 GEWPRG = LKODE;
 if ( GEWPRG > atp)		  GEWPRG = FALSE;
 if (!GEWPRG && (def_prg <= atp)) GEWPRG = def_prg;

 OMSCH = (AKTPRG != GEWPRG) && (!FIX || !HFIX);

 if (((STAP == OPNT) || !OPNT) && OMSCH || SPR) {
	AKTPRG = GEWPRG;
	SVAS   = TRUE;
 }

 CTYD = IPNT = OPNT = CPNT = FALSE;
}

/* PROCEDURE BEPAAL PROGRAMMA-KEUZE MASTER */
/* ======================================= */

void proc_crsv_progkeuze_master(
	const Int16 atp,	/* Aantal CRSV-programma's */
	Int16 dpr,		/* Default programma	   */
	Int16 t_o,		/* Tijdvertr. omschakelen  */
	Int16 ks1,		/* Koppelsignaal 1 "UIT"   */
	Int16 ks2,		/* Koppelsignaal 2 "UIT"   */
	Int16 ks3,		/* Koppelsignaal 3 "UIT"   */
	Int16 ks4,		/* Koppelsignaal 4 "UIT"   */
	Int16 Vas)		/* Gewenst stappenraster   */
{
 Int16 def_prg = (Int16)inst_EPARM(dpr)/10;
 Bool  start_t = FALSE;

	/* CKODE -> kode vanaf complex-coordinator		    */
	/* HKODE -> buffer CKODE t.b.v. start-puls		    */
	/* LKODE -> kode in lokale automaat (volgt vertraagt CKODE) */

 CKODE = FALSE;
 MKODE = TL(Vas);
 if ( MKODE <= atp)		 CKODE = MKODE;
 if (!CKODE && (def_prg <= atp)) CKODE = def_prg;

 if ((CKODE == 1) || (CKODE == 3) || (CKODE == 5) || (CKODE == 7) ||
     (CKODE == 9) || (CKODE ==11) || (CKODE ==13) || (CKODE ==15)) {
	    set_HF(ks1);
 } else { reset_HF(ks1); }

 if ((CKODE == 2) || (CKODE == 3) || (CKODE == 6) || (CKODE == 7) ||
     (CKODE ==10) || (CKODE ==11) || (CKODE ==14) || (CKODE ==15)) {
	    set_HF(ks2);
 } else { reset_HF(ks2); }

 if ((CKODE == 4) || (CKODE == 5) || (CKODE == 6) || (CKODE == 7) ||
     (CKODE ==12) || (CKODE ==13) || (CKODE ==14) || (CKODE ==15)) {
	    set_HF(ks3);
 } else { reset_HF(ks3); }

 if ((CKODE == 8) || (CKODE == 9) || (CKODE ==10) || (CKODE ==11) ||
     (CKODE ==12) || (CKODE ==13) || (CKODE ==14) || (CKODE ==15)) {
	    set_HF(ks4);
 } else { reset_HF(ks4); }

 if  (HKODE != CKODE) { HKODE   = CKODE;
		        herstart_TIJD(t_o);
			start_t = TRUE;
		      }
 if ((LKODE != CKODE) && !TIJD(t_o) && !start_t || SPR) LKODE = CKODE;

 GEWPRG = LKODE;
 if ( GEWPRG > atp)		  GEWPRG = FALSE;
 if (!GEWPRG && (def_prg <= atp)) GEWPRG = def_prg;

 OMSCH = (AKTPRG != GEWPRG) && (!FIX || !HFIX);

 if (((STAP == OPNT) || !OPNT) && OMSCH || SPR) {
	AKTPRG = GEWPRG;
	SVAS   = TRUE;
 }

 CTYD = IPNT = OPNT = CPNT = FALSE;
}

/* PROCEDURE BEPAAL AKTIEF STAPPENRASTER */
/* ===================================== */

void proc_crsv_parm(
	Int16 ctyd,	/* Cyclustijd	      */
	Int16 insc,	/* Inschakelpunt      */
	Int16 omsc,	/* Omschakelpunt      */
	Int16 sync)	/* Synchronisatiepunt */
{
 CTYD = (Int16)inst_EPARM(ctyd)/10;
 IPNT = (Int16)inst_EPARM(insc)/10;
 OPNT = (Int16)inst_EPARM(omsc)/10;
 CPNT = (Int16)inst_EPARM(sync)/10;

 if ((IPNT>CTYD) || !IPNT) IPNT = 1;
 if ( OPNT>CTYD)	   OPNT = FALSE;
 if ((CPNT>CTYD) || !CPNT) CPNT = 1;
}

/* PROCEDURE BEPAAL STATUS STAPPENRASTER SLAAF */
/* =========================================== */

void proc_crsv_stappenraster(
	Int16 sync)	/* Koppelsignaal 5 "IN" */

{
 Int16 prog_keuze = (Int16)inst_EPARM(PROGKEUZE_CS);

 if (!(begin_HF(sync)) || SPR) SSYNC = FALSE;

 if (begin_HF(sync)&& !SVAS && AKTPRG && !OMSCH && (prog_keuze != 11)
		   && !SSYNC)			 {   /* Start synchronisatie */

   Straag = Svsnel = Sstart = Sverschil = Sversnel = Sblok = Sdubb = FALSE;
   SSYNC  = TRUE;

   /* Bepaal "vooruitlopen" t.o.v. het stappenraster */ 
   /* ---------------------------------------------- */

   if (STAP>=CPNT) { Sverschil = STAP - CPNT; }
   else		   { Sverschil = CTYD + STAP - CPNT; }

   /* Als "vooruitlopen" <= 50% v/d CTYD dan vertragen stappenraster */
   /* -------------------------------------------------------------- */

   if ((CTYD/2)>=Sverschil) { Straag = TRUE; Sblok = FALSE; }
   else {

     /* Bepaal "achterlopen" t.o.v. het stappenraster */
     /* --------------------------------------------- */

     Sverschil = CTYD - Sverschil;

     /* Als "achterlopen" <= 10% v/d CTYD dan versnellen stappenraster */
     /* -------------------------------------------------------------- */

     if ((CTYD/10)>=Sverschil) { Svsnel = TRUE; Sversnel = 10; }
     else {

       /* Herstart stappenraster indien vertragen EN versnellen ongewenst */
       /* --------------------------------------------------------------- */

       Sstart    = TRUE;
       Sverschil = FALSE;
     }
   }
 }

 if (TS && Straag) {	/* Vertraag stappenraster */

   if (Sverschil > 0) {
     Sblok = !Sblok;
     if (Sblok) Sverschil--;
   } else { Sverschil = Straag = Sblok = FALSE; }
 }

 if (TS && Svsnel) {	/* Versnel stappenraster */

   if (Sverschil > 0) {
     Sversnel++;
     if (Sversnel >= 10) {
       Sverschil--;
       Sdubb    = TRUE;
       Sversnel = 1;
     }
   } else { Sverschil = Svsnel = Sdubb = Sversnel = FALSE; }
 }

 if (SVAS || OMSCH) {	/* ALTIJD reset synchronisatie bij start VAS */
   if (SVAS) STAP  = IPNT;
   Straag = Svsnel = Sstart = Sverschil = Sversnel = Sblok = Sdubb = FALSE;
 }

 if (!FIX || !HFIX) {
   if ( TS && !SVAS && (!Sblok || !Straag))  STAP++;
   if (!TS &&	         Sdubb &&  Svsnel) { STAP++;
				 	     Sdubb = FALSE;
				 	     N_ts  = TRUE;
   } else { N_ts = FALSE; }
 } else {		/* ALTIJD reset synchronisatie bij FIXATIE */
     Straag = Svsnel = Sstart = Sverschil = Sversnel = Sblok = Sdubb = FALSE;
     N_ts   = FALSE;
 }

 if (!TS && !N_ts && snel_lokaal()) {
   STAP++;
   N_ts = TRUE;
 }

 if (STAP>CTYD) STAP = 1;

 if (!AKTPRG) {		/* ALTIJD reset synchronisatie bij einde VAS */
   STAP   = FALSE;
   Straag = Svsnel = Sstart = Sverschil = Sversnel = Sblok = Sdubb = FALSE;
 }

 if (prog_keuze == 11) {/* ALTIJD reset synch bij "snel"LOKAAL programma */
   Straag = Svsnel = Sstart = Sverschil = Sversnel = Sblok = Sdubb = FALSE;
 }

 if (Sstart) {
   STAP   = CPNT;
   Sstart = FALSE;
   SVAS   = TRUE;
 }
 proc_reset_crsv_start();
}

/* PROCEDURE BEPAAL STATUS STAPPENRASTER MASTER */
/* ============================================ */

void proc_crsv_master_raster(
	Int16 ks5,		/* Koppelsignaal 5 "UIT"       */
	Int16 t_s)		/* Duur synchronisatie-signaal */
{
 Int16 prog_keuze = (Int16)inst_EPARM(PROGKEUZE_CS);
 Bool  start_t = FALSE;

 if (SVAS)	  		     STAP = IPNT;
 if (TS && !SVAS && (!FIX || !HFIX)) STAP++;

 N_ts = FALSE;
 if (!TS && snel_lokaal()) {
   STAP++;
   N_ts = TRUE;
 }
 if (STAP>CTYD) STAP = 1; /* @#@ Fik150201 */

 if (!AKTPRG) {
   STAP = FALSE;
 } else {
   if (TS && (STAP == CPNT) && !OMSCH && (!FIX || !HFIX)
						&& (prog_keuze != 11)) {
	herstart_TIJD(t_s);
	start_t = TRUE;
   }
 }
 if (TIJD(t_s) || start_t) set_HF(ks5);
 else			 reset_HF(ks5);

 proc_reset_crsv_start();
}

/* PROCEDURE RESET VARIABELEN BIJ START SIGNAALGROEPSTURING */
/* ======================================================== */

void proc_reset_crsv_start()
{
 Int16 i,j,x;
 Int16 fc1,fc2,fc3,hulp_functie,stat;
 Bool  YM2,PVAS1,PVS22;
 Bool  kop_gewenst = FALSE;
 Bool  inschakel = FALSE;
 Bool  uitschakel = FALSE;

 CIF_TE_SECONDE = (Int16)CIF_KLOK[CIF_TSEC_TELLER];

 TE = 0;

 if (CIF_TE_SECONDE > BUF_TE_SECONDE) {
	TE = CIF_TE_SECONDE - BUF_TE_SECONDE;
 }

 if (CIF_TE_SECONDE < BUF_TE_SECONDE) {
	TE = (32767 - BUF_TE_SECONDE) + CIF_TE_SECONDE + 1;
 }

 BUF_TE_SECONDE = CIF_TE_SECONDE;

 for (i=0; i<NUMSG_CS; i++) {
	BHK[i] = HKV[i] = FALSE;
 }

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {

	fc1          = hki[i][0];
	fc2          = hki[i][1];
	fc3          = hki[i][10];
	hulp_functie = hki[i][19];
	stat         = hki[i][20];

						/* fc2 wordt vastgehouden door koppeling vanaf fc1 */
	if (begin_G(fc2) && (RW_hki[i][fc2]&BIT3)) BW_hki[i][fc2] = TRUE;

	/* status hki -> 0 = uit; 1= insch; 2= aan; 3= uitsch; */
	kop_gewenst = FALSE;
	if (HF(hulp_functie)) kop_gewenst = TRUE;

	if ( kop_gewenst && (stat == 0)) stat = 1;
	if ( kop_gewenst && (stat == 3)) stat = 2;

	if (!kop_gewenst && (stat == 1)) stat = 0;
	if (!kop_gewenst && (stat == 2)) stat = 3;

	if (stat == 1) {			/* zoek gunstig inschakelmoment */
		inschakel = TRUE;
		if (G(fc1)) {
			inschakel = FALSE;
			BHK[fc1] = TRUE;
		}
		if (fc3 >= 0) {
			if (G(fc2)) {
				inschakel = FALSE;
				BHK[fc2] = TRUE;
			}
		}
		if (inschakel) stat = 2;
	}

	if (stat == 3) {			/* zoek gunstig uitschakelmoment */
		uitschakel = TRUE;
		if (G(fc2) && (RW_hki[i][fc2]&BIT3)) {
			uitschakel = FALSE;
			BHK[fc1] = TRUE;
		}
		if (fc3 >= 0) {
			if (G(fc3) && (RW_hki[i][fc3]&BIT3)) uitschakel = FALSE;
			BHK[fc2] = TRUE;
		}
		if (uitschakel) stat = 0;
	}
	hki[i][20] = stat;

        if (stat == 2) { /* bepaal HKV[] Fik150222 */
          if (G(fc1)) {
            HKV[fc2] = TRUE;
            if (fc3 >= 0) {
              if (G(fc1) || G(fc2)) HKV[fc3] = TRUE;
            }
          }
        }

    }
 }

 for (i=0; i<NUMSG_CS; i++) {

   sgn_n = i;		/* Bepaal K[] */
   if (GL(i) || R(i))                 K[i] = TRUE;
   if (ov_d && ov_e && ov_av || G(i)) K[i] = FALSE;

   PVAS1 = (PVAS[i]&BIT1);
   PVS22 = (PVS2[i]&BIT2);
   if (!AKTPRG) {
	HVAS[i]  = PVAS[i] = PVS2[i] = FALSE;
   	for (j=0; j<NUMSG_CS; j++) {
		PVAS_hki[j][i] &=(~BIT1);
	}
   }
   if ( SVAS) { HVAS[i]	 = PVAS[i] = PVS2[i] = FALSE;
		  VA[i] &=(~BIT2);
		  VA[i] &=(~BIT4);
		 FCA[i] &=(~BIT3);

   		for (j=0; j<NUMSG_CS; j++) {
			FCA_hki[j][i] &=(~BIT3);
		}

		if (PVAS1) PVAS[i] |= BIT1;
		if (PVS22) PVS2[i] |= BIT2;
   }
   YM2 = (YM[i]&BIT2);

   B[i]=X[i]=RR[i]=RW[i]=YV[i]=YM[i]=Z[i]=FALSE;

   for (j=0; j<NUMSG_CS; j++) {
	RW_hki[j][i] &=(~BIT3);
   }

   PVAS[i] &= (~BIT4);			/* Reset uitstellen  toegestaan */
   PVAS[i] &= (~BIT5);			/* Reset afbreken    toegestaan */
   PVAS[i] &= (~BIT6);			/* Reset doorsnijden toegestaan */

   PVS2[i] &= (~BIT0);			/* Reset prioriteit OV voor einde uitstel toegestaan */
   PVS2[i] &= (~BIT1);			/* Reset prioriteit OV na afkappunt       toegestaan */

   if (RVG(i) && WTV_SG[i]) {
	HG[i] |= BIT7;
   } else {
	HG[i] &= (~BIT7);
   }

   if (G(i)) {
		   VA[i] |= BIT0;	/* Altijd aanvraag indien groen */
		 PVS2[i] &=(~BIT4);	/* Reset terugkomen na afkappen */
   }
		  BAR[i]  = FALSE;	/* Reset blokkeer alt.real.	*/
		  BLW[i]  = FALSE;	/* Reset blokkeer wachtstand    */
		   VA[i] &=(~BIT7);	/* Reset start det/ma.aanvraag	*/
		  FCA[i] &=(~BIT2);	/* Reset openhouden aanv.gebied */

   if (einde_G(i)) {
		  VA[i]  = FALSE;	/* Reset aanvraag		 */
		  HG[i] &= (~BIT4);	/* Reset prioriteit volgrichting */

   		  for (j=0; j<NUMSG_CS; j++) {
			HG_hki[j][i] &=(~BIT4);
		  }

		  if (PVS2[i]&BIT3) PVS2[i] |= BIT4;
   }

   if (G(i) && !MVG(i) && YM2)		/* Buffer aanhouden groen agv	*/
		   YM[i] |= BIT2;	/* ... koppeling		*/
   if (!G(i) && BL_OP(i))		/* Reset aanvraag		*/
		   VA[i]  = FALSE;	/* ... agv BL_optie		*/

   if (begin_R(i)) {	/* Verwijder bussen waaraan prioriteit is verleend */
	for (j=1; j<=3; j++) {
		if (ovp[i][(j*5)+1] >= 10) {
			ovp[i][(j*5)-2] = NIET;
			ovp[i][(j*5)-1] = NIET;
			ovp[i][(j*5)  ] = NIET;
			ovp[i][(j*5)+1] = NIET;
			ovp[i][(j*5)+2] = NIET;
		}
	}
	proc_sorteer_bus(i,1,2);
	proc_sorteer_bus(i,2,3);
	proc_sorteer_bus(i,1,2);
   }
   if (ovp[i][18] == -1) TPVU[i] = 255;
   else                  TPVU[i] = (Int16)inst_EPARM(ovp[i][18])/10;
 }
 _tts = _vtg = _vgr = _pri = NIET;	/* Hulpvlaggen tbv OV-melding   */
 init_kapm_crsv();
}


/* PROCEDURE BEPAAL INMELDING OPENBAAR VERVOER */
/* =========================================== */

void proc_ov_inm(
	Int16 _sg)	/* Signaalgroep */
{
 Int16 _htts,_hvtg,_hvgr,_hpri;
 Int16 _hbus;

 if ((_sg >= 0) && (_sg < NUMSG_CS)) {	/* Signaalgroep is correct */
   if (ovp[_sg][2] >= 0) {		/* Uitmeldbewaking is gedefinieerd */
     if ((_tts >= 0) && (_tts < 255) || (ovp[_sg][0] >= 0)) {

	_htts = _tts;			/* Bepaal tts */
	if (((_htts < 0) || (_htts == 255)) && (ovp[_sg][0] >= 0))
		_htts = (Int16)inst_EPARM(ovp[_sg][0])/10;

	_hvtg = _vtg;			/* Bepaal vtg-nummer */
	if (_hvtg < 0) _hvtg = 0;

	_hvgr = _vgr;			/* Bepaal groen voor passage */
	if ((_hvgr < 0) && (ovp[_sg][1] >= 0))
		_hvgr = (Int16)inst_EPARM(ovp[_sg][1])/10;
	if (_hvgr < 0) _hvgr = (Int16)inst_GG_TIJD(_sg)/10;

	_hpri = _pri;			/*    Bepaal prioriteit toegestaan     */
	if (_hpri < 0) _hpri = 0;	/* 0: Geen prioriteit toegestaan       */
	if (_hpri > 2) _hpri = 0;	/* 1: Alleen aanhouden eigen groenfase */
					/* 2: Prioriteitsrealisatie toegestaan */
	/* Is voertuig al aanwezig? */
	_hbus = 0;
	if (_hvtg > 0) {
	  if      (ovp[_sg][4] == _hvtg) _hbus = 1; /* Ja, dan update */
	  else if (ovp[_sg][9] == _hvtg) _hbus = 2;
	  else if (ovp[_sg][14]== _hvtg) _hbus = 3;
	  else if (ovp[_sg][4] ==  NIET) _hbus = 1; /* Nee, dan toevoegen */
	  else if (ovp[_sg][9] ==  NIET) _hbus = 2;
	  else if (ovp[_sg][14]==  NIET) _hbus = 3;
	} else {
	  if      (ovp[_sg][4] ==  NIET) _hbus = 1; /* Geen voertuignummer? */
	  else if (ovp[_sg][9] ==  NIET) _hbus = 2; /* dan alleen toevoegen */
	  else if (ovp[_sg][14]==  NIET) _hbus = 3;
	}

	if (_hbus > 0) {
		ovp[_sg][(_hbus*5)-2] = _htts;
		ovp[_sg][(_hbus*5)-1] = _hvtg;
		ovp[_sg][(_hbus*5)  ] = _hvgr;
		ovp[_sg][(_hbus*5)+1] = _hpri;
		ovp[_sg][(_hbus*5)+2] = 0;	/* Start aanwezigheidstijd */
	}

	/* Sorteer bussen op basis van tijd tot stopstreep */
	proc_sorteer_bus(_sg,1,2);
	proc_sorteer_bus(_sg,2,3);
	proc_sorteer_bus(_sg,1,2);
     }
   }
 }
}

/* PROCEDURE BEPAAL UITMELDING OPENBAAR VERVOER */
/* =========================================== */

void proc_ov_uit(
	Int16 _sg)	/* Signaalgroep */
{
 Int16 verwijder;

 if ((_sg >= 0) && (_sg < NUMSG_CS)) {	/* Signaalgroep is correct */
   if (ovp[_sg][2] >= 0) {		/* Uitmeldbewaking is gedefinieerd */
     if (_vtg > 0) {			/* Voertuignummer verwijderen */
	if (ovp[_sg][4] == _vtg) {
	  ovp[_sg][3] = ovp[_sg][4] = ovp[_sg][5] = NIET;
	  ovp[_sg][6] = ovp[_sg][7] = NIET;
	}
	if (ovp[_sg][9] == _vtg) {
	  ovp[_sg][8] = ovp[_sg][9] = ovp[_sg][10]= NIET;
	  ovp[_sg][11]= ovp[_sg][12]= NIET;
	}
	if (ovp[_sg][14]== _vtg) {
	  ovp[_sg][13]= ovp[_sg][14]= ovp[_sg][15]= NIET;
	  ovp[_sg][16]= ovp[_sg][17]= NIET;
	}
     }
     /* @#@ Wijziging MF150118 -> was (_vtg == 0) */
     if (_vtg <= 0) {			/* Verwijder oudste "0" voertuig   */
	verwijder = 0;			/* indien niet aanwezig dan oudste */
	 				/* voertuig met nummer verwijderen */
	if      (ovp[_sg][4] == 0) verwijder = 1;
	else if (ovp[_sg][9] == 0) verwijder = 2;
	else if (ovp[_sg][14]== 0) verwijder = 3;
	else if (ovp[_sg][4] >  0) verwijder = 1;
	else if (ovp[_sg][9] >  0) verwijder = 2;
	else if (ovp[_sg][14]>  0) verwijder = 3;

	if (verwijder > 0) {
	  ovp[_sg][(verwijder*5)-2] = NIET;
	  ovp[_sg][(verwijder*5)-1] = NIET;
	  ovp[_sg][(verwijder*5)  ] = NIET;
	  ovp[_sg][(verwijder*5)+1] = NIET;
	  ovp[_sg][(verwijder*5)+2] = NIET;
	}
     }

     /* Sorteer resterende bussen op basis van tijd tot stopstreep */
     proc_sorteer_bus(_sg,1,2);
     proc_sorteer_bus(_sg,2,3);
     proc_sorteer_bus(_sg,1,2);
   }
 }
}

/* PROCEDURE SORTEER BUSSEN OP AFSTAND TOT STOPSTREEP */
/* ================================================== */

void proc_sorteer_bus(
	Int16 fc,	/* Signaalgroep */
	Int16 nr1,	/* Volgnummer 1 */
	Int16 nr2)	/* Volgnummer 2 */
{
 Bool  wissel = FALSE;
 Int16 hbuf1,hbuf2,hbuf3,hbuf4,hbuf5;

 if (ovp[fc][(nr2*5)-1] >= 0) { 		/* 2e bus is aanwezig */
   if (ovp[fc][(nr1*5)-1] < 0) wissel = TRUE;	/* 1e bus niet => wisselen */
   else {
     if ((ovp[fc][(nr2*5)-2] - ovp[fc][(nr2*5)+2]) <
         (ovp[fc][(nr1*5)-2] - ovp[fc][(nr1*5)+2])) wissel = TRUE;
   }
   if (wissel) {
	hbuf1 = ovp[fc][(nr1*5)-2];
	hbuf2 = ovp[fc][(nr1*5)-1];
	hbuf3 = ovp[fc][(nr1*5)  ];
	hbuf4 = ovp[fc][(nr1*5)+1];
	hbuf5 = ovp[fc][(nr1*5)+2];

	ovp[fc][(nr1*5)-2] = ovp[fc][(nr2*5)-2];
	ovp[fc][(nr1*5)-1] = ovp[fc][(nr2*5)-1];
	ovp[fc][(nr1*5)  ] = ovp[fc][(nr2*5)  ];
	ovp[fc][(nr1*5)+1] = ovp[fc][(nr2*5)+1];
	ovp[fc][(nr1*5)+2] = ovp[fc][(nr2*5)+2];

	ovp[fc][(nr2*5)-2] = hbuf1;
	ovp[fc][(nr2*5)-1] = hbuf2;
	ovp[fc][(nr2*5)  ] = hbuf3;
	ovp[fc][(nr2*5)+1] = hbuf4;
	ovp[fc][(nr2*5)+2] = hbuf5;
   }
 }
}

/* PROCEDURE BEPAAL AKTUELE PRIMAIRE GEBIEDEN */
/* ========================================== */

void proc_akt_crsv(
	Int16 fc,	/* Signaalgroep   */
	Int16 cyc,	/* SG cyclisch	  */
	Int16 tl1,	/* Einde uitstel  */
	Int16 tl2,	/* Start primair  */
	Int16 tl3,	/* Start verleng  */
	Int16 tl4,	/* Einde primair  */
	Int16 tl5,	/* Einde groen    */
	Int16 abm,	/* Afbreekmethode */
	Int16 pri)	/* Prio.buiten primair gebied */
{
 Int16 prog_keuze = (Int16)inst_EPARM(PROGKEUZE_CS);
 Int16 SPRIM;
 Int16 VASX;
 Int16 _ABM;
 Int16 _PRI;
 Int16 HSTAP;
 Bool  PRIM_GEBIED;

 if (abm != NIET) {
   _ABM = (Int16)inst_EPARM(abm)/10;
 } else {
   _ABM = 7;
 }

 if (pri != NIET) {
   _PRI = (Int16)inst_EPARM(pri)/10;
 } else {
   _PRI = 0;
 }

 if (_ABM&BIT0) PVAS[fc] |= BIT4;	/* Uitstel     groen door OV toegestaan */
 if (_ABM&BIT1) PVAS[fc] |= BIT5;	/* Afbreken    groen door OV toegestaan */
 if (_ABM&BIT2) PVAS[fc] |= BIT6;	/* Doorsnijden groen door OV toegestaan */

 if (_PRI&BIT0) PVS2[fc] |= BIT0;	/* Prioriteit OV voor einde uitstel toegestaan */
 if (_PRI&BIT1) PVS2[fc] |= BIT1;	/* Prioriteit OV na afkappunt       toegestaan */

						/* Bepaal MAXG volgens raster */
 if ((((Int16)inst_EPARM(tl2)/10) > 0) && (((Int16)inst_EPARM(tl4)/10) > 0)
  && (((Int16)inst_EPARM(tl2)/10) <= CTYD)
  && (((Int16)inst_EPARM(tl4)/10) <= CTYD)) {
   if (((Int16)inst_EPARM(tl4)/10) >= ((Int16)inst_EPARM(tl2)/10)) {
     MAXG[fc] = ((Int16)inst_EPARM(tl4)/10) - ((Int16)inst_EPARM(tl2)/10);
   } else {
     MAXG[fc] = CTYD -
		((Int16)inst_EPARM(tl2)/10) + ((Int16)inst_EPARM(tl4)/10);
   }
 }
						/* Bepaal cyclische realisatie */
 if (SCH(cyc) && (prog_keuze != 10)
	      && (prog_keuze != 11) && !BL_OP(fc)) { HVAS[fc] |=   BIT5;  }
 else						   { HVAS[fc] &= (~BIT5); }
 if ((prog_keuze == 30) && !BL_OP(fc)) HVAS[fc] |= BIT5;
 
 VAS1[fc] = VAS3[fc] = VAS5[fc] = 0;
 VAS4[fc] = (Int16)inst_EPARM(tl4)/10;

 SPRIM = (Int16)inst_EPARM(tl2)/10;
 if (STAP == SPRIM) HVAS[fc] &= (~BIT4);	/* Reset versnelde realisatie  */

 if (SVAS) {					/* Als op SVAS nog ALTM[] groen gemaakt kan worden dan voorkom overslag */
	SVS2[fc] = 0;
	PRIM_GEBIED = FALSE;

	if (!G(fc) && (SPRIM != 0) && (VAS4[fc] != 0) && (SPRIM != VAS4[fc])) {

		HSTAP = STAP + TTR[fc] + 2;	/* Voorkom afrondingsfouten */
		if (HSTAP > CTYD) HSTAP -= CTYD;

		if (VAS4[fc] > SPRIM) {
			if ((HSTAP >= SPRIM) && (HSTAP < VAS4[fc])) PRIM_GEBIED = TRUE;
		} else {
			if ((HSTAP >= SPRIM) || (HSTAP < VAS4[fc])) PRIM_GEBIED = TRUE;
		}
		if (PRIM_GEBIED) {
			if (HSTAP != SPRIM) SVS2[fc] = HSTAP;	/* SVS2 is altijd tenminste 1 sec. voorbij SPRIM */
			HSTAP += ALTM[fc];
			if (HSTAP > CTYD) HSTAP -= CTYD;

			PRIM_GEBIED = FALSE;
			if (VAS4[fc] > SPRIM) {
				if ((HSTAP >= SPRIM) && (HSTAP <= VAS4[fc])) PRIM_GEBIED = TRUE;
			} else {
				if ((HSTAP >= SPRIM) || (HSTAP <= VAS4[fc])) PRIM_GEBIED = TRUE;
			}
			if (!PRIM_GEBIED) {
				SVS2[fc] = 0;
			} else {				/* Als net niet past dan gebied 1 sec. naar voren schuiven */
								/* -> overslag op SVAS is in dat geval dus afh. van de afrondingen */
				if ((HSTAP == VAS4[fc]) && (SVS2[fc] != 0)) {
					SVS2[fc]--;
					if (SVS2[fc] == 0) SVS2[fc] = CTYD;
				}
			}
		}
	}
 }

 if (G(fc) || (HVAS[fc]&BIT3)) SVS2[fc] = 0;	/* Reset speciale start waarde bij SVAS */

 if (HVAS[fc]&BIT4) {
	VAS2[fc] = STAP;
 } else {
	if (SVS2[fc] == 0) VAS2[fc] = (Int16)inst_EPARM(tl2)/10;
	else		   VAS2[fc] = SVS2[fc];
 }

 if ((prog_keuze != 10) && (prog_keuze != 11)) {
	if (tl1 >= 0) VAS1[fc] = (Int16)inst_EPARM(tl1)/10;
	if (tl3 >= 0) VAS3[fc] = (Int16)inst_EPARM(tl3)/10;
	if (tl5 >= 0) VAS5[fc] = (Int16)inst_EPARM(tl5)/10;
 }
 if (prog_keuze == 30) VAS3[fc] = (Int16)inst_EPARM(tl4)/10;

 /* Bepaal primair gebied conform instellingen */
 /* ------------------------------------------ */

 HVAS[fc] &= (~BIT7);
 if ((SPRIM != 0)  && (VAS4[fc] != 0) && (SPRIM != VAS4[fc])) {
	if (VAS4[fc]>SPRIM) {
	  if ((STAP>=SPRIM) && (STAP<VAS4[fc])) HVAS[fc] |= BIT7;
	} else {
	  if ((STAP>=SPRIM) || (STAP<VAS4[fc])) HVAS[fc] |= BIT7;
	}
 }

 if ((VAS2[fc] != 0) && (VAS4[fc] != 0) && (/* VAS2[fc] */ SPRIM != VAS4[fc])) { /* Fik131220 */

	/* Bepaal primair gebied incl.vooruitrealiseren */
	/* -------------------------------------------- */

	if (VAS4[fc]>VAS2[fc]) {  /* Start primair VOOR einde primair */

	  if ((STAP>=VAS2[fc]) && (STAP<VAS4[fc]) && !(HVAS[fc]&BIT3)) {
	  	HVAS[fc] |= BIT0;
	  	if ((STAP<VAS3[fc]) && (VAS3[fc]<=VAS4[fc]))
			 { HVAS[fc] |=   BIT2 ; }
		else	 { HVAS[fc] &= (~BIT2); }
	  } else {
			   HVAS[fc] &= (~BIT0);
			   HVAS[fc] &= (~BIT2);
			   HVAS[fc] &= (~BIT4);
			   PVS2[fc] &= (~BIT4);
	  }

	} else {		  /* Start primair NA einde primair */

	if (((STAP>=VAS2[fc]) || (STAP<VAS4[fc])) && !(HVAS[fc]&BIT3)) {
		HVAS[fc] |= BIT0;
		if ((VAS3[fc]!=0) &&
		   ((STAP>=VAS2[fc]) && ((STAP<VAS3[fc])
						|| (VAS3[fc]<=VAS4[fc]))
		||  (STAP<=VAS4[fc]) &&  (STAP<VAS3[fc])
						&& (VAS3[fc]<=VAS4[fc])))
			 { HVAS[fc] |=   BIT2 ; }
		else	 { HVAS[fc] &= (~BIT2); }
	} else {
			   HVAS[fc] &= (~BIT0);
			   HVAS[fc] &= (~BIT2);
			   HVAS[fc] &= (~BIT4);
			   PVS2[fc] &= (~BIT4);
               }
	}

	/* Bepaal blokkeer overgang naar groen */
	/* ----------------------------------- */

	if ((VAS1[fc] != 0) && (VAS1[fc] != VAS4[fc])) {

	  if (VAS1[fc]>VAS4[fc]) {   /* Start uitstel VOOR einde uitstel */

	    if ((STAP>=VAS4[fc]) && (STAP<VAS1[fc])
				 || (HVAS[fc]&BIT3)) { HVAS[fc] |=   BIT1 ;
	    } else {				       HVAS[fc] &= (~BIT1); }
	    
	  } else {		     /* Start uitstel NA einde uitstel   */

	    if ((STAP>=VAS4[fc]) || (STAP<VAS1[fc])
				 || (HVAS[fc]&BIT3)) { HVAS[fc] |=   BIT1 ;
	    } else {				       HVAS[fc] &= (~BIT1); }
	  }
	} else { HVAS[fc] &= (~BIT1); }

	/* Bepaal forceer overgang naar rood */
	/* --------------------------------- */

	if (VAS1[fc] != 0) VASX = VAS1[fc];	/* Einde NIET-groen-gebied */
	else		   VASX = VAS2[fc];	/* afh. van def.VAS1[fc]   */

	if ((VAS5[fc] != 0) && (VASX != VAS5[fc])) {

	  if (VASX>VAS5[fc]) {       /* Start forceer VOOR einde forceer */

	    if ((STAP>=VAS5[fc]) && (STAP<VASX)
		      || (HVAS[fc]&BIT3) && !G(fc)) { HVAS[fc] |=   BIT6 ;
	    } else {				      HVAS[fc] &= (~BIT6); }
	    
	  } else {		     /* Start forceer NA einde forceer   */

	    if ((STAP>=VAS5[fc]) || (STAP<VASX)
		      || (HVAS[fc]&BIT3) && !G(fc)) { HVAS[fc] |=   BIT6 ;
	    } else {				      HVAS[fc] &= (~BIT6); }
	  }
	} else { HVAS[fc] &= (~BIT6); }

   } else { HVAS[fc] &= (~BIT0); /* Indien Start en/of einde primair NIET */
	    HVAS[fc] &= (~BIT1); /* gedefinieerd dan richting ALTIJD als  */
	    HVAS[fc] &= (~BIT2); /* gerealiseerd beschouwen		  */
	    HVAS[fc] |=   BIT3 ;
	    HVAS[fc] &= (~BIT4);
	    HVAS[fc] &= (~BIT5);
	    HVAS[fc] &= (~BIT6);
	    PVS2[fc] &= (~BIT4);
 }
}

/* PROCEDURE BEPAAL MINIMAAL PRIMAIR GEBIED TBV OV-INGREPEN */
/* ======================================================== */

void proc_min_prim_crsv()
{
   Int16 i;
   Int16 HEPR,REST;

   for (i=0; i<NUMSG_CS; i++) {
	SDSN[i] = 255;	/* Initialiseer doorsnijden start */
	EDSN[i] = 0;	/*       ... en doorsnijden einde */

	if (AKTPRG && (HVAS[i]&BIT0)) {					/* Primaire realisatie aktief */
		HEPR = KAPM[i];
		if (KAPM[i] >= ALTM[i]) REST = ALTM[i];
		else                    REST = KAPM[i];
		if (G(i)) {
			if (TS && (PRGR[i]<255)) PRGR[i]++;		/* Bepaal duur primair groen  */
			if (KG[i] > PRGR[i]) PRGR[i] = KG[i];
			if ((PVAS[i]&BIT6) && !(PVS2[i]&BIT2)) {	/* Doorsnijden is toegestaan */
				if (KG[i] > REST) SDSN[i] = 0;
				else              SDSN[i] = REST - KG[i];
			}
		}
		if (PRGR[i] >= HEPR) HEPR  = 0;				/* Bereken benodigd groen */
		else                 HEPR -= PRGR[i];			/* na terugkomen          */
		if (HEPR < REST)     HEPR  = REST;	

		if (STAP <= VAS4[i]) {
			REST = VAS4[i] - STAP;
			if (REST <= HEPR) EDSN[i] = 0;
			else              EDSN[i] = REST - HEPR;
		} else {
			REST = CTYD - STAP + VAS4[i];
			if (REST <= HEPR) EDSN[i] = 0;
			else              EDSN[i] = REST - HEPR;
		}
		if (PRGR[i] >= KAPM[i]) { 
			EDSN[i] = 255;
			PVS2[i] &= (~BIT4);
		}
	} else {
		PRGR[i] = 0;						/* Reset duur primair groen */
	}
   }

   for (i=0; i<NUMSG_CS; i++) {
	VS2M[i] = VAS2[i];						/* default gelijk aan start primair */
	if (PVAS[i]&BIT4) {						/* corrigeer als uitstel is toegestaan */
		if (VAS2[i] <= VAS4[i]) {
		  if ((VAS4[i] - KAPM[i]) > VAS2[i]) VS2M[i] = VAS4[i] - KAPM[i];
		} else {
		  HEPR = VAS4[i] + CTYD;
		  if (VAS2[i] <= HEPR) {
		    if ((HEPR - KAPM[i]) > VAS2[i]) {
			VS2M[i] = HEPR - KAPM[i];
			if (VS2M[i] > CTYD) VS2M[i] -= CTYD;
		    }
		  }
		}
	}
	if (PVS2[i]&BIT4) {						/* Corrigeer VS2M[] indien richting */
		VS2M[i] = STAP + EDSN[i];				/* terug gaat komen na afkappen     */
		if (VS2M[i] > CTYD) VS2M[i] -= CTYD;
	}
   }
   for (i=0; i<aant_fts; i++) {
     proc_min_prim_vtg(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
   }
   for (i=0; i<aant_bbv; i++) {
     proc_min_prim_vtg(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
   }
   for (i=0; i<aant_gov; i++) {
     proc_min_prim_vtg(gov[i][0],gov[i][1],gov[i][7]
			,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
   }
   proc_min_prim_hki();

   for (i=0; i<NUMSG_CS; i++) {

	if ((VS2M[i] != 0) && (VAS4[i] != 0) && (VS2M[i] != VAS4[i])) {

		/* Bepaal garantie gebied primaire realisatie */
		/* ------------------------------------------ */

		if (VAS4[i]>VS2M[i]) {	/* Start primair VOOR einde primair */

		  if ((STAP>=VS2M[i]) && (STAP<VAS4[i]) && !(HVAS[i]&BIT3)) {
		  	PVAS[i] |= BIT0;
		  } else {
			PVAS[i] &= (~BIT0);
		  }

		} else {		/* Start primair NA einde primair */

		  if (((STAP>=VS2M[i]) || (STAP<VAS4[i])) && !(HVAS[i]&BIT3)) {
			PVAS[i] |= BIT0;
		  } else {
			PVAS[i] &= (~BIT0);
		  }
		}
	}
   }
}

/* CORRIGEER MIN.PRIMAIR GEBIED TBV OV-INGREPEN AGV GEKOPPELDE OVERSTEKEN */
/* ====================================================================== */
void proc_min_prim_vtg(
	Int16 fc1,	/* Signaalgroep 1 */
	Int16 fc2,	/* Signaalgroep 2 */
	Int16 fc3,	/* Signaalgroep 3 */
	Int16 fc4,	/* Signaalgroep 4 */
	Int16 fc5,	/* Signaalgroep 5 */
	Int16 fc6,	/* Signaalgroep 6 */
	Int16 fc7)	/* Signaalgroep 7 */
{
 Int16 _minVS2 = (2*CTYD)+1;
 Int16 HSPR;
 Int16 i,_fc[7];

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=fc7;

 /* Bepaal VS2M */
 /* ----------- */
 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
	if (VS2M[_fc[i]] < VAS2[_fc[i]]) HSPR = VS2M[_fc[i]] + CTYD;
	else				 HSPR = VS2M[_fc[i]];
	if (HSPR < _minVS2) _minVS2 = HSPR;
   }
 }
 if (_minVS2 > (2*CTYD)) _minVS2 = 0;
 if (_minVS2 > CTYD) _minVS2 -= CTYD;

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) VS2M[_fc[i]] = _minVS2;
 }
}

/* CORRIGEER MIN.PRIMAIR GEBIED TBV OV-INGREPEN AGV SERIELE KOPPELING */
/* ================================================================== */
void proc_min_prim_hki()
{
 Int16 fc1,fc2,vs12,fc3,vs23,stat;
 Int16 voorstart;
 Int16 correctie;
 Int16 _VS2M;
 Int16 i,x;

 for (x=0; x<3; x++) {							/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1 = hki[i][0];
	fc2 = hki[i][1];
	vs12= hki[i][2];
	fc3 = hki[i][10];
	vs23= hki[i][11];
	stat= hki[i][20];

	if (stat >= 2) {						/* koppeling is aktief */
		if ((x == 1) && (TS || N_ts)) {
			if (HG_hki[i][fc2] && (hki[i][9]<255)) hki[i][9]++;
			if (fc3 >= 0) {					/* pas gaan tellen als fc2 groen geworden is! */
				if (HG_hki[i][fc3] && (hki[i][18]<255) && (G(fc2) || (hki[i][18]>0))) hki[i][18]++;
			}
		}

		if (G(fc2) || !HG_hki[i][fc2]) hki[i][9]=0;
		if (fc3 >= 0) {
			if (G(fc3) || !HG_hki[i][fc3]) hki[i][18]=0;
		}

		if (G(fc1) && (HVAS[fc1]&BIT0) && HG_hki[i][fc2]) {
			HG_hki[i][fc2] |= BIT3;
			HG[fc2] |= BIT3;
			if (fc3 >= 0) {
				if (HG_hki[i][fc3]) {
					HG_hki[i][fc3] |= BIT5;
					HG[fc3] |= BIT5;
				}
			}
		}
		if (fc3 >= 0) {
			if (G(fc2) && (HVAS[fc2]&BIT0) && HG_hki[i][fc3]) {
				HG_hki[i][fc3] |= BIT3;
				HG[fc3] |= BIT3;
			}
		}

		if (HG_hki[i][fc2]&BIT3) {				/* _VS2M is het startgroen moment van de voeding */
			if (hki[i][9] > CTYD) _VS2M = VAS2[fc1];	/* fout opgetreden */
			else {
				_VS2M = STAP - hki[i][9];
				if (_VS2M < 0) _VS2M += CTYD;
			}
		} else {
			_VS2M = VS2M[fc1];
		}							/* voorstart is de garandeerde resulterende voorstart */
		if (_VS2M <= VS2M[fc2]) voorstart = VS2M[fc2] - _VS2M;
		else voorstart = VS2M[fc2] + CTYD - _VS2M;

		if (voorstart > ((Int16)inst_TIJD(vs12)/10)) {		/* te groot? dan pas VS2M[] volgrichting aan */
			correctie = voorstart - ((Int16)inst_TIJD(vs12)/10);
			VS2M[fc2] -= correctie;
			if (VS2M[fc2] <= 0) VS2M[fc2] += CTYD;

			if (VAS2[fc2] <= VAS4[fc2]) {			/* VS2M[] kan nooit kleiner worden dan VAS2[] */
				if ((VS2M[fc2] < VAS2[fc2]) || (VS2M[fc2] > VAS4[fc2])) {
					VS2M[fc2] = VAS2[fc2];
				}
			} else {
				if ((VS2M[fc2] < VAS2[fc2]) && (VS2M[fc2] > VAS4[fc2])) {
					VS2M[fc2] = VAS2[fc2];
				}
			}
		}

		if (fc3 >= 0) {						/* corrigeer VS2M[fc3] tov startgroen fc2 */
			if (HG_hki[i][fc3]&BIT3) {
				if (hki[i][18] > CTYD) _VS2M = VAS2[fc2];
				else {
					_VS2M = STAP - hki[i][18];
					if (_VS2M < 0) _VS2M += CTYD;
				}
			} else {
				_VS2M = VS2M[fc2];
			}
			if (_VS2M <= VS2M[fc3]) voorstart = VS2M[fc3] - _VS2M;
			else voorstart = VS2M[fc3] + CTYD - _VS2M;

			if (voorstart > ((Int16)inst_TIJD(vs23)/10)) {
				correctie = voorstart - ((Int16)inst_TIJD(vs23)/10);
				VS2M[fc3] -= correctie;
				if (VS2M[fc3] <= 0) VS2M[fc3] += CTYD;

				if (VAS2[fc3] <= VAS4[fc3]) {
					if ((VS2M[fc3] < VAS2[fc3]) || (VS2M[fc3] > VAS4[fc3])) {
						VS2M[fc3] = VAS2[fc3];
					}
				} else {
					if ((VS2M[fc3] < VAS2[fc3]) && (VS2M[fc3] > VAS4[fc3])) {
						VS2M[fc3] = VAS2[fc3];
					}
				}
			}

			if (HG_hki[i][fc3]&BIT5) {			/* corrigeer VS2M[fc3] tov startgroen fc1 */
				if (hki[i][9] > CTYD) _VS2M = VAS2[fc1];
				else {
					_VS2M = STAP - hki[i][9];
					if (_VS2M < 0) _VS2M += CTYD;
				}
			} else {
				_VS2M = VS2M[fc1];
			}
			if (_VS2M <= VS2M[fc3]) voorstart = VS2M[fc3] - _VS2M;
			else voorstart = VS2M[fc3] + CTYD - _VS2M;

			if (voorstart > (((Int16)inst_TIJD(vs12)/10) + ((Int16)inst_TIJD(vs23)/10))) {
				correctie = voorstart - ((Int16)inst_TIJD(vs12)/10) - ((Int16)inst_TIJD(vs23)/10);
				VS2M[fc3] -= correctie;
				if (VS2M[fc3] <= 0) VS2M[fc3] += CTYD;

				if (VAS2[fc3] <= VAS4[fc3]) {
					if ((VS2M[fc3] < VAS2[fc3]) || (VS2M[fc3] > VAS4[fc3])) {
						VS2M[fc3] = VAS2[fc3];
					}
				} else {
					if ((VS2M[fc3] < VAS2[fc3]) && (VS2M[fc3] > VAS4[fc3])) {
						VS2M[fc3] = VAS2[fc3];
					}
				}
			}
		}

	} else {							/* koppeling is niet aktief */
		hki[i][9] = 0;
		hki[i][18]= 0;
	}
    }
 }
}

/* PROCEDURE INITIALISEER ONDERGRENZEN VOOR AFKAPPEN, ALTM[] EN KAPM[] */
/* =================================================================== */

void init_kapm_crsv()
{
 Int16 i,garant;

 for (i=0; i<NUMSG_CS; i++) {
	 garant  = (Int16)inst_GG_TIJD(i)/10;
	 ALTM[i] = KAPM[i] = MAXG[i] = (Int16)inst_VG_TIJD(i)/10;
	 if (garant > ALTM[i])
	 ALTM[i] = KAPM[i] = MAXG[i] = garant;
	 PVAS[i] &= (~BIT7);
 }
}

/* PROCEDURE BEPAAL ALTM[] EN KAPM[] */
/* ================================= */

void proc_kapm_crsv(
	Int16 fc,	/* Signaalgroep */
	Int16 alt,	/* EPARM(ALTVA) */
	Int16 kap)	/* EPARM(KAPOV) */
{
 Int16 waarde = 0;
 Int16 percen = 0;

 if (alt >= 0) waarde = (Int16)inst_EPARM(alt)/10;
 if (kap >= 0) percen = (Int16)inst_EPARM(kap)/10;

 if (waarde > ALTM[fc]) ALTM[fc] = waarde;

 if (percen > 100) percen = 100;
 waarde = (percen * MAXG[fc])/100;
 if (waarde > KAPM[fc]) KAPM[fc] = waarde;
}

/* PROCEDURE CORRIGEER ALTM[] EN KAPM[] IVM GEKOPPELDE OVERSTEKEN */
/* ============================================================== */

void proc_corr_kapm()
{
 Int16 i;

 for (i=0; i<aant_bbv; i++) {
	proc_kapm_crsv_bb(bbv[i][0],bbv[i][1],bbv[i][2],bbv[i][3],bbv[i][8]);
 }
 for (i=0; i<aant_gov; i++) {
	proc_kapm_crsv_go(gov[i][0],gov[i][1],gov[i][4],gov[i][5],
			  gov[i][6],gov[i][7],gov[i][8],gov[i][10],gov[i][11],
			  gov[i][13],gov[i][14],gov[i][16],gov[i][17],gov[i][21],
                          gov[i][22],gov[i][25],gov[i][26],gov[i][27],gov[i][28]);
 }
 if (AKTPRG) proc_min_prim_crsv();
}

/* PROCEDURE BEPAAL ALTM[] EN KAPM[] VOOR PROGRESSIEVE VOETGANGERSOVERSTEEK */
/* ======================================================================== */

void proc_kapm_crsv_bb(
	Int16 fc1,	/* Signaalgroep 1	 */
	Int16 fc2,	/* Signaalgroep 2	 */
	Int16 kpt12,	/* KoppelTIJD eg1 -> eg2 */
	Int16 gkpg_a,	/* Schakelaar geen kop.garantie bij alt  */
	Int16 gkpg_p)	/* Schakelaar geen kop.garantie bij prio */
{
 Int16 kop12 = 0;

 if ((fc1 >= 0) && (fc2 >=0)) {
	kop12 = (Int16)inst_TIJD(kpt12)/10;
	if ((ALTM[fc1] + kop12) > ALTM[fc2]) {
		if (!SCH(gkpg_a)) ALTM[fc2] = ALTM[fc1] + kop12;
	}
	if ((KAPM[fc1] + kop12) > KAPM[fc2]) {
		if (!SCH(gkpg_p)) KAPM[fc2] = KAPM[fc1] + kop12;
	}
	if (SCH(gkpg_p)) {		/* vlag voetganger mag afgebroken worden door OV */
		PVAS[fc1] |= BIT7;
		PVAS[fc2] |= BIT7;
	}
 }
}

/* PROCEDURE BEPAAL ALTM[] EN KAPM[] VOOR GESCHEIDEN VOETGANGERSOVERSTEEK */
/* ====================================================================== */

void proc_kapm_crsv_go(
	Int16 fc1,	/* Signaalgroep 1	                 */
	Int16 fc2,	/* Signaalgroep 2	                 */
	Int16 kpt12,	/* KoppelTIJD sg1 -> eg2                 */
	Int16 kpt21,	/* KoppelTIJD sg2 -> eg1                 */
	Int16 gkpg_a,	/* Schakelaar geen kop.garantie bij alt  */
	Int16 fc3,	/* Gekoppelde fietser 1                  */
	Int16 fc4,	/* Gekoppelde fietser 1 volg             */
	Int16 kpt3s,	/* Koppeltijd vanaf start fc3            */
	Int16 kpt3e,	/* Koppeltijd vanaf einde fc3            */
	Int16 fc5,	/* Gekoppelde fietser 2                  */
	Int16 fc6,	/* Gekoppelde fietser 2 volg             */
	Int16 kpt5s,	/* Koppeltijd vanaf start fc5            */
	Int16 kpt5e,	/* Koppeltijd vanaf einde fc5            */
	Int16 gkpg_p,	/* Schakelaar geen kop.garantie bij prio */

	Int16 vtg3,     /* Signaalgroep 3e voetganger            */
	Int16 kpt13,    /* KoppelTIJD sg1 -> eg3                 */
	Int16 kpt23,    /* KoppelTIJD sg2 -> eg3                 */
	Int16 kpt31,    /* KoppelTIJD sg3 -> eg1                 */
	Int16 kpt32)    /* KoppelTIJD sg3 -> eg2                 */
{
 Int16 kop12 = 0;
 Int16 kop21 = 0;
 Int16 kop3s = 0;
 Int16 kop3e = 0;
 Int16 kop5s = 0;
 Int16 kop5e = 0;

 Int16 akt12 = 0;
 Int16 akt21 = 0;

 Int16 kop13 = 0;       /* toevoegingen i.v.m. drie-traps-voetganger */
 Int16 kop23 = 0;
 Int16 kop31 = 0;
 Int16 kop32 = 0;

 Int16 akt13 = 0;
 Int16 akt23 = 0;
 Int16 akt31 = 0;
 Int16 akt32 = 0;

 if ((fc1 >= 0) && (fc2 >= 0)) {
	kop12 = (Int16)inst_TIJD(kpt12)/10;
	kop21 = (Int16)inst_TIJD(kpt21)/10;
	if ((kop21 > ALTM[fc1]) && (!G(fc2) || begin_G(fc2)) && !SCH(gkpg_a)) ALTM[fc1] = kop21;
	if ((kop21 > KAPM[fc1]) && (!G(fc2) || begin_G(fc2)) && !SCH(gkpg_p)) KAPM[fc1] = kop21;
	if ((kop12 > ALTM[fc2]) && (!G(fc1) || begin_G(fc1)) && !SCH(gkpg_a)) ALTM[fc2] = kop12;
	if ((kop12 > KAPM[fc2]) && (!G(fc1) || begin_G(fc1)) && !SCH(gkpg_p)) KAPM[fc2] = kop12;

	if (G(fc1) && TIJD(kpt12)) {
		akt12 = (Int16)waarde_TIJD(kpt12)/10;
		if (((kop12 - akt12) > ALTM[fc2]) && !SCH(gkpg_a)) ALTM[fc2] = kop12 - akt12;
		if (((kop12 - akt12) > KAPM[fc2]) && !SCH(gkpg_p)) KAPM[fc2] = kop12 - akt12;
	}
	if (G(fc2) && TIJD(kpt21)) {
		akt21 = (Int16)waarde_TIJD(kpt21)/10;
		if (((kop21 - akt21) > ALTM[fc1]) && !SCH(gkpg_a)) ALTM[fc1] = kop21 - akt21;
		if (((kop21 - akt21) > KAPM[fc1]) && !SCH(gkpg_p)) KAPM[fc1] = kop21 - akt21;
	}
	if (SCH(gkpg_p)) {		/* vlag voetganger mag afgebroken worden door OV */
		PVAS[fc1] |= BIT7;
		PVAS[fc2] |= BIT7;
	}
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) { /* correctie i.g.v. drie-traps-voetganger */
	kop13 = (Int16)inst_TIJD(kpt13)/10;
	kop23 = (Int16)inst_TIJD(kpt23)/10;
	kop31 = (Int16)inst_TIJD(kpt31)/10;
	kop32 = (Int16)inst_TIJD(kpt32)/10;

	if ((kop31 > ALTM[fc1]) && (!G(vtg3) || begin_G(vtg3)) && !SCH(gkpg_a)) ALTM[fc1] = kop31;
	if ((kop31 > KAPM[fc1]) && (!G(vtg3) || begin_G(vtg3)) && !SCH(gkpg_p)) KAPM[fc1] = kop31;
	if ((kop32 > ALTM[fc2]) && (!G(vtg3) || begin_G(vtg3)) && !SCH(gkpg_a)) ALTM[fc2] = kop32;
	if ((kop32 > KAPM[fc2]) && (!G(vtg3) || begin_G(vtg3)) && !SCH(gkpg_p)) KAPM[fc2] = kop32;

	if ((kop13 > ALTM[vtg3]) && (!G(fc1) || begin_G(fc1)) && !SCH(gkpg_a)) ALTM[vtg3] = kop13;
	if ((kop13 > KAPM[vtg3]) && (!G(fc1) || begin_G(fc1)) && !SCH(gkpg_p)) KAPM[vtg3] = kop13;
	if ((kop23 > ALTM[vtg3]) && (!G(fc2) || begin_G(fc2)) && !SCH(gkpg_a)) ALTM[vtg3] = kop23;
	if ((kop23 > KAPM[vtg3]) && (!G(fc2) || begin_G(fc2)) && !SCH(gkpg_p)) KAPM[vtg3] = kop23;

	if (G(fc1) && TIJD(kpt13)) {
		akt13 = (Int16)waarde_TIJD(kpt13)/10;
		if (((kop13 - akt13) > ALTM[vtg3]) && !SCH(gkpg_a)) ALTM[vtg3] = kop13 - akt13;
		if (((kop13 - akt13) > KAPM[vtg3]) && !SCH(gkpg_p)) KAPM[vtg3] = kop13 - akt13;
	}
	if (G(fc2) && TIJD(kpt23)) {
		akt23 = (Int16)waarde_TIJD(kpt23)/10;
		if (((kop23 - akt23) > ALTM[vtg3]) && !SCH(gkpg_a)) ALTM[vtg3] = kop23 - akt23;
		if (((kop23 - akt23) > KAPM[vtg3]) && !SCH(gkpg_p)) KAPM[vtg3] = kop23 - akt23;
	}
	if (G(vtg3) && TIJD(kpt31)) {
		akt31 = (Int16)waarde_TIJD(kpt31)/10;
		if (((kop31 - akt31) > ALTM[fc1]) && !SCH(gkpg_a)) ALTM[fc1] = kop31 - akt31;
		if (((kop31 - akt31) > KAPM[fc1]) && !SCH(gkpg_p)) KAPM[fc1] = kop31 - akt31;
	}
	if (G(vtg3) && TIJD(kpt32)) {
		akt32 = (Int16)waarde_TIJD(kpt32)/10;
		if (((kop32 - akt32) > ALTM[fc2]) && !SCH(gkpg_a)) ALTM[fc2] = kop32 - akt32;
		if (((kop32 - akt32) > KAPM[fc2]) && !SCH(gkpg_p)) KAPM[fc2] = kop32 - akt32;
	}
	if (SCH(gkpg_p)) {		 /* vlag voetganger mag afgebroken worden door OV */
		PVAS[vtg3] |= BIT7;
	}
 }

 if ((fc3 >= 0) && (fc4 >= 0)) {
	kop3s = (Int16)inst_TIJD(kpt3s)/10;
	kop3e = (Int16)inst_TIJD(kpt3e)/10;
	if (kop3s > ALTM[fc4]) ALTM[fc4] = kop3s;
	if (kop3s > KAPM[fc4]) KAPM[fc4] = kop3s;
	if ((ALTM[fc3] + kop3e) > ALTM[fc4])
		ALTM[fc4] = ALTM[fc3] + kop3e;
	if ((KAPM[fc3] + kop3e) > KAPM[fc4])
		KAPM[fc4] = KAPM[fc3] + kop3e;
 }
 if ((fc5 >= 0) && (fc6 >= 0)) {
	kop5s = (Int16)inst_TIJD(kpt5s)/10;
	kop5e = (Int16)inst_TIJD(kpt5e)/10;
	if (kop5s > ALTM[fc6]) ALTM[fc6] = kop5s;
	if (kop5s > KAPM[fc6]) KAPM[fc6] = kop5s;
	if ((ALTM[fc5] + kop5e) > ALTM[fc6])
		ALTM[fc6] = ALTM[fc5] + kop5e;
	if ((KAPM[fc5] + kop5e) > KAPM[fc6])
		KAPM[fc6] = KAPM[fc5] + kop5e;
 }
}

/* PROCEDURE BEPAAL OPENHOUDEN PRIMAIR AANVRAAGGEBIED DOOR APPLICATIE */
/* ================================================================== */

void proc_open_prim_appl(
	Int16 fc,	/* Signaalgroep          */
	Int16 hf_op_pr)	/* Hulpfunctie open_prim */
{
 Int16 i;

 if (HF(hf_op_pr)) FCA[fc] |= BIT2;

 for (i=0; i<aant_fts; i++) {
   proc_open_prim(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_open_prim(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
 }
 for (i=0; i<aant_gov; i++) {
   proc_open_prim(gov[i][0],gov[i][1],gov[i][7]
		 ,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
 }
}

/* PROCEDURE CORRIGEER OPENHOUDEN PRIM.AANVRAAGGEBIED FTS.VTG.KOPPELINGEN */
/* ====================================================================== */

void proc_open_prim(
	Int16 fc1,	/* Signaalgroep 1 */
	Int16 fc2,	/* Signaalgroep 2 */
	Int16 fc3,	/* Signaalgroep 3 */
	Int16 fc4,	/* Signaalgroep 4 */
	Int16 fc5,	/* Signaalgroep 5 */
	Int16 fc6,	/* Signaalgroep 6 */
	Int16 fc7)	/* Signaalgroep 7 */
{
 Bool _FCA = FALSE;
 Int16 i,_fc[7];

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=fc7;

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
	if (FCA[_fc[i]]&BIT2) _FCA = TRUE;
   }
 }
 if (_FCA) {
   for (i=0; i<7; i++) {
     if (_fc[i] >= 0) FCA[_fc[i]] |= BIT2;
   }
 }
}

/* PROCEDURE CORRIGEER OPENHOUDEN PRIM.AANVRAAGGEBIED SERIELE KOPPELING */
/* ==================================================================== */

void proc_open_hki_prim()
{
 Int16 fc1,fc2,fc3,stat,i,j,x;
 Bool hki_gebied;

 for (x=0; x<3; x++) {							/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1 = hki[i][0];
	fc2 = hki[i][1];
	fc3 = hki[i][10];
	stat= hki[i][20];
	hki_gebied = FALSE;

	if (stat >= 2) {						/* koppeling is aktief */

		if ((VAS2[fc1] != 0) && (VAS4[fc1] != 0) && (VAS2[fc1] != VAS4[fc1]) &&
		    (VAS2[fc2] != 0) && (VAS4[fc2] != 0) && (VAS2[fc2] != VAS4[fc2])) {

			if (VAS4[fc2]>=VAS4[fc1]) {			/* einde primair fc1 VOOR einde primair fc2 */

				if ((STAP>=VAS4[fc1]) && (STAP<VAS4[fc2])) hki_gebied = TRUE;

			} else {					/* einde primair fc1 NA   einde primair fc2 */

				if ((STAP>=VAS4[fc1]) || (STAP<VAS4[fc2])) hki_gebied = TRUE;
			}

			if (G(fc1) || GL(fc1) || GR_TIJD(fc1) || VA[fc1]
					      || (HVAS[fc1]&BIT5) || FCA[fc1]) {
				if (!hki_gebied && !(HVAS[fc1]&BIT3)) {
					FCA[fc2] |= BIT2;
					FCA_hki[i][fc2] |= BIT3;
				}
			}

			if (G(fc1) || (HVAS[fc1]&BIT3) || hki_gebied ||	/* toegevoegd Fik110216 */
									!GL(fc1) && !GR_TIJD(fc1) && !VA[fc1] && !(HVAS[fc1]&BIT5) && !FCA[fc1]) {
				FCA_hki[i][fc2] &= (~BIT3);
			}

			if (G(fc1) && !G(fc2)) VA[fc2] |= BIT3;		/* fc2 volgt fc1, toegevoegd 110110 */

		} else {
			FCA_hki[i][fc2] &= (~BIT3);
		}

		if (fc3 >= 0) {
			if ((VAS2[fc2] != 0) && (VAS4[fc2] != 0) && (VAS2[fc2] != VAS4[fc2]) &&
			    (VAS2[fc3] != 0) && (VAS4[fc3] != 0) && (VAS2[fc3] != VAS4[fc3])) {

				if (VAS4[fc3]>=VAS4[fc2]) {		/* einde primair fc2 VOOR einde primair fc3 */

					if ((STAP>=VAS4[fc2]) && (STAP<VAS4[fc3])) hki_gebied = TRUE;

				} else {				/* einde primair fc2 NA   einde primair fc3 */

					if ((STAP>=VAS4[fc2]) || (STAP<VAS4[fc3])) hki_gebied = TRUE;
				}

				if (G(fc2) || GL(fc2) || GR_TIJD(fc2) || VA[fc2]
						      || (HVAS[fc2]&BIT5) || FCA[fc2]) {
					if (!hki_gebied && !(HVAS[fc2]&BIT3)) {
						FCA[fc3] |= BIT2;
						FCA_hki[i][fc3] |= BIT3;
					}
				}

				if (G(fc2) || (HVAS[fc2]&BIT3) || hki_gebied || !GL(fc2) && !GR_TIJD(fc2) && !VA[fc2] && !(HVAS[fc2]&BIT5) && !FCA[fc2]) {
					FCA_hki[i][fc3] &= (~BIT3);
				}
									/* fc3 volgt fc2, toegevoegd Fik110110, gewijzigd Fik110806 */
				/* if (!G(fc3) && (G(fc2) && BW_hki[i][fc2] || G(fc1) && !(FCA_hki[i][fc3]&BIT3))) VA[fc3] |= BIT3; */
				if (!G(fc3) && G(fc2) && BW_hki[i][fc2]) VA[fc3] |= BIT3;

			} else {
				FCA_hki[i][fc3] &= (~BIT3);
			}
		}

	} else {							/* koppeling is niet aktief */
		FCA_hki[i][fc2] &= (~BIT3);
		if (fc3 >= 0) FCA_hki[i][fc3] &= (~BIT3);
	}
    }

    for (j=0; j<NUMSG_CS; j++) {					/* bepaal FCA[]&BIT3 per signaalgroep */
	FCA[j] &= (~BIT3);
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (FCA_hki[i][j]&BIT3) FCA[j] |= BIT3;
	}
    }
 }
}

/* PROCEDURE BEPAAL TIJD TOT EINDE GROEN, TEG[] */
/* ============================================ */

void proc_bteg_crsv()
{
 Int16 i,garant;
 Int16 _peg;

 proc_open_hki_prim();
 for (i=0; i<NUMSG_CS; i++) {

	garant = (Int16)inst_GG_TIJD(i)/10;

	if (G(i)) {
	   if (TS){
		if (TEG[i]>0) TEG[i]--;
		if (PEG[i]>0) PEG[i]--;
	   }
	   if (MVG(i) && (KG[i] >= garant)) {
		TEG[i] = FALSE;
		PEG[i] = FALSE;
	   }
	   if (begin_G(i)) {
		TEG[i] = ALTM[i];
		PEG[i] = KAPM[i];
	   }
	} else { TEG[i] = PEG[i] = FALSE; }

	if (!(PVAS[i]&BIT5)) {	/* Corrigeer PEG[] als afbreken niet is toegestaan */
		_peg = 0;
		if (!(HVAS[i]&BIT3)) {
			if (begin_G(i) && (VA[i]&BIT4) || G(i) && ((HVAS[i]&BIT0) || (HVAS[i]&BIT4))) {
						if (STAP <= VAS4[i]) _peg = VAS4[i] - STAP;
						else                 _peg = CTYD - STAP + VAS4[i];
			}
		}
		if (_peg > PEG[i]) PEG[i] = _peg;
	}

 }
 for (i=0; i<aant_bbv; i++)
	corr_bbtegcrsv(bbv[i][0],bbv[i][1],bbv[i][2]);
 for (i=0; i<aant_gov; i++)
	corr_gotegcrsv(gov[i][0],gov[i][1],gov[i][4],gov[i][5],
		       gov[i][7],gov[i][8],gov[i][10],gov[i][11],
		       gov[i][13],gov[i][14],gov[i][16],gov[i][17],
                       gov[i][22],gov[i][23],gov[i][24],gov[i][25],gov[i][26],gov[i][27],gov[i][28]);
 corr_hkitegcrsv();
}

/* PROCEDURE CORRIGEER TEG[] VOOR PROGRESSIEVE VOETGANGERSOVERSTEEK */
/* ================================================================ */

void corr_bbtegcrsv(
	Int16 fc1,	/* Signaalgroep 1	 */
	Int16 fc2,	/* Signaalgroep 2	 */
	Int16 kpt12)	/* KoppelTIJD eg1 -> eg2 */
{
 Int16 dgg_1 = 0;
 Int16 dgg_2 = 0;
 Int16 kop12 = 0;

 if ((fc1 >= 0) && (fc2 >= 0)) {
   dgg_1 = (Int16)inst_GG_TIJD(fc1)/10;
   dgg_2 = (Int16)inst_GG_TIJD(fc2)/10;
   kop12 = (Int16)inst_TIJD(kpt12)/10;

   if (begin_G(fc1)) { TEG[fc1] = (Int16)inst_VG_TIJD(fc1)/10;
		       if (dgg_1 > TEG[fc1]) TEG[fc1] = dgg_1;
   }
   if (begin_G(fc2)) { TEG[fc2] = (Int16)inst_VG_TIJD(fc2)/10;
		       if (dgg_2 > TEG[fc2]) TEG[fc2] = dgg_2;
   }
   if (G(fc1)) {
     if (((TEG[fc1] + kop12) > TEG[fc2]) && G(fc2))
				TEG[fc2] = TEG[fc1] + kop12;
   }
   PEG[fc1] = TEG[fc1];
   PEG[fc2] = TEG[fc2];
 }
}

/* PROCEDURE CORRIGEER TEG[] VOOR GESCHEIDEN VOETGANGERSOVERSTEEK */
/* ============================================================== */

void corr_gotegcrsv(
	Int16 fc1,	/* Signaalgroep 1	      */
	Int16 fc2,	/* Signaalgroep 2	      */
	Int16 kpt12,	/* KoppelTIJD sg1 -> eg2      */
	Int16 kpt21,	/* koppelTIJD sg2 -> eg1      */
	Int16 fc3,	/* Gekoppelde fietser 1       */
	Int16 fc4,	/* Gekoppelde fietser 1 volg  */
	Int16 kpt3s,	/* Koppeltijd vanaf start fc3 */
	Int16 kpt3e,	/* Koppeltijd vanaf einde fc3 */
	Int16 fc5,	/* Gekoppelde fietser 2       */
	Int16 fc6,	/* Gekoppelde fietser 2 volg  */
	Int16 kpt5s,	/* Koppeltijd vanaf start fc5 */
	Int16 kpt5e,	/* Koppeltijd vanaf einde fc5 */

	Int16 vtg3,     /* Signaalgroep 3e voetganger */
	Int16 kpa31,    /* Kop.aanvr. sg3 -> sg1      */
	Int16 kpa32,    /* Kop.aanvr. sg3 -> sg2      */
	Int16 kpt13,    /* KoppelTIJD sg1 -> eg3      */
	Int16 kpt23,    /* KoppelTIJD sg2 -> eg3      */
	Int16 kpt31,    /* KoppelTIJD sg3 -> eg1      */
	Int16 kpt32)    /* KoppelTIJD sg3 -> eg2      */
{
 Int16 dvg_1 = 0;
 Int16 dvg_2 = 0;
 Int16 dgg_1 = 0;
 Int16 dgg_2 = 0;
 Int16 kop12 = 0;
 Int16 kop21 = 0;
 Int16 kop3s = 0;
 Int16 kop3e = 0;
 Int16 kop5s = 0;
 Int16 kop5e = 0;

 Int16 akt12 = 0;
 Int16 akt21 = 0;

 Int16 min_1 = 0;
 Int16 min_2 = 0;

 Int16 dvg_3 = 0;   /* toevoegingen i.v.m. drie-traps-voetganger */
 Int16 dgg_3 = 0;

 Int16 kop13 = 0;
 Int16 kop23 = 0;
 Int16 kop31 = 0;
 Int16 kop32 = 0;

 Int16 akt13 = 0;
 Int16 akt23 = 0;
 Int16 akt31 = 0;
 Int16 akt32 = 0;

 Int16 min_3 = 0;

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 < 0)) {
   dvg_1 = (Int16)inst_VG_TIJD(fc1)/10;
   dvg_2 = (Int16)inst_VG_TIJD(fc2)/10;
   dgg_1 = (Int16)inst_GG_TIJD(fc1)/10;
   dgg_2 = (Int16)inst_GG_TIJD(fc2)/10;
   kop12 = (Int16)inst_TIJD(kpt12)/10;
   kop21 = (Int16)inst_TIJD(kpt21)/10;

   min_1 = dvg_1; min_2 = dvg_2;
   if (dgg_1 > min_1) min_1 = dgg_1;
   if (dgg_2 > min_2) min_2 = dgg_2;

   if (TIJD(kpt12)) {
	akt12 = (Int16)waarde_TIJD(kpt12)/10;
   } else {
	akt12 = 0;
   }

   if (TIJD(kpt21)) {
	akt21 = (Int16)waarde_TIJD(kpt21)/10;
   } else {
	akt21 = 0;
   }

   if ((fc3 < 0) && (fc4 < 0) && (fc5 < 0) && (fc6 < 0)) {
	if (begin_G(fc1) && (VA[fc1]&BIT6) && RVG(fc2)) HG[fc2] |= BIT2;
	if (begin_G(fc2) && (VA[fc2]&BIT6) && RVG(fc1)) HG[fc1] |= BIT2;
   }
   if (begin_G(fc1) || HG[fc1]) TEG[fc1] = min_1;
   if (begin_G(fc2) || HG[fc2]) TEG[fc2] = min_2;

   if (begin_G(fc1) && (VA[fc1]&BIT6)) {
     if ((kop12 > TEG[fc2]) && G(fc2)) TEG[fc2] = kop12;
   }
   if (begin_G(fc2) && (VA[fc2]&BIT6)) {
     if ((kop21 > TEG[fc1]) && G(fc1)) TEG[fc1] = kop21;
   }
   if (HG[fc1]) {
	TEG[fc1] += TTR[fc1];
	if ((kop21 - akt21) > TEG[fc1]) TEG[fc1] = kop21 - akt21;
	if (G(fc1)) HG[fc1] = FALSE;
	if (G(fc2) && ((TTR[fc1]+kop12) > TEG[fc2])) TEG[fc2] = TTR[fc1]+kop12;
	if (G(fc2) && begin_G(fc1) && !(VA[fc1]&BIT6)) {
	  if (begin_G(fc2)) TEG[fc2] = min_2;
	  else {
	    if (dvg_2 >= dgg_2) {
	      if (VG_TIJD(fc2)) TEG[fc2] = dvg_2-(Int16)waarde_VG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
	    } else {
	      if (GG_TIJD(fc2)) TEG[fc2] = dgg_2-(Int16)waarde_GG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
	    }
	    if (TEG[fc2]<0) TEG[fc2] = 0;
	  }
	}
   }
   if (HG[fc2]) {
	TEG[fc2] += TTR[fc2];
	if ((kop12 - akt12) > TEG[fc2]) TEG[fc2] = kop12 - akt12;
	if (G(fc2)) HG[fc2] = FALSE;
	if (G(fc1) && ((TTR[fc2]+kop21) > TEG[fc1])) TEG[fc1] = TTR[fc2]+kop21;
	if (G(fc1) && begin_G(fc2) && !(VA[fc2]&BIT6)) {
	  if (begin_G(fc1)) TEG[fc1] = min_1;
	  else {
	    if (dvg_1 >= dgg_1) {
	      if (VG_TIJD(fc1)) TEG[fc1] = dvg_1-(Int16)waarde_VG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    } else {
	      if (GG_TIJD(fc1)) TEG[fc1] = dgg_1-(Int16)waarde_GG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    }
	    if (TEG[fc1]<0) TEG[fc1] = 0;
	  }
	}
   }
 } 

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) {
   dvg_1 = (Int16)inst_VG_TIJD(fc1)/10;
   dvg_2 = (Int16)inst_VG_TIJD(fc2)/10;
   dgg_1 = (Int16)inst_GG_TIJD(fc1)/10;
   dgg_2 = (Int16)inst_GG_TIJD(fc2)/10;
   kop12 = (Int16)inst_TIJD(kpt12)/10;
   kop21 = (Int16)inst_TIJD(kpt21)/10;

   dvg_3 = (Int16)inst_VG_TIJD(vtg3)/10;
   dgg_3 = (Int16)inst_GG_TIJD(vtg3)/10;
   kop13 = (Int16)inst_TIJD(kpt13)/10;
   kop23 = (Int16)inst_TIJD(kpt23)/10;
   kop31 = (Int16)inst_TIJD(kpt31)/10;
   kop32 = (Int16)inst_TIJD(kpt32)/10;

   min_1 = dvg_1; min_2 = dvg_2; min_3 = dvg_3;
   if (dgg_1 > min_1) min_1 = dgg_1;
   if (dgg_2 > min_2) min_2 = dgg_2;
   if (dgg_3 > min_3) min_3 = dgg_3;

   if (TIJD(kpt12)) {
	akt12 = (Int16)waarde_TIJD(kpt12)/10;
   } else {
	akt12 = 0;
   }

   if (TIJD(kpt13)) {
	akt13 = (Int16)waarde_TIJD(kpt13)/10;
   } else {
	akt13 = 0;
   }

   if (TIJD(kpt21)) {
	akt21 = (Int16)waarde_TIJD(kpt21)/10;
   } else {
	akt21 = 0;
   }

   if (TIJD(kpt23)) {
	akt23 = (Int16)waarde_TIJD(kpt23)/10;
   } else {
	akt23 = 0;
   }

   if (TIJD(kpt31)) {
	akt31 = (Int16)waarde_TIJD(kpt31)/10;
   } else {
	akt31 = 0;
   }

   if (TIJD(kpt32)) {
	akt32 = (Int16)waarde_TIJD(kpt32)/10;
   } else {
	akt32 = 0;
   }

   if ((fc3 < 0) && (fc4 < 0) && (fc5 < 0) && (fc6 < 0)) {
	if (begin_G(fc1) && (VA[fc1]&BIT6) && RVG(fc2) ) HG[fc2]  |= BIT2;
	if (begin_G(fc1) && (VA[fc1]&BIT6) && RVG(vtg3)) HG[vtg3] |= BIT2;
	if (begin_G(fc2) && (VA[fc2]&BIT6) && RVG(fc1) ) HG[fc1]  |= BIT2;
	if (begin_G(fc2) && (VA[fc2]&BIT6) && RVG(vtg3)) HG[vtg3] |= BIT2;

	if (begin_G(vtg3) && DRK[kpa31]    && RVG(fc1) ) HG[fc1]  |= BIT2;
	if (begin_G(vtg3) && DRK[kpa32]    && RVG(fc2) ) HG[fc2]  |= BIT2;
   }
   if (begin_G(fc1)  || HG[fc1] ) TEG[fc1]  = min_1;
   if (begin_G(fc2)  || HG[fc2] ) TEG[fc2]  = min_2;
   if (begin_G(vtg3) || HG[vtg3]) TEG[vtg3] = min_3;

   if (begin_G(fc1) && (VA[fc1]&BIT6)) {
     if ((kop12 > TEG[fc2] ) && G(fc2) ) TEG[fc2]  = kop12;
     if ((kop13 > TEG[vtg3]) && G(vtg3)) TEG[vtg3] = kop13;
   }
   if (begin_G(fc2) && (VA[fc2]&BIT6)) {
     if ((kop21 > TEG[fc1] ) && G(fc1) ) TEG[fc1]  = kop21;
     if ((kop23 > TEG[vtg3]) && G(vtg3)) TEG[vtg3] = kop23;
   }
   if (begin_G(vtg3) && DRK[kpa31]) {
     if ((kop31 > TEG[fc1]) && G(fc1)) TEG[fc1] = kop31;
   }
   if (begin_G(vtg3) && DRK[kpa32]) {
     if ((kop32 > TEG[fc2]) && G(fc2)) TEG[fc2] = kop32;
   }

   if (HG[fc1]) {
	TEG[fc1] += TTR[fc1];
	if ((kop21 - akt21) > TEG[fc1]) TEG[fc1] = kop21 - akt21;
	if ((kop31 - akt31) > TEG[fc1]) TEG[fc1] = kop31 - akt31;
	if (G(fc1)) HG[fc1] = FALSE;
	if (G(fc2)  && ((TTR[fc1]+kop12) > TEG[fc2] )) TEG[fc2]  = TTR[fc1]+kop12;
	if (G(vtg3) && ((TTR[fc1]+kop13) > TEG[vtg3])) TEG[vtg3] = TTR[fc1]+kop13;
	if (G(fc2) && begin_G(fc1) && !(VA[fc1]&BIT6)) {
	  if (begin_G(fc2)) TEG[fc2] = min_2;
	  else {
	    if (dvg_2 >= dgg_2) {
	      if (VG_TIJD(fc2)) TEG[fc2] = dvg_2-(Int16)waarde_VG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
	    } else {
	      if (GG_TIJD(fc2)) TEG[fc2] = dgg_2-(Int16)waarde_GG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
		}
	    if (TEG[fc2]<0) TEG[fc2] = 0;
	  }
	}
	if (G(vtg3) && begin_G(fc1) && !(VA[fc1]&BIT6)) {
	  if (begin_G(vtg3)) TEG[vtg3] = min_3;
	  else {
	    if (dvg_3 >= dgg_3) {
	      if (VG_TIJD(vtg3)) TEG[fc3] = dvg_3-(Int16)waarde_VG_TIJD(fc3)/10;
	      else               TEG[fc3] = 0;
	    } else {
	      if (GG_TIJD(vtg3)) TEG[fc3] = dgg_3-(Int16)waarde_GG_TIJD(fc3)/10;
	      else               TEG[fc3] = 0;
	    }
	    if (TEG[vtg3]<0) TEG[vtg3] = 0;
	  }
	}
   }
   if (HG[fc2]) {
	TEG[fc2] += TTR[fc2];
	if ((kop12 - akt12) > TEG[fc2]) TEG[fc2] = kop12 - akt12;
	if ((kop32 - akt32) > TEG[fc2]) TEG[fc2] = kop32 - akt32;
	if (G(fc2)) HG[fc2] = FALSE;
	if (G(fc1)  && ((TTR[fc2]+kop21) > TEG[fc1] )) TEG[fc1]  = TTR[fc2]+kop21;
	if (G(vtg3) && ((TTR[fc2]+kop23) > TEG[vtg3])) TEG[vtg3] = TTR[fc2]+kop23;
	if (G(fc1) && begin_G(fc2) && !(VA[fc2]&BIT6)) {
	  if (begin_G(fc1)) TEG[fc1] = min_1;
	  else {
	    if (dvg_1 >= dgg_1) {
	      if (VG_TIJD(fc1)) TEG[fc1] = dvg_1-(Int16)waarde_VG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    } else {
	      if (GG_TIJD(fc1)) TEG[fc1] = dgg_1-(Int16)waarde_GG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    }
	    if (TEG[fc1]<0) TEG[fc1] = 0;
	  }
	}
	if (G(vtg3) && begin_G(fc2) && !(VA[fc2]&BIT6)) {
	  if (begin_G(vtg3)) TEG[vtg3] = min_3;
	  else {
	    if (dvg_3 >= dgg_3) {
	      if (VG_TIJD(vtg3)) TEG[fc3] = dvg_3-(Int16)waarde_VG_TIJD(fc3)/10;
	      else               TEG[fc3] = 0;
	    } else {
	      if (GG_TIJD(vtg3)) TEG[fc3] = dgg_3-(Int16)waarde_GG_TIJD(fc3)/10;
	      else               TEG[fc3] = 0;
	    }
	    if (TEG[vtg3]<0) TEG[vtg3] = 0;
	  }
	}
   }
   if (HG[vtg3]) {
	TEG[vtg3] += TTR[vtg3];
	if ((kop13 - akt13) > TEG[vtg3]) TEG[vtg3] = kop13 - akt13;
	if ((kop23 - akt23) > TEG[vtg3]) TEG[vtg3] = kop23 - akt23;
	if (G(vtg3)) HG[vtg3] = FALSE;
	if (G(fc1) && ((TTR[vtg3]+kop31) > TEG[fc1])) TEG[fc1] = TTR[vtg3]+kop31;
	if (G(fc2) && ((TTR[vtg3]+kop32) > TEG[fc2])) TEG[fc2] = TTR[vtg3]+kop32;
	if (G(fc1) && begin_G(vtg3) && !DRK[kpa31]) {
	  if (begin_G(fc1)) TEG[fc1] = min_1;
	  else {
	    if (dvg_1 >= dgg_1) {
	      if (VG_TIJD(fc1)) TEG[fc1] = dvg_1-(Int16)waarde_VG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    } else {
	      if (GG_TIJD(fc1)) TEG[fc1] = dgg_1-(Int16)waarde_GG_TIJD(fc1)/10;
	      else              TEG[fc1] = 0;
	    }
	    if (TEG[fc1]<0) TEG[fc1] = 0;
	  }
	}
	if (G(fc2) && begin_G(vtg3) && !DRK[kpa32]) {
	  if (begin_G(fc2)) TEG[fc2] = min_2;
	  else {
	    if (dvg_2 >= dgg_2) {
	      if (VG_TIJD(fc2)) TEG[fc2] = dvg_2-(Int16)waarde_VG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
	    } else {
	      if (GG_TIJD(fc2)) TEG[fc2] = dgg_2-(Int16)waarde_GG_TIJD(fc2)/10;
	      else              TEG[fc2] = 0;
	    }
	    if (TEG[fc2]<0) TEG[fc2] = 0;
	  }
	}
   }
   /* 1x extra vanwege 3e voetganger */
   if (begin_G(fc1) && (VA[fc1]&BIT6)) {
     if ((kop12 > TEG[fc2] ) && G(fc2) ) TEG[fc2]  = kop12;
     if ((kop13 > TEG[vtg3]) && G(vtg3)) TEG[vtg3] = kop13;
   }
   if (begin_G(fc2) && (VA[fc2]&BIT6)) {
     if ((kop21 > TEG[fc1] ) && G(fc1) ) TEG[fc1]  = kop21;
     if ((kop23 > TEG[vtg3]) && G(vtg3)) TEG[vtg3] = kop23;
   }
   if (begin_G(vtg3) && DRK[kpa31]) {
     if ((kop31 > TEG[fc1]) && G(fc1)) TEG[fc1] = kop31;
   }
   if (begin_G(vtg3) && DRK[kpa32]) {
     if ((kop32 > TEG[fc2]) && G(fc2)) TEG[fc2] = kop32;
   }
 }

 /* Fik150301  toegevoegd "fcx >= 0" */
 if (fc1  >= 0) PEG[fc1]  = TEG[fc1];
 if (fc2  >= 0) PEG[fc2]  = TEG[fc2];
 if (vtg3 >= 0) PEG[vtg3] = TEG[vtg3];

 if ((fc3 >= 0) && (fc4 >= 0)) {
   kop3s = (Int16)inst_TIJD(kpt3s)/10;
   kop3e = (Int16)inst_TIJD(kpt3e)/10;
   if (begin_G(fc3)) {
     if (((TEG[fc3] + kop3s) > TEG[fc4]) && G(fc4))
           TEG[fc4] = TEG[fc3] + kop3s;
     if (((PEG[fc3] + kop3s) > PEG[fc4]) && G(fc4))
           PEG[fc4] = PEG[fc3] + kop3s;
   }
   if (G(fc3)) {
     if (((TEG[fc3] + kop3e) > TEG[fc4]) && G(fc4))
				TEG[fc4] = TEG[fc3] + kop3e;
     if (((PEG[fc3] + kop3e) > PEG[fc4]) && G(fc4))
				PEG[fc4] = PEG[fc3] + kop3e;
   }
 }
 if ((fc5 >= 0) && (fc6 >= 0)) {
   kop5s = (Int16)inst_TIJD(kpt5s)/10;
   kop5e = (Int16)inst_TIJD(kpt5e)/10;
   if (begin_G(fc5)) {
     if (((TEG[fc5] + kop5s) > TEG[fc6]) && G(fc6))
           TEG[fc6] = TEG[fc5] + kop5s;
     if (((PEG[fc5] + kop5s) > PEG[fc6]) && G(fc6))
           PEG[fc6] = PEG[fc5] + kop5s;
   }
   if (G(fc5)) {
     if (((TEG[fc5] + kop5e) > TEG[fc6]) && G(fc6))
				TEG[fc6] = TEG[fc5] + kop5e;
     if (((PEG[fc5] + kop5e) > PEG[fc6]) && G(fc6))
				PEG[fc6] = PEG[fc5] + kop5e;
   }
 }
}

/* PROCEDURE CORRIGEER TEG[] VOOR SERIELE KOPPELING */
/* ================================================ */

void corr_hkitegcrsv()
{
 Int16 fc1,fc2,fc3,stat,i,j,x;
 Int16 kopsg12,kopsg23;
 Int16 kopeg12,kopeg23;
 Int16 kopdm12,kopdm23;
 Int16 garant2,garant3;
 Int16 akt;
 Int16 bufteg2,bufteg3;
 Int16 bufpeg2,bufpeg3;
 Int16 _peg;

 for (i=0; i<aant_hki; i++) {
	fc2 = hki[i][1];
	fc3 = hki[i][10];
												/* bepaal juiste startwaarde TEG[] en PEG[] */
	if (KG[fc2] > ALTM[fc2]) TEG[fc2] = 0;
	if (KG[fc2] > KAPM[fc2]) PEG[fc2] = 0;

	if (!(PVAS[fc2]&BIT5)) {					/* Corrigeer PEG[] als afbreken niet is toegestaan */
		_peg = 0;
		if (!(HVAS[fc2]&BIT3)) {
			if (begin_G(fc2) && (VA[fc2]&BIT4) || G(fc2) && ((HVAS[fc2]&BIT0) || (HVAS[fc2]&BIT4))) {
						if (STAP <= VAS4[fc2]) _peg = VAS4[fc2] - STAP;
						else                   _peg = CTYD - STAP + VAS4[fc2];
			}
		}
		if (_peg > PEG[fc2]) PEG[fc2] = _peg;
	}

	if (fc3 >= 0) {
		if (KG[fc3] > ALTM[fc3]) TEG[fc3] = 0;
		if (KG[fc3] > KAPM[fc3]) PEG[fc3] = 0;

		if (!(PVAS[fc3]&BIT5)) {				/* Corrigeer PEG[] als afbreken niet is toegestaan */
			_peg = 0;
			if (!(HVAS[fc3]&BIT3)) {
				if (begin_G(fc3) && (VA[fc3]&BIT4) || G(fc3) && ((HVAS[fc3]&BIT0) || (HVAS[fc3]&BIT4))) {
							if (STAP <= VAS4[fc3]) _peg = VAS4[fc3] - STAP;
							else                   _peg = CTYD - STAP + VAS4[fc3];
				}
			}
			if (_peg > PEG[fc3]) PEG[fc3] = _peg;
		}
	}
 }

 for (x=0; x<3; x++) {							/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kopsg12 = (Int16)inst_TIJD(hki[i][3])/10;
	kopeg12 = (Int16)inst_TIJD(hki[i][4])/10;
	kopdm12 = (Int16)inst_TIJD(hki[i][5])/10;
	garant2 = (Int16)inst_GG_TIJD(fc2)/10;
	fc3     = hki[i][10];
	stat    = hki[i][20];

	if (fc3 >= 0) {
		kopsg23 = (Int16)inst_TIJD(hki[i][12])/10;
		kopeg23 = (Int16)inst_TIJD(hki[i][13])/10;
		kopdm23 = (Int16)inst_TIJD(hki[i][14])/10;
		garant3 = (Int16)inst_GG_TIJD(fc3)/10;
	} else {
		kopsg23 = 0;
		kopeg23 = 0;
		kopdm23 = 0;
		garant3 = 0;
	}

	if (stat >= 2) {						/* koppeling is aktief */

		bufteg2 = bufpeg2 = 0;

		if (G(fc1) || G(fc2) || HG_hki[i][fc2]) {
			bufteg2 = TEG[fc2];
			bufpeg2 = PEG[fc2];

			HG_hki[i][fc2] &= (~BIT1);
			HG_hki[i][fc2] &= (~BIT2);
			if (G(fc2)) HG_hki[i][fc2] &= (~BIT3);

			if (!G(fc2)) HG_hki[i][fc2] |= BIT1;
			if (!G(fc2) && (TTP[fc1] != 0)) HG_hki[i][fc2] |= BIT2;
			TEG[fc2] = PEG[fc2] = FALSE;

			if (!G(fc2)) {
				TEG[fc2] = TTR[fc2] + ALTM[fc2];
				PEG[fc2] = TTR[fc2] + KAPM[fc2];
			}
			if (begin_G(fc2)) { TEG[fc2] = ALTM[fc2]; PEG[fc2] = KAPM[fc2]; }
			else {
				if (G(fc2) && (ALTM[fc2] > KG[fc2])) TEG[fc2] = ALTM[fc2] - KG[fc2];
				if (G(fc2) && (KAPM[fc2] > KG[fc2])) PEG[fc2] = KAPM[fc2] - KG[fc2];
			}
			if (MVG(fc2) && (KG[fc2] >= garant2)) { TEG[fc2] = PEG[fc2] = FALSE; }
			else {
				if (MVG(fc2) && GG_TIJD(fc2)) {
					TEG[fc2] = (Int16)(garant2 - (waarde_GG_TIJD(fc2)/10));
					PEG[fc2] = (Int16)(garant2 - (waarde_GG_TIJD(fc2)/10));
					if (TEG[fc2] < 0) TEG[fc2] = 0;
					if (PEG[fc2] < 0) PEG[fc2] = 0;
				}
			}
			if (G(fc1)) {
				if (begin_G(fc1) && ((kopsg12 + kopdm12) > TEG[fc2]))
					TEG[fc2] = kopsg12 + kopdm12;
				if (TEG[fc1] + kopeg12 + kopdm12 > TEG[fc2])
					TEG[fc2] = TEG[fc1] + kopeg12 + kopdm12;
				if (begin_G(fc1) && ((kopsg12 + kopdm12) > PEG[fc2]))
					PEG[fc2] = kopsg12 + kopdm12;
				if (PEG[fc1] + kopeg12 + kopdm12 > PEG[fc2])
					PEG[fc2] = PEG[fc1] + kopeg12 + kopdm12;
			}
			if (TIJD(hki[i][3])) {	/* koppeltijd vanaf start groen */
				akt = (Int16)waarde_TIJD(hki[i][3])/10;
				if ((kopsg12 - akt + kopdm12) > TEG[fc2]) TEG[fc2] = kopsg12 - akt + kopdm12;
				if ((kopsg12 - akt + kopdm12) > PEG[fc2]) PEG[fc2] = kopsg12 - akt + kopdm12;
			}
			if (TIJD(hki[i][4])) {	/* koppeltijd vanaf einde groen */
				akt = (Int16)waarde_TIJD(hki[i][4])/10;
				if ((kopeg12 - akt + kopdm12) > TEG[fc2]) TEG[fc2] = kopeg12 - akt + kopdm12;
				if ((kopeg12 - akt + kopdm12) > PEG[fc2]) PEG[fc2] = kopeg12 - akt + kopdm12;
			}
			if (TIJD(hki[i][5])) {	/* duur max. na koppeling */
				akt = (Int16)waarde_TIJD(hki[i][5])/10;
				if ((kopdm12 - akt) > TEG[fc2])           TEG[fc2] = kopdm12 - akt;
				if ((kopdm12 - akt) > PEG[fc2])           PEG[fc2] = kopdm12 - akt;
			}
		}

		if (fc3 >= 0) {

			if (G(fc1) || G(fc2) || G(fc3) || HG_hki[i][fc3]) {
				bufteg3 = TEG[fc3];
				bufpeg3 = PEG[fc3];

				HG_hki[i][fc3] &= (~BIT1);
				HG_hki[i][fc3] &= (~BIT2);
				if (G(fc3)) HG_hki[i][fc3] &= (~BIT3);
				if (G(fc2) && BW_hki[i][fc2] || G(fc3)) HG_hki[i][fc3] &= (~BIT5);

				if (!G(fc3) && (!G(fc2) || BW_hki[i][fc2])) HG_hki[i][fc3] |= BIT1;
				if ((HG_hki[i][fc2]&BIT2) || G(fc2) && BW_hki[i][fc2] && !G(fc3) && (TTP[fc2] != 0)) HG_hki[i][fc3] |= BIT2;
				TEG[fc3] = PEG[fc3] = FALSE;

				if (!G(fc3) && (!G(fc2) || BW_hki[i][fc2])) {
					TEG[fc3] = TTR[fc3] + ALTM[fc3];
					PEG[fc3] = TTR[fc3] + KAPM[fc3];
				}
				if (begin_G(fc3)) { TEG[fc3] = ALTM[fc3]; PEG[fc3] = KAPM[fc3]; }
				else {
					if (G(fc3) && (ALTM[fc3] > KG[fc3])) TEG[fc3] = ALTM[fc3] - KG[fc3];
					if (G(fc3) && (KAPM[fc3] > KG[fc3])) PEG[fc3] = KAPM[fc3] - KG[fc3];
				}
				if (MVG(fc3) && (KG[fc3] >= garant3)) { TEG[fc3] = PEG[fc3] = FALSE; }
				else {
					if (MVG(fc3) && GG_TIJD(fc3)) {
						TEG[fc3] = (Int16)(garant3 - (waarde_GG_TIJD(fc3)/10));
						PEG[fc3] = (Int16)(garant3 - (waarde_GG_TIJD(fc3)/10));
						if (TEG[fc3] < 0) TEG[fc3] = 0;
						if (PEG[fc3] < 0) PEG[fc3] = 0;
					}
				}
				if (!G(fc2) && HG_hki[i][fc2]) {
					if ((TTR[fc2] + kopsg23 + kopdm23) > TEG[fc3])
						TEG[fc3] = TTR[fc2] + kopsg23 + kopdm23;
					if ((TEG[fc2] + kopeg23 + kopdm23) > TEG[fc3])
						TEG[fc3] = TEG[fc2] + kopeg23 + kopdm23;
					if ((TTR[fc2] + kopsg23 + kopdm23) > PEG[fc3])
						PEG[fc3] = TTR[fc2] + kopsg23 + kopdm23;
					if ((PEG[fc2] + kopeg23 + kopdm23) > PEG[fc3])
						PEG[fc3] = PEG[fc2] + kopeg23 + kopdm23;
				}
				if (G(fc2) && BW_hki[i][fc2]) {
					if (begin_G(fc2) && ((kopsg23 + kopdm23) > TEG[fc3]))
						TEG[fc3] = kopsg23 + kopdm23;
					if (TEG[fc2] + kopeg23 + kopdm23 > TEG[fc3])
						TEG[fc3] = TEG[fc2] + kopeg23 + kopdm23;
					if (begin_G(fc2) && ((kopsg23 + kopdm23) > PEG[fc3]))
						PEG[fc3] = kopsg23 + kopdm23;
					if (PEG[fc2] + kopeg23 + kopdm23 > PEG[fc3])
						PEG[fc3] = PEG[fc2] + kopeg23 + kopdm23;
				}
				if (TIJD(hki[i][12])) {	/* koppeltijd vanaf start groen */
					akt = (Int16)waarde_TIJD(hki[i][12])/10;
					if ((kopsg23 - akt + kopdm23) > TEG[fc3]) TEG[fc3] = kopsg23 - akt + kopdm23;
					if ((kopsg23 - akt + kopdm23) > PEG[fc3]) PEG[fc3] = kopsg23 - akt + kopdm23;
				}
				if (TIJD(hki[i][13])) {	/* koppeltijd vanaf einde groen */
					akt = (Int16)waarde_TIJD(hki[i][13])/10;
					if ((kopeg23 - akt + kopdm23) > TEG[fc3]) TEG[fc3] = kopeg23 - akt + kopdm23;
					if ((kopeg23 - akt + kopdm23) > PEG[fc3]) PEG[fc3] = kopeg23 - akt + kopdm23;
				}
				if (TIJD(hki[i][14])) {	/* duur max. na koppeling */
					akt = (Int16)waarde_TIJD(hki[i][14])/10;
					if ((kopdm23 - akt) > TEG[fc3])           TEG[fc3] = kopdm23 - akt;
					if ((kopdm23 - akt) > PEG[fc3])           PEG[fc3] = kopdm23 - akt;
				}
				if (bufteg3 > TEG[fc3]) TEG[fc3] = bufteg3;
				if (bufpeg3 > PEG[fc3]) PEG[fc3] = bufteg3;
			}
		}

		if (bufteg2 > TEG[fc2]) TEG[fc2] = bufteg2;
		if (bufpeg2 > PEG[fc2]) PEG[fc2] = bufteg2;

	} else {							/* koppeling is niet aktief */
		HG_hki[i][fc2] &= (~BIT1);
		HG_hki[i][fc2] &= (~BIT2);
		HG_hki[i][fc2] &= (~BIT3);
		if (fc3 >= 0) {
			HG_hki[i][fc3] &= (~BIT1);
			HG_hki[i][fc3] &= (~BIT2);
			HG_hki[i][fc3] &= (~BIT3);
			HG_hki[i][fc3] &= (~BIT5);
		}
	}
    }

    for (i=0; i<aant_hki; i++) {					/* bepaal HG[] per signaalgroep voor hki koppelingen */
	for (j=0; j<NUMSG_CS; j++) {
		if ((j == hki[i][0]) || (j == hki[i][1]) || (j == hki[i][10])) {
			HG[j] &= (~BIT1);
			HG[j] &= (~BIT2);
			HG[j] &= (~BIT3);
			HG[j] &= (~BIT5);
		}
        }
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (HG_hki[i][j]&BIT1) HG[j] |= BIT1;
		if (HG_hki[i][j]&BIT2) HG[j] |= BIT2;
		if (HG_hki[i][j]&BIT3) HG[j] |= BIT3;
		if (HG_hki[i][j]&BIT5) HG[j] |= BIT5;
	}
    }
 }
}

/* PROCEDURE BEPAAL TIJD TOT ALTERNATIEVE REALISATIE, TTR[] */
/* ======================================================== */

void proc_bttr_crsv()
{
 Int16 i,j,k;
 Int16 max,extra,ontruim;
 Int16 rest;

 for (i=0; i<NUMSG_CS; i++) {

   if (R(i) && !GR_TIJD(i) && (DA(i) || MA(i) || (ALED[i] > 0)) && !(VA[i]&BIT1) && !BL_OP(i)) {
     if (!VA[i]) VA[i] |= BIT7;			/* Start detectie- cq mee-aanvraag */
     VA[i] |= BIT1;
   }

   TTK[i] = TEP[i] = 255;	/* Initialisatie TTK[] en TEP[] */
   if (G(i)) TTR[i] = FALSE;	/* Reset  TTR[] */
   else {			/* Bepaal TTR[] */
	  max = 0;
          if (GL(i)) {
	   if (GL_TIJD(i)) {
             max=(Int16)(inst_GL_TIJD(i)-waarde_GL_TIJD(i)+inst_GR_TIJD(i))/10;
	   } else max=(Int16)(inst_GR_TIJD(i))/10;  
	  }
	  if (GR_TIJD(i))
	  max=(Int16)(inst_GR_TIJD(i)-waarde_GR_TIJD(i))/10;

	  extra = 0;
	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];
				/* Conflict is groen */
	    if (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) {

	      extra  = 2;	/* 2 sec. extra i.v.m. afrondingsfouten */
	      ontruim= 0;
	      if (j<aant_gcf[i]) {
		ontruim=(Int16)(inst_GL_TIJD(k)+inst_O_TIJD(k,i))/10;
	      }
	      ontruim+=TEG[k];
	      if (ontruim > max) max = ontruim;
	    } else {
	      if (j<aant_gcf[i]) {
	        if (GL(k)) {
		  if (GL_TIJD(k)) {
		    ontruim=(Int16)(inst_GL_TIJD(k)-waarde_GL_TIJD(k)
				   +inst_O_TIJD(k,i))/10;
		  } else ontruim=(Int16)(inst_O_TIJD(k,i))/10;
		  if (ontruim > max) max = ontruim;
	        } else {
		  if (R(k) && O_TIJD(k,i)) {
		    ontruim=(Int16)(inst_O_TIJD(k,i)-waarde_O_TIJD(k,i))/10;
		    if (ontruim > max) max = ontruim;
		  }
	        }
	      }
	    }
	  }
          if ((ROG(i) || RVG(i)) && (extra==2) || WR(i) && (extra==0)) extra = 1;
	  TTR[i] = max + extra;
      }

   if (G(i)) TTR_WV[i] = FALSE;	/* Reset  TTR_WV[] */
   else {			/* Bepaal TTR_WV[] */
	  max = 0;
          if (GL(i)) {
	   if (GL_TIJD(i)) {
             max=(Int16)(inst_GL_TIJD(i)-waarde_GL_TIJD(i)+inst_GR_TIJD(i));
	   } else max=(Int16)(inst_GR_TIJD(i));  
	  }
	  if (GR_TIJD(i))
	  max=(Int16)(inst_GR_TIJD(i)-waarde_GR_TIJD(i));

	  extra = 0;
	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];
				/* Conflict is groen */
	    if (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) {

	      ontruim= 0;
	      if (j<aant_gcf[i]) {
		ontruim=(Int16)(inst_GL_TIJD(k)+inst_O_TIJD(k,i));
	      }
	      ontruim+=(TEG[k]*10);
	      if (ontruim > max) max = ontruim;
	    } else {
	      if (j<aant_gcf[i]) {
	        if (GL(k)) {
		  if (GL_TIJD(k)) {
		    ontruim=(Int16)(inst_GL_TIJD(k)-waarde_GL_TIJD(k)
				   +inst_O_TIJD(k,i));
		  } else ontruim=(Int16)(inst_O_TIJD(k,i));
		  if (ontruim > max) max = ontruim;
	        } else {
		  if (R(k) && O_TIJD(k,i)) {
		    ontruim=(Int16)(inst_O_TIJD(k,i)-waarde_O_TIJD(k,i));
		    if (ontruim > max) max = ontruim;
		  }
	        }
	      }
	    }
	  }
	  TTR_WV[i] = max;
      }

   if (begin_G(i)) VG1[i] = TRUE;
   else	{
#ifdef RWSC_old
	 if (einde_G(i) || !VG(i) && !H1e_TIJD(i) ) VG1[i] = FALSE;
#else
	 if (einde_G(i) || !VG(i) && !H1e_loopt(i)) VG1[i] = FALSE;
#endif
   }

#ifdef RWSC_old
   if (G(i) && (VG1[i] || H2e_TIJD(i) ) && (HVAS[i]&BIT0)) YV[i] |= BIT1;
   if (G(i) && (VG1[i] || H2e_TIJD(i) ))                   YV[i] |= BIT2;
#else
   if (G(i) && (VG1[i] || H2e_loopt(i)) && (HVAS[i]&BIT0)) YV[i] |= BIT1;
   if (G(i) && (VG1[i] || H2e_loopt(i)))                   YV[i] |= BIT2;
#endif
 }

 for (i=0; i<NUMSG_CS; i++) {

   if (G(i)) TTW[i] = FALSE;	/* Reset  TTW[] */
   else {			/* Bepaal TTW[] */
	  max = 0;
          if (GL(i)) {
	   if (GL_TIJD(i)) {
             max=(Int16)(inst_GL_TIJD(i)-waarde_GL_TIJD(i)+inst_GR_TIJD(i))/10;
	   } else max=(Int16)(inst_GR_TIJD(i))/10;  
	  }
	  if (GR_TIJD(i))
	  max=(Int16)(inst_GR_TIJD(i)-waarde_GR_TIJD(i))/10;

	  extra = 0;
	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];
				/* Conflict is groen */
	    if (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) {

	      extra  = 2;	/* 2 sec. extra i.v.m. afrondingsfouten */
	      ontruim= 0;
	      if (j<aant_gcf[i]) {
		ontruim=(Int16)(inst_GL_TIJD(k)+inst_O_TIJD(k,i))/10;
	      }

	      rest = 0;
	      if (VG(k)) rest = (Int16)((inst_VG_TIJD(k)/10) - (waarde_VG_TIJD(k)/10));
	      if (!G(k)) rest = (Int16)((inst_VG_TIJD(k)/10) + TTR[k]);

	      ontruim+=rest;
	      if (ontruim > max) max = ontruim;
	    } else {
	      if (j<aant_gcf[i]) {
	        if (GL(k)) {
		  if (GL_TIJD(k)) {
		    ontruim=(Int16)(inst_GL_TIJD(k)-waarde_GL_TIJD(k)
				   +inst_O_TIJD(k,i))/10;
		  } else ontruim=(Int16)(inst_O_TIJD(k,i))/10;
		  if (ontruim > max) max = ontruim;
	        } else {
		  if (R(k) && O_TIJD(k,i)) {
		    ontruim=(Int16)(inst_O_TIJD(k,i)-waarde_O_TIJD(k,i))/10;
		    if (ontruim > max) max = ontruim;
		  }
	        }
	      }
	    }
	  }
          if ((ROG(i) || RVG(i)) && (extra==2) || WR(i) && (extra==0)) extra = 1;
	  TTW[i] = max + extra;
      }
 }

 for (i=0; i<aant_fts; i++) {
   proc_cttr_crsv_vtg_fts(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_cttr_crsv_vtg_fts(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
 }
 for (i=0; i<aant_gov; i++) {
   proc_cttr_crsv_vtg_fts(gov[i][0],gov[i][1],gov[i][7]
			 ,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
 }
 proc_cttr_crsv_hki();
}

/* PROCEDURE CORRIGEER TTR[] VOOR FIETS.VOETGANGERSKOPPELINGEN */
/* =========================================================== */

void proc_cttr_crsv_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 (vtg)	*/
	Int16 fc2,	/* Signaalgroep 2 (vtg)	*/
	Int16 fc3,	/* Gekoppelde.fietsr. 1	*/
	Int16 fc4,	/* Gekoppelde.fietsr. 2	*/
	Int16 fc5,	/* Gekoppelde.fietsr. 3	*/
	Int16 fc6,	/* Gekoppelde.fietsr. 4	*/
	Int16 fc7)	/* Signaalgroep 3e voetganger */
{
 Int16 _maxTTR = 0;
 Int16 _maxTTW = 0;
 Int16 _maxTTR_WV = 0;

 /* Bepaal TTR */
 /* ---------- */

 if (fc1 >= 0) {
	if (TTR[fc1]    > _maxTTR   ) _maxTTR    = TTR[fc1];
	if (TTW[fc1]    > _maxTTW   ) _maxTTW    = TTW[fc1];
	if (TTR_WV[fc1] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc1];
 }
 if (fc2 >= 0) {
	if (TTR[fc2]    > _maxTTR   ) _maxTTR    = TTR[fc2];
	if (TTW[fc2]    > _maxTTW   ) _maxTTW    = TTW[fc2];
	if (TTR_WV[fc2] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc2];
 }
 if (fc3 >= 0) {
	if (TTR[fc3]    > _maxTTR   ) _maxTTR    = TTR[fc3];
	if (TTW[fc3]    > _maxTTW   ) _maxTTW    = TTW[fc3];
	if (TTR_WV[fc3] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc3];
 }
 if (fc4 >= 0) {
	if (TTR[fc4]    > _maxTTR   ) _maxTTR    = TTR[fc4];
	if (TTW[fc4]    > _maxTTW   ) _maxTTW    = TTW[fc4];
	if (TTR_WV[fc4] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc4];
 }
 if (fc5 >= 0) {
	if (TTR[fc5]    > _maxTTR   ) _maxTTR    = TTR[fc5];
	if (TTW[fc5]    > _maxTTW   ) _maxTTW    = TTW[fc5];
	if (TTR_WV[fc5] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc5];
 }
 if (fc6 >= 0) {
	if (TTR[fc6]    > _maxTTR   ) _maxTTR    = TTR[fc6];
	if (TTW[fc6]    > _maxTTW   ) _maxTTW    = TTW[fc6];
	if (TTR_WV[fc6] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc6];
 }
 if (fc7 >= 0) {
	if (TTR[fc7]    > _maxTTR   ) _maxTTR    = TTR[fc7];
	if (TTW[fc7]    > _maxTTW   ) _maxTTW    = TTW[fc7];
	if (TTR_WV[fc7] > _maxTTR_WV) _maxTTR_WV = TTR_WV[fc7];
 }

 if (fc1 >= 0) { TTR[fc1] = _maxTTR; TTW[fc1] = _maxTTW; TTR_WV[fc1] = _maxTTR_WV; }
 if (fc2 >= 0) { TTR[fc2] = _maxTTR; TTW[fc2] = _maxTTW; TTR_WV[fc2] = _maxTTR_WV; }
 if (fc3 >= 0) { TTR[fc3] = _maxTTR; TTW[fc3] = _maxTTW; TTR_WV[fc3] = _maxTTR_WV; }
 if (fc4 >= 0) { TTR[fc4] = _maxTTR; TTW[fc4] = _maxTTW; TTR_WV[fc4] = _maxTTR_WV; }
 if (fc5 >= 0) { TTR[fc5] = _maxTTR; TTW[fc5] = _maxTTW; TTR_WV[fc5] = _maxTTR_WV; }
 if (fc6 >= 0) { TTR[fc6] = _maxTTR; TTW[fc6] = _maxTTW; TTR_WV[fc6] = _maxTTR_WV; }
 if (fc7 >= 0) { TTR[fc7] = _maxTTR; TTW[fc7] = _maxTTW; TTR_WV[fc7] = _maxTTR_WV; }

 /* Bepaal fictieve aanvragen voetgangers onderling */
 /* ----------------------------------------------- */

 if ((fc1 >= 0) && (fc2 >= 0) && (fc7 < 0)) {
	if (R(fc1) && VA[fc1] && !(VA[fc1]&BIT7) || (HVAS[fc1]&BIT5)) {
		FCA[fc2] |=   BIT0;
	} else {
		FCA[fc2] &= (~BIT0);
	}
	if (R(fc2) && VA[fc2] && !(VA[fc2]&BIT7) || (HVAS[fc2]&BIT5)) {
		FCA[fc1] |=   BIT0;
	} else {
		FCA[fc1] &= (~BIT0);
	}
 } else {
        if (fc7 < 0) {
		if (fc1 >= 0) FCA[fc1] &= (~BIT0);
		if (fc2 >= 0) FCA[fc2] &= (~BIT0);
        }
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (fc7 >= 0)) {
	if (R(fc1) && VA[fc1] && !(VA[fc1]&BIT7) || (HVAS[fc1]&BIT5) ||
           (R(fc2) && VA[fc2] && !(VA[fc2]&BIT7) || (HVAS[fc2]&BIT5))) {
		FCA[fc7] |=   BIT0;
	} else {
		FCA[fc7] &= (~BIT0);
	}
	if (R(fc1) && VA[fc1] && !(VA[fc1]&BIT7) || (HVAS[fc1]&BIT5) ||
           (R(fc7) && VA[fc7] && !(VA[fc7]&BIT7) || (HVAS[fc7]&BIT5))) {
		FCA[fc2] |=   BIT0;
	} else {
		FCA[fc2] &= (~BIT0);
	}
	if (R(fc2) && VA[fc2] && !(VA[fc2]&BIT7) || (HVAS[fc2]&BIT5) ||
           (R(fc7) && VA[fc7] && !(VA[fc7]&BIT7) || (HVAS[fc7]&BIT5))) {
		FCA[fc1] |=   BIT0;
	} else {
		FCA[fc1] &= (~BIT0);
	}
 } else {
        if (fc7 >= 0) {
		if (fc1 >= 0) FCA[fc1] &= (~BIT0);
		if (fc2 >= 0) FCA[fc2] &= (~BIT0);
	}
	if (fc7 >= 0) FCA[fc7] &= (~BIT0);
 }

 /* Bepaal fictieve aanvragen gekoppelde fietsers */
 /* --------------------------------------------- */

 if ((fc3 >= 0) && (fc4 >= 0)) {
	if (R(fc3) && VA[fc3] && !(VA[fc3]&BIT7) || (HVAS[fc3]&BIT5)) {
		FCA[fc4] |=   BIT0;
	} else {
		FCA[fc4] &= (~BIT0);
	}
 } else {
	if (fc4 >= 0) FCA[fc4] &= (~BIT0);
 }

 if ((fc5 >= 0) && (fc6 >= 0)) {
	if (R(fc5) && VA[fc5] && !(VA[fc5]&BIT7) || (HVAS[fc5]&BIT5)) {
		FCA[fc6] |=   BIT0;
	} else {
		FCA[fc6] &= (~BIT0);
	}
 } else {
	if (fc6 >= 0) FCA[fc6] &= (~BIT0);
 }

 /* Bepaal overige fictieve aanvragen */
 /* --------------------------------- */

 if (fc1 >= 0) FCA[fc1] &= (~BIT1);
 if (fc2 >= 0) FCA[fc2] &= (~BIT1);
 if (fc3 >= 0) FCA[fc3] &= (~BIT1);
 if (fc4 >= 0) FCA[fc4] &= (~BIT1);
 if (fc5 >= 0) FCA[fc5] &= (~BIT1);
 if (fc6 >= 0) FCA[fc6] &= (~BIT1);
 if (fc7 >= 0) FCA[fc7] &= (~BIT1);

 if (fc1 >= 0) {
	if (R(fc1) && VA[fc1] && !(VA[fc1]&BIT7) || (HVAS[fc1]&BIT5)) {
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc4 >= 0) FCA[fc4] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
		if (fc6 >= 0) FCA[fc6] |= BIT1; /* fc2 en fc7 krijgen bit0 */
	}
 }
 if (fc2 >= 0) {
	if (R(fc2) && VA[fc2] && !(VA[fc2]&BIT7) || (HVAS[fc2]&BIT5)) {
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc4 >= 0) FCA[fc4] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
		if (fc6 >= 0) FCA[fc6] |= BIT1; /* fc1 en fc7 krijgen bit0 */
	}
 }
 if (fc7 >= 0) {
	if (R(fc7) && VA[fc7] && !(VA[fc7]&BIT7) || (HVAS[fc7]&BIT5)) {
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc4 >= 0) FCA[fc4] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
		if (fc6 >= 0) FCA[fc6] |= BIT1; /* fc1 en fc2 krijgen bit0 */
	}
 }

 if (fc3 >= 0) {
	if (R(fc3) && VA[fc3] && !(VA[fc3]&BIT7) || (HVAS[fc3]&BIT5)) {
		if (fc1 >= 0) FCA[fc1] |= BIT1;
		if (fc2 >= 0) FCA[fc2] |= BIT1;
		if (fc7 >= 0) FCA[fc7] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
		if (fc6 >= 0) FCA[fc6] |= BIT1; /* fc4 krijgt bit0 */
	}
 }
 if (fc4 >= 0) {
	if (R(fc4) && VA[fc4] && !(VA[fc4]&BIT7) || (HVAS[fc4]&BIT5)) {
		if (fc1 >= 0) FCA[fc1] |= BIT1;
		if (fc2 >= 0) FCA[fc2] |= BIT1;
		if (fc7 >= 0) FCA[fc7] |= BIT1;
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
		if (fc6 >= 0) FCA[fc6] |= BIT1;
	}
 }
 if (fc5 >= 0) {
	if (R(fc5) && VA[fc5] && !(VA[fc5]&BIT7) || (HVAS[fc5]&BIT5)) {
		if (fc1 >= 0) FCA[fc1] |= BIT1;
		if (fc2 >= 0) FCA[fc2] |= BIT1;
		if (fc7 >= 0) FCA[fc7] |= BIT1;
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc4 >= 0) FCA[fc4] |= BIT1; /* fc6 krijgt bit0 */
	}
 }
 if (fc6 >= 0) {
	if (R(fc6) && VA[fc6] && !(VA[fc6]&BIT7) || (HVAS[fc6]&BIT5)) {
		if (fc1 >= 0) FCA[fc1] |= BIT1;
		if (fc2 >= 0) FCA[fc2] |= BIT1;
		if (fc7 >= 0) FCA[fc7] |= BIT1;
		if (fc3 >= 0) FCA[fc3] |= BIT1;
		if (fc4 >= 0) FCA[fc4] |= BIT1;
		if (fc5 >= 0) FCA[fc5] |= BIT1;
	}
 }
}

/* PROCEDURE CORRIGEER TTR[] VOOR SERIELE KOPPELING */
/* ================================================ */

void proc_cttr_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,x;
 Int16 kptvs12,kptvs23;
 Int16 voorstart;

 for (x=0; x<3; x++) {							/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	stat    = hki[i][20];

	if (stat >= 2) {						/* koppeling is aktief */
		if (fc3 >= 0) {
			voorstart = (Int16)inst_TIJD(kptvs23)/10;
			if (TTR[fc3] > voorstart) {
				if ((TTR[fc3] - voorstart) > TTR[fc2]) TTR[fc2] = TTR[fc3] - voorstart;
			}
		}
		voorstart = (Int16)inst_TIJD(kptvs12)/10;
		if (TTR[fc2] > voorstart) {
			if ((TTR[fc2] - voorstart) > TTR[fc1]) TTR[fc1] = TTR[fc2] - voorstart;
		}
	}
    }
 }
}

/* PROCEDURE BEPAAL TIJD TOT PRIMAIRE REALISATIE, TTP[] */
/* ==================================================== */

void proc_bttp_crsv()
{
 Int16 i;

 for (i=0; i<NUMSG_CS; i++) {

	if (AKTPRG) {				/* Bepaal TTP[] en UTTP[] */
	  if (HVAS[i]&BIT0) { VTTP[i] = TTP[i] = FALSE; }
	  else {
	    if ((TS || N_ts || SVAS) && !(HVAS[i]&BIT3)) {
		  if (STAP<VAS2[i]) { TTP[i] = VTTP[i] = VAS2[i] - STAP; }
		  else		    { TTP[i] = VTTP[i] = CTYD    - STAP + VAS2[i]; }
	    }
	  }
	  if (PVAS[i]&BIT0) { UTTP[i] = FALSE; }
	  else {
	    if ((TS || N_ts || SVAS)  && !(HVAS[i]&BIT3)) {
		  if (STAP<VS2M[i]) { UTTP[i] = VS2M[i] - STAP; }
		  else		    { UTTP[i] = CTYD    - STAP + VS2M[i]; }
	    }
	  }
	} else { TTP[i] = VTTP[i] = UTTP[i] = 255; }

	if (AKTPRG && (HVAS[i]&BIT1)) {		/* Bepaal TTU[] */
	    if (TS || N_ts || SVAS) {
		  if (STAP<VAS1[i]) { TTU[i] = VAS1[i] - STAP; }
		  else		    { TTU[i] = CTYD    - STAP + VAS1[i]; }
	  }
	} else { TTU[i] = FALSE; }
 }
}

/* PROCEDURE BEPAAL PRIORITEIT OPENBAAR VERVOER */
/* ============================================ */

void proc_prio_crsv()
{
 Int16 i,j,k,x;
 Int16 _UTTP,_TEP,_REST;
 Int16 ontruim,tts,_min_tts;
 Int16 o_tijd,gltijd;
 Int16 uitm_bew;
 Int16 min_groen,start_pri;
 Bool  prio_aktief,_uitm_bew;
 Int16 prog_keuze = (Int16)inst_EPARM(PROGKEUZE_CS);

 if (AKTPRG) {

   /* Update aanwezigheidstijd openbaar vervoer */
   if (TS || N_ts) {
     for (i=0; i<NUMSG_CS; i++) {
	if ((ovp[i][4] >= 0) && (ovp[i][7] < 255)) ovp[i][7]++;
	if ((ovp[i][9] >= 0) && (ovp[i][12]< 255)) ovp[i][12]++;
	if ((ovp[i][14]>= 0) && (ovp[i][17]< 255)) ovp[i][17]++;
     }
   }

   for (i=0; i<NUMSG_CS; i++) {	/* Bepaal TEP[] */

     if ((VAS5[i] != 0) && !(PVS2[i]&BIT1)) {	/* Bepaal TEP[] agv afkapmoment */
	if (!(PVS2[i]&BIT0) && ((HVAS[i]&BIT1) || (HVAS[i]&BIT6))) TEP[i] = 0;
	else {
		if (STAP <= VAS5[i]) _REST = VAS5[i] - STAP;
		else _REST = CTYD - STAP + VAS5[i];
		if (_REST < TEP[i]) TEP[i] = _REST;
	}
     }

     if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5) || FCA[i]) {
	if ((HVAS[i]&BIT3) || (HVAS[i]&BIT0) && G(i) || begin_G(i) && (VA[i]&BIT4)) {
	  if (STAP<VS2M[i]) { _UTTP = VS2M[i] - STAP + CTYD;    } /* Gerealiseerd?  */
	  else		    { _UTTP = CTYD    - STAP + VS2M[i]; } /* ... dan + CTYD */
	} else {
	  _UTTP = UTTP[i]; /* Niet gerealiseerd? dan copie van UTTP[i] */
	}
	for (j=0; j<aant_dgc[i]; j++) {
	  k = gcf[i][j];

	  gltijd = 0;
	  o_tijd = 0;
	  if (j<aant_gcf[i]) {
	    gltijd = (Int16)inst_GL_TIJD(k)/10;
	    o_tijd = (Int16)inst_O_TIJD(k,i)/10;
	  }
	  ontruim = gltijd + o_tijd;

	  if (HG[i] && (ROG(i) || RVG(i))) { TEP[k] = FALSE; }
	  else {
	    if (_UTTP <= ontruim)              { TEP[k] = FALSE; }
	    else if ((_UTTP-ontruim) < TEP[k]) { TEP[k] = _UTTP - ontruim; }
	  }
	}
     }
   }
   proc_ctep_crsv_hki();

   for (i=0; i<NUMSG_CS; i++) {	/* Bepaal TSP[] */
	TSP[i]  = 0;		/* Initialiseer TSP[]  */
	TTPR[i] = 255;		/* Initialiseer TTPR[] */
	PVAS[i] &= (~BIT3);	/* Reset conflict bit  */
	PVS2[i] &= (~BIT3);	/* Reset conflict bit doorsnijding */
   }
   proc_bcob_crsv();		/* Bepaal conflict bit */
   proc_btsp_crsv();		/* Bereken TSP[]       */
   proc_knp_crsv_hki();

   for (i=0; i<NUMSG_CS; i++) {			/* Volgrichting volgt voeding */
	if (HG[i]&BIT4) {
		if (G(i)) TTPR[i] = 0;
		if (TSP[i] < TTPR[i]) TTPR[i] = TSP[i];
   	        if (R(i) && !GR_TIJD(i) && !somfbk(i) && ((TTPR[i] < TTR[i]) || (TTR[i] == 0)) || ROG(i) || RVG(i)) {
			 B[i] |= BIT4;
			VA[i] |= BIT0;
	        }
		proc_ctegov_crsv_hki();
		proc_btsp_crsv(); 		/* Herbereken TSP[] */
	}
   }

   for (i=0; i<NUMSG_CS; i++) {			/* Aanhouden groen door OV */
     uitm_bew = 0;
     if (ovp[i][2] >= 0) uitm_bew = (Int16)inst_EPARM(ovp[i][2])/10;

     if (G(i) && (TEG_OV[i] > 0) && (KG[i] < ALTM[i]) && (YV[i]&BIT2)) TEG_OV[i] = ALTM[i] - KG[i];
     else TEG_OV[i] = 0;
     for (j=1; j<=3; j++) {
       prio_aktief = (ovp[i][(j*5)+1] >= 10);	/* Prioriteit al aktief */
       _TEP = TEP[i];
       if (prio_aktief) _TEP += 2;
       prio_aktief = FALSE;

       if (G(i) && (ovp[i][(j*5)-1] >= 0) && (ovp[i][(j*5)+1] >= 1)
		 && (prog_keuze != 30)) {				/* Er is een bus aanwezig   */
	 if ((KG[i] + _TEP) >= ovp[i][(j*5)]) {				/* Min.groen criterium oke  */
	   tts = ovp[i][(j*5)-2] - ovp[i][(j*5)+2];			/* TTS gecorrigeerd met awt */
	   _min_tts = ovp[i][(j*5)] - KG[i];
	   if (_min_tts < 0) _min_tts = 0;
	   if (tts < _min_tts) tts = _min_tts;				/* ... maar met een minimum */
	   if (tts <= uitm_bew) {					/* TTS kleiner dan uitm.bew.*/
	     if (tts <= _TEP) {						/* Bus past in het raster   */
	       if (tts > TEG_OV[i]) TEG_OV[i] = tts;			/* Bepaal TEG_OV            */
	       prio_aktief = TRUE;
	       TTPR[i] = 0;
	       PVAS[i] |= BIT2;						/* Vlag prioriteit aktief */
	       proc_ctegov_crsv_hki();
	       proc_btsp_crsv(); 					/* Herbereken TSP[] */
	     }
	   }
	 }
       }
       if (G(i)) {
         if (prio_aktief) {
	   if (ovp[i][(j*5)+1] >=100) ovp[i][(j*5)+1] -= 100;
	   if (ovp[i][(j*5)+1] <  10) ovp[i][(j*5)+1] += 10;
         } else {
	   if (ovp[i][(j*5)+1] >=100) ovp[i][(j*5)+1] -= 100;
	   if (ovp[i][(j*5)+1] >= 10) ovp[i][(j*5)+1] -= 10;
         }
       }
     }
     if (G(i) && (TEG_OV[i] > 0) && (TTPR[i] != 0)) {
	TTPR[i] = 0;
	PVAS[i] |= BIT2;				/* Vlag prioriteit aktief */
	proc_ctegov_crsv_hki();
	proc_btsp_crsv(); 				/* Herbereken TSP[] */
     }
     if (G(i) && (TTPR[i] != 0)) PVAS[i] &= (~BIT2);	/* Reset prioriteit aktief */
   }

   for (i=0; i<NUMSG_CS; i++) {				/* prioriteitsrealisatie OV */
     proc_bdsn_crsv(i);					/* bepaal doorsnijden */
     uitm_bew = 0;
     if (ovp[i][2] >= 0) uitm_bew = (Int16)inst_EPARM(ovp[i][2])/10;
     /* TEG_OV[i] niet gelijk aan nul maken, is al gebeurd */

     if (!G(i) && !(HG[i]&BIT4)) {
	PVAS[i] &= (~BIT2);	/* Reset prioriteit aktief */
	VA[i]   &= (~BIT0);	/* Iedere machineslag opnieuw bepalen */
     }
     /* prioriteit dmv doorsnijden */
     for (j=1; j<=3; j++) {				/* ... Prioriteit in groen gaat voor  */
       prio_aktief = (ovp[i][(j*5)+1] >= 100);		/* Prioriteit al aktief */
       _TEP = DSEP[i];
       if (prio_aktief) _TEP += 2;
       prio_aktief = FALSE;

       if (R(i) && (ovp[i][(j*5)-1] >= 0) && (ovp[i][(j*5)+1] >= 2) && (PVS2[i]&BIT7)
		 && !(PVAS[i]&BIT3) && (prog_keuze != 30)) {	/* Er is een bus aanwezig   */
	if ((_TEP > (DSSP[i]+ALTM[i])) && (DSSP[i]<255)) {	/* Min.ALTM mogelijk        */
	 if ((_TEP-DSSP[i]) >= ovp[i][(j*5)]) {			/* Min.groen criterium oke  */
	   tts = ovp[i][(j*5)-2] - ovp[i][(j*5)+2];		/* TTS gecorrigeerd met awt */
	   if (tts < ovp[i][(j*5)]) tts = ovp[i][(j*5)];	/* ... maar minimaal vgr[]  */
	   if (tts <= uitm_bew) {				/* TTS kleiner dan uitm.bew.*/
	     if ((tts <= _TEP) && !BL_OP(i)) {			/* Bus past in het raster   */
	       if (tts > TEG_OV[i]) TEG_OV[i] = tts;		/* Bepaal TEG_OV            */
	       prio_aktief = TRUE;
	       PVAS[i] |= BIT2;					/* Vlag prioriteit aktief   */

	       proc_ctegov_crsv_hki();
	       proc_bcob_crsv();	/* set blokkeer bit bij conflicten */

	       /* bepaal tijd tot prioriteitsrealisatie */
	       /* ------------------------------------- */
	       min_groen = (Int16)inst_VG_TIJD(i)/10;
	       if (ovp[i][(j*5)] > min_groen) min_groen = ovp[i][(j*5)];
	       start_pri = TEG_OV[i] - min_groen;
	       if (start_pri < DSSP[i]) start_pri = DSSP[i];
	       if (start_pri < TTPR[i]) TTPR[i] = start_pri;
   	       if (R(i) && !GR_TIJD(i) && !somfbk(i) && ((TTPR[i] < TTR[i]) || (TTR[i] == 0)) || ROG(i) || RVG(i)) {
			VA[i] |= BIT0;
			 B[i] |= BIT4;
	       }
	     }
	   }
	 }
	}
       }
       if (R(i)) {
         if (prio_aktief) {
	   if (ovp[i][(j*5)+1] < 100) ovp[i][(j*5)+1] += 100;
         } else {
	   if (ovp[i][(j*5)+1] >=100) {
		ovp[i][(j*5)+1] -= 100;
		if (ovp[i][(j*5)+1] < 10) ovp[i][(j*5)+1] += 10;
	   }
         }
       }
     }
     for (j=0; j<NUMSG_CS; j++) PVS2[j] &= (~BIT7);	/* Ruim kladblok op */

     /* prioriteit dmv afbreken */
     for (j=1; j<=3; j++) {				/* ... Prioriteit in groen gaat voor  */
       prio_aktief = (ovp[i][(j*5)+1] >= 10)		/* Prioriteit al aktief */
		  && (ovp[i][(j*5)+1] < 100); 
       _TEP = TEP[i];
       if (prio_aktief) _TEP += 2;
       prio_aktief = FALSE;

       if (R(i) && (ovp[i][(j*5)-1] >= 0) && (ovp[i][(j*5)+1] >= 2) && (ovp[i][(j*5)+1] < 100)
		 && !(PVAS[i]&BIT3) && (prog_keuze != 30)) {	/* Er is een bus aanwezig   */
	if ((_TEP > (TSP[i]+ALTM[i])) && (TSP[i]<255))	 {	/* Min.ALTM mogelijk        */
	 if ((_TEP-TSP[i]) >= ovp[i][(j*5)]) {			/* Min.groen criterium oke  */
	   tts = ovp[i][(j*5)-2] - ovp[i][(j*5)+2];		/* TTS gecorrigeerd met awt */
	   if (tts < ovp[i][(j*5)]) tts = ovp[i][(j*5)];	/* ... maar minimaal vgr[]  */
	   if (tts <= uitm_bew) {				/* TTS kleiner dan uitm.bew.*/
	     if ((tts <= _TEP) && !BL_OP(i)) {			/* Bus past in het raster   */
	       if (tts > TEG_OV[i]) TEG_OV[i] = tts;		/* Bepaal TEG_OV            */
	       prio_aktief = TRUE;
	       PVAS[i] |= BIT2;					/* Vlag prioriteit aktief   */

	       proc_ctegov_crsv_hki();
	       proc_bcob_crsv();	/* set blokkeer bit bij conflicten */

	       /* bepaal tijd tot prioriteitsrealisatie */
	       /* ------------------------------------- */
	       min_groen = (Int16)inst_VG_TIJD(i)/10;
	       if (ovp[i][(j*5)] > min_groen) min_groen = ovp[i][(j*5)];
	       start_pri = TEG_OV[i] - min_groen;
	       if (start_pri < TSP[i]) start_pri = TSP[i];
	       if (start_pri < TTPR[i]) TTPR[i] = start_pri;
   	       if (R(i) && !GR_TIJD(i) && !somfbk(i) && ((TTPR[i] < TTR[i]) || (TTR[i] == 0)) || ROG(i) || RVG(i)) {
			VA[i] |= BIT0;
			 B[i] |= BIT4;
	       }
	     }
	   }
	 }
	}
       }
       if (R(i)) {
         if (prio_aktief) {
	   if ((TTPR[i] + ALTM[i]) > TEG_OV[i]) TEG_OV[i] = TTPR[i] + ALTM[i];	/* Fik090816 */
	   if (ovp[i][(j*5)+1] < 10) ovp[i][(j*5)+1] += 10;
         } else {
	   if (ovp[i][(j*5)+1] >= 100) {
		if ((ovp[i][(j*5)+1] - 100) >= 10) ovp[i][(j*5)+1] -= 10;
	   }
	   if ((ovp[i][(j*5)+1] >=10) && (ovp[i][(j*5)+1] < 100)) ovp[i][(j*5)+1] -= 10;
         }
       }
     }
   }

   /* Corrigeer TTP[] na afloop aanhouden groen door busprioriteit */
   /* ------------------------------------------------------------ */
   for (i=0; i<NUMSG_CS; i++) {
	if (G(i)) CTTP[i] = FALSE;
	if ((CTTP[i] > 0) && (TS || N_ts)) CTTP[i]--;
	if ( CTTP[i] > UTTP[i]) CTTP[i] = UTTP[i];

	if (TTP[i] < 255) {
	  if (CTTP[i] > TTP[i]) TTP[i] = CTTP[i];
	} else {
	  CTTP[i] = 0;
	}
   }

   /* Corrigeer TTP[] agv aktieve prioriteitsrealisatie */
   /* ------------------------------------------------- */
   for (i=0; i<NUMSG_CS; i++) {

	if (R(i) && (PVAS[i]&BIT2) || G(i) && (TTPR[i] == 0)) {

	  TTP[i] = TTPR[i];
          uitm_bew = 0;
          if (ovp[i][2] >= 0) uitm_bew = (Int16)inst_EPARM(ovp[i][2])/10;
	  if (G(i)) {
		RW[i] |= BIT2;		/* Aanhouden groen busrichting       */
     		for (j=1; j<=3; j++) {	/* Bepaal aanspreken uitmeldbewaking */
			_uitm_bew = FALSE;

			/* Als bus langer aanwezig dan minimum groen en langer dan tts bij inmelding */
			if ((ovp[i][(j*5)-1] >= 0) && (KG[i] >= ovp[i][(j*5)]) && (ovp[i][(j*5)+2] >= ovp[i][(j*5)-2])) {
#ifdef RWSC_old
			  if ((ovp[i][(j*5)+2] >= uitm_bew) && (!VG1[i] && !H2e_TIJD(i)  || (KG[i] >= uitm_bew))) _uitm_bew = TRUE;
#else
			  if ((ovp[i][(j*5)+2] >= uitm_bew) && (!VG1[i] && !H2e_loopt(i) || (KG[i] >= uitm_bew))) _uitm_bew = TRUE;
#endif
			}
			if (ovp[i][(j*5)+2] >= 255) _uitm_bew = TRUE;
			if (_uitm_bew) {
	  			ovp[i][(j*5)-2] = NIET;
	  			ovp[i][(j*5)-1] = NIET;
	  			ovp[i][(j*5)  ] = NIET;
	  			ovp[i][(j*5)+1] = NIET;
	 			ovp[i][(j*5)+2] = NIET;

		     		/* Sorteer resterende bussen op basis van tijd tot stopstreep */
     				proc_sorteer_bus(i,1,2);
     				proc_sorteer_bus(i,2,3);
     				proc_sorteer_bus(i,1,2);
			}
 	        }
	  } else {
     		for (j=1; j<=3; j++) {	/* Bepaal aanspreken uitmeldbewaking */
			_uitm_bew = FALSE;
			if (ovp[i][(j*5)+2] >= 255) _uitm_bew = TRUE;
			if (_uitm_bew) {
	  			ovp[i][(j*5)-2] = NIET;
	  			ovp[i][(j*5)-1] = NIET;
	  			ovp[i][(j*5)  ] = NIET;
	  			ovp[i][(j*5)+1] = NIET;
	 			ovp[i][(j*5)+2] = NIET;

		     		/* Sorteer resterende bussen op basis van tijd tot stopstreep */
     				proc_sorteer_bus(i,1,2);
     				proc_sorteer_bus(i,2,3);
     				proc_sorteer_bus(i,1,2);
			}
		}
	  }

	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];
	    gltijd = 0;
	    o_tijd = 0;
	    if (j<aant_gcf[i]) {
	      gltijd = (Int16)inst_GL_TIJD(i)/10;
	      o_tijd = (Int16)inst_O_TIJD(i,k)/10;
	    }
	    ontruim = gltijd + o_tijd;
	    if (G(i) && (ontruim > CTTP[k])) CTTP[k] = ontruim;

	    gltijd = 0;
	    o_tijd = 0;
	    if (j<aant_gcf[i]) {
	      gltijd = (Int16)inst_GL_TIJD(k)/10;
	      o_tijd = (Int16)inst_O_TIJD(k,i)/10;
	    }
	    ontruim = gltijd + o_tijd;

	    if (TTPR[i]<=ontruim) {
		RR[k] |= BIT2;
		BAR[k] = TRUE;
		TTK[k] = FALSE;
		if (G(k)) Z[k] |= BIT2;
	    } else {
		if ((TTPR[i]-ontruim)<TTK[k]) { TTK[k] = TTPR[i]-ontruim; }
	    }

	    if (!G(k) || (FCA[k]&BIT0)) {	/* Fic.aanv. gekoppelde.vtg. aanwezig */
						/* danwel voedende fietser aanwezig   */

		ontruim = gltijd + o_tijd + TTR[k] + ALTM[k];
	        if (TTPR[i]<=ontruim) {
			RR[k] |= BIT2;
			BAR[k] = TRUE;
		}
	    }

	    gltijd = 0;
	    o_tijd = 0;
	    if (j<aant_gcf[i]) {
	      gltijd = (Int16)inst_GL_TIJD(i)/10;
	      o_tijd = (Int16)inst_O_TIJD(i,k)/10;
	    }
	    ontruim = TEG_OV[i] + gltijd + o_tijd;

	    if ((TTP[k] < 255) && !G(k) && !einde_G(k)) {
		if (TTP[k] < ontruim) TTP[k] = ontruim;
		if (UTTP[k] < TTP[k]) TTP[k] = UTTP[k];
	    }

	    if (!(HVAS[k]&BIT3)) {		/* Bepaal overslag conflicten */

		if ((UTTP[k]<=ontruim) && R(i)
				       && !GR_TIJD(k) && !(HVAS[k]&BIT5) 
				       && !FCA[k]
				       && (!VA[k] || (VA[k]&BIT7))) {
			HVAS[k] |= BIT3;
			 TTP[k]  = UTTP[k] = 255;
			   X[k] |= BIT1;	/* Registratie overslag */
		}
	    }
	  }

	  for (j=0; j<aant_fcf[i]; j++) {
	    k = fcf[i][j];

	    if ((TTP[k] < 255) && !G(k) && !einde_G(k)) {
		if (TTP[k] < TEG_OV[i]) TTP[k] = TEG_OV[i];
		if (UTTP[k] < TTP[k])   TTP[k] = UTTP[k];
	    }
	  }
	}
   }

   for (x=0; x<aant_fts; x++) {
     proc_cttp_crsv_vtg_fts(fts[x][0],NIET,fts[x][1],NIET,fts[x][2],NIET,NIET);
   }
   for (x=0; x<aant_bbv; x++) {
     proc_cttp_crsv_vtg_fts(bbv[x][0],bbv[x][1],bbv[x][4],NIET,bbv[x][5],NIET,NIET);
   }
   for (x=0; x<aant_gov; x++) {
     proc_cttp_crsv_vtg_fts(gov[x][0],gov[x][1],gov[x][7]
			   ,gov[x][8],gov[x][13],gov[x][14],gov[x][22]);
   }
   proc_cttp_crsv_hki();

   for (i=0; i<NUMSG_CS; i++) {
	if (HG[i] && (ROG(i) || RVG(i)) || (YM[i]&BIT2)) {
		RR[i] &= (~BIT2);
		BAR[i] = FALSE;
	}
   }

 } else { /* Geen AKTPGR dan TEG_OV[] resetten */
   for (i=0; i<NUMSG_CS; i++) {
	CTTP[i] = TEG_OV[i] = 0;
	PVAS[i] &= (~BIT1);
	PVAS[i] &= (~BIT2);
	PVAS[i] &= (~BIT3);
   	for (j=0; j<NUMSG_CS; j++) {
		PVAS_hki[j][i] &= (~BIT1);
	}
   }
 }
}

/* PROCEDURE BEPAAL CONFLICT BIT */
/* ============================= */

void proc_bcob_crsv()
{
   Int16 i,j,k;

   for (i=0; i<NUMSG_CS; i++) {

	if (R(i) && (PVAS[i]&BIT2)) {
	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];
	    PVAS[k] |= BIT3;
	    if ((PVS2[i]&BIT7) && (PVS2[k]&BIT7)) PVS2[k] |= BIT3;
	  }
	  for (j=0; j<aant_fcf[i]; j++) {
	    k = fcf[i][j];
	    PVAS[k] |= BIT3;
	    if ((PVS2[i]&BIT7) && (PVS2[k]&BIT7)) PVS2[k] |= BIT3;
	  }
	}
   }
   proc_cpvas_crsv_hki();
}

/* PROCEDURE (HER)BEREKEN TSP[] */
/* ============================ */

void proc_btsp_crsv()
{
   Int16 i,j,k;
   Int16 ontruim,max;
   Int16 o_tijd,gltijd;
   Int16 _PEG,_TEG,_TTU;
   Bool  _primair;

   for (i=0; i<NUMSG_CS; i++) {

	max = 0;
        if (GL(i)) {
	 if (GL_TIJD(i)) {
           max=(Int16)(inst_GL_TIJD(i)-waarde_GL_TIJD(i)+inst_GR_TIJD(i))/10;
	 } else max=(Int16)(inst_GR_TIJD(i))/10;  
	}
	if (GR_TIJD(i))
	max=(Int16)(inst_GR_TIJD(i)-waarde_GR_TIJD(i))/10;

	if (!G(i) && (VAS1[i] != 0) && !(PVS2[i]&BIT0)) {	/* Correctie indien geen prio voor einde uitstel */
		if (HVAS[i]&BIT1) {
			if ((TTR[i] <= TTU[i]) && !ROG(i) && !RVG(i)) {
				if (TTU[i] > max) max = TTU[i];
			}
		}
		if ((HVAS[i]&BIT6) && !(HVAS[i]&BIT1) && !(VA[i]&BIT4)) {
			if (!ROG(i) && !RVG(i)) {
				if (TTP[i] > max) max = TTP[i];
			}
		}
	}

	if (TTU[i] > TPVU[i]) _TTU = TTU[i] - TPVU[i];
	else                  _TTU = 0;

	if (!G(i) && (VAS1[i] != 0) && (PVS2[i]&BIT0)) {	/* Correctie indien wel prio voor einde uitstel */
		if (HVAS[i]&BIT1) {
			if ((TTR[i] <= _TTU) && !ROG(i) && !RVG(i)) {
				if (_TTU > max) max = _TTU;
			}
		}
		if ((HVAS[i]&BIT6) && !(HVAS[i]&BIT1) && !(VA[i]&BIT4)) {
			if (!ROG(i) && !RVG(i)) {
				if (TTP[i] > max) max = TTP[i];
			}
		}
	}

	if (max > TSP[i]) TSP[i] = max;

	for (j=0; j<aant_dgc[i]; j++) {
	  k = gcf[i][j];

	  if (G(k) || HG[k]) {

	    gltijd = 0;
	    o_tijd = 0;
	  
	    if (j<aant_gcf[i]) {
	      gltijd = (Int16)inst_GL_TIJD(k)/10;
	      o_tijd = (Int16)inst_O_TIJD(k,i)/10;
	    }

	    /* volgrichtingen hebben al de juiste PEG[] en TEG[] als voeding groen is */

            _primair = FALSE;
	    _PEG = PEG[k];
	    _TEG = TEG[k];

	    if (PVAS[k]&BIT7) {	/* voetganger waarvan koppeling mag worden afgebroken */
		if (G(k)) {
			if (KG[k] >= KAPM[k]) _PEG = 0;
			else                  _PEG = KAPM[k] - KG[k];
			if (KG[k] >= ALTM[k]) _TEG = 0;
			else                  _TEG = ALTM[k] - KG[k];
		} else {
			_PEG = TTR[k] + KAPM[k];
			_TEG = TTR[k] + ALTM[k];
		}
	    }

	    if (!(HVAS[k]&BIT3)) {
		if (begin_G(k) && (VA[k]&BIT4) || G(k) && ((HVAS[k]&BIT0) || (HVAS[k]&BIT4))) _primair = TRUE;
	    }
	    if (_primair) ontruim = _PEG + gltijd + o_tijd;
	    else {	/* Bij alternatief kies TEG[] tenzij PEG[] een lagere waarde heeft! */
		if (_TEG <= _PEG) {
			ontruim = _TEG + gltijd + o_tijd;
		} else {
			ontruim = _PEG + gltijd + o_tijd;
		}
	    }

	    if (ontruim > TSP[i]) TSP[i] = ontruim;

	    ontruim = TEG_OV[k] + gltijd + o_tijd;
	    if (ontruim > TSP[i]) TSP[i] = ontruim;

	  } else {

	    if (j<aant_gcf[i]) {
	      if (GL(k)) {
	        if (GL_TIJD(k)) {
		  ontruim=(Int16)(inst_GL_TIJD(k)-waarde_GL_TIJD(k)
				 +inst_O_TIJD(k,i))/10;
		} else ontruim=(Int16)(inst_O_TIJD(k,i))/10;
		if (ontruim > TSP[i]) TSP[i] = ontruim;
	      } else {
		if (R(k) && O_TIJD(k,i)) {
		  ontruim=(Int16)(inst_O_TIJD(k,i)-waarde_O_TIJD(k,i))/10;
		  if (ontruim > TSP[i]) TSP[i] = ontruim;
		}
	      }
	    }
	  }
	}
   }
   proc_ctsp_crsv_hki();
}

/* PROCEDURE BEPAAL DSSP[] EN DSEP */
/* =============================== */

void proc_bdsn_crsv(
	Int16 fc)	/* Signaalgroep */
{
   Int16 i,j,k;
   Int16 ontruim,max;
   Int16 o_tijd,gltijd,o_tijd2,gltijd2;
   Int16 _PEG,_TEG,_REST,_UTTP,_TTU;
   Bool  _primair,_doorsnij;

   for (i=0; i<NUMSG_CS; i++) {	/* Kladblok, vlagt conflicten die doorsneden gaan worden */
	PVS2[i] &= (~BIT7);	/* ... en OV-richting die gaat doorsnijden               */
   }

   DSSP[fc] = 0;
   DSEP[fc] = 255;

   if ((VAS5[fc] != 0) && !(PVS2[fc]&BIT1)) {	/* Initialiseer DSEP[] agv afkapmoment */
	if (!(PVS2[fc]&BIT0) && ((HVAS[fc]&BIT1) || (HVAS[fc]&BIT6))) DSEP[fc] = 0;
	else {
		if (STAP <= VAS5[fc]) _REST = VAS5[fc] - STAP;
		else _REST = CTYD - STAP + VAS5[fc];
		if (_REST < DSEP[fc]) DSEP[fc] = _REST;
	}
   }

   max = 0;					/* Initialiseer DSSP[] agv GL(), GR() of uitstelmoment */
   if (GL(fc)) {
	if (GL_TIJD(fc)) {
           max=(Int16)(inst_GL_TIJD(fc)-waarde_GL_TIJD(fc)+inst_GR_TIJD(fc))/10;
	} else max=(Int16)(inst_GR_TIJD(fc))/10;  
   }
   if (GR_TIJD(fc)) max=(Int16)(inst_GR_TIJD(fc)-waarde_GR_TIJD(fc))/10;

   if (!G(fc) && (VAS1[fc] != 0) && !(PVS2[fc]&BIT0)) {
	if (HVAS[fc]&BIT1) {
		if ((TTR[fc] <= TTU[fc]) && !ROG(fc) && !RVG(fc)) {
			if (TTU[fc] > max) max = TTU[fc];
		}
	}
	if ((HVAS[fc]&BIT6) && !(HVAS[fc]&BIT1) && !(VA[fc]&BIT4)) {
		if (!ROG(fc) && !RVG(fc)) {
			if (TTP[fc] > max) max = TTP[fc];
		}
	}
   }

   if (TTU[fc] > TPVU[fc]) _TTU = TTU[fc] - TPVU[fc];
   else                    _TTU = 0;

   if (!G(fc) && (VAS1[fc] != 0) && (PVS2[fc]&BIT0)) {
	if (HVAS[fc]&BIT1) {
		if ((TTR[fc] <= _TTU) && !ROG(fc) && !RVG(fc)) {
			if (_TTU > max) max = _TTU;
		}
	}
	if ((HVAS[fc]&BIT6) && !(HVAS[fc]&BIT1) && !(VA[fc]&BIT4)) {
		if (!ROG(fc) && !RVG(fc)) {
			if (TTP[fc] > max) max = TTP[fc];
		}
	}
   }

   if (max > DSSP[fc]) DSSP[fc] = max;

   for (j=0; j<aant_dgc[fc]; j++) {		/* Bepaal DSSP[] en DSEP[] */
	k = gcf[fc][j];

	if (G(k) || GL(k) || GR_TIJD(k) || VA[k] || (HVAS[k]&BIT5) || FCA[k]) {
		if ((HVAS[k]&BIT3) || (HVAS[k]&BIT0) && G(k) || begin_G(k) && (VA[k]&BIT4)) {
		  if (STAP<VS2M[k]) { _UTTP = VS2M[k] - STAP + CTYD;    } /* Gerealiseerd?  */
		  else		    { _UTTP = CTYD    - STAP + VS2M[k]; } /* ... dan + CTYD */
		} else {
		  _UTTP = UTTP[k]; /* Niet gerealiseerd? dan copie van UTTP[k] */
		}
	}

	if (HG[k] || G(k)) {
		gltijd = 0;
		o_tijd = 0;
		gltijd2= 0;
	 	o_tijd2= 0;
 
		if (j<aant_gcf[fc]) {
			gltijd = (Int16)inst_GL_TIJD(k)/10;
			gltijd2= (Int16)inst_GL_TIJD(fc)/10;
			o_tijd = (Int16)inst_O_TIJD(k,fc)/10;
			o_tijd2= (Int16)inst_O_TIJD(fc,k)/10;
		}
		_primair = FALSE;
		if (!(HVAS[k]&BIT3)) {
			if (begin_G(k) && (VA[k]&BIT4) || G(k) && ((HVAS[k]&BIT0) || (HVAS[k]&BIT4))) _primair = TRUE;
		}
		_doorsnij = FALSE;
		if (_primair && ((SDSN[k] + gltijd + o_tijd + ALTM[fc] + gltijd2 + o_tijd2) < EDSN[k]) && (EDSN[k]<255)) _doorsnij = TRUE;
		
						/* conflict is primair groen en mag worden doorsneden */
		if (G(k) && (PVAS[k]&BIT6) && !(PVAS[k]&BIT2) && !(PVS2[k]&BIT2) && _primair && _doorsnij) {
			if ((SDSN[k] + gltijd  + o_tijd ) > DSSP[fc]) DSSP[fc] = SDSN[k] + gltijd  + o_tijd;
			if ((EDSN[k] - gltijd2 - o_tijd2) < DSEP[fc]) DSEP[fc] = EDSN[k] - gltijd2 - o_tijd2;
			PVS2[k]  |= BIT7;	/* schrijf weg in kladblok */
			PVS2[fc] |= BIT7;
		} else {			/* conflict mag niet worden doorsneden */
			
			_PEG = PEG[k];		/* volgrichtingen hebben al de juiste PEG[] en TEG[] als voeding groen is */
			_TEG = TEG[k];

			if (PVAS[k]&BIT7) {	/* voetganger waarvan koppeling mag worden afgebroken */
				if (G(k)) {
					if (KG[k] >= KAPM[k]) _PEG = 0;
					else                  _PEG = KAPM[k] - KG[k];
					if (KG[k] >= ALTM[k]) _TEG = 0;
					else                  _TEG = ALTM[k] - KG[k];
				} else {
					_PEG = TTR[k] + KAPM[k];
					_TEG = TTR[k] + ALTM[k];
				}
	    		}

			if (_primair) ontruim = _PEG + gltijd + o_tijd;
			else {	/* Bij alternatief kies TEG[] tenzij PEG[] een lagere waarde heeft! */
				if (_TEG <= _PEG) {
					ontruim = _TEG + gltijd + o_tijd;
				} else {
					ontruim = _PEG + gltijd + o_tijd;
				}
			}

			if (ontruim > DSSP[fc]) DSSP[fc] = ontruim;

			ontruim = TEG_OV[k] + gltijd + o_tijd;
			if (ontruim > DSSP[fc]) DSSP[fc] = ontruim;
			if (_UTTP < DSEP[fc])   DSEP[fc] = _UTTP;
		}

	} else {	/* richting is niet groen */

	    if (j<aant_gcf[i]) {
	      if (GL(k)) {
	        if (GL_TIJD(k)) {
		  ontruim=(Int16)(inst_GL_TIJD(k)-waarde_GL_TIJD(k)
				 +inst_O_TIJD(k,fc))/10;
		} else ontruim=(Int16)(inst_O_TIJD(k,fc))/10;
		if (ontruim > DSSP[fc]) DSSP[fc] = ontruim;
	      } else {
		if (R(k) && O_TIJD(k,fc)) {
		  ontruim=(Int16)(inst_O_TIJD(k,fc)-waarde_O_TIJD(k,fc))/10;
		  if (ontruim > DSSP[fc]) DSSP[fc] = ontruim;
		}
	      }


	      if (_UTTP < DSEP[fc]) DSEP[fc] = _UTTP;
	    }
	}
   }
   proc_cdssp_crsv_hki();
}

/* PROCEDURE CORRIGEER TEP[] VOOR SERIELE KOPPELINGEN */
/* ================================================== */

void proc_ctep_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,j,x;
 Int16 kpteg12,kptdm12;
 Int16 kpteg23,kptdm23;
 Int16 naloop;

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kpteg12 = hki[i][4];
	kptdm12 = hki[i][5];
	fc3     = hki[i][10];
	kpteg23 = hki[i][13];
	kptdm23 = hki[i][14];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (fc3 >= 0) {
			if (VAS4[fc2] <= VAS4[fc3]) naloop = VAS4[fc3] - VAS4[fc2];
			else                        naloop = VAS4[fc3] - VAS4[fc2] + CTYD;

			if ((((Int16)inst_TIJD(kpteg23)+(Int16)inst_TIJD(kptdm23))/10) < naloop) {
				naloop = ((Int16)inst_TIJD(kpteg23)+(Int16)inst_TIJD(kptdm23))/10;
			}
			if ((TEP[fc3] - naloop) < TEP[fc2]) TEP[fc2] = TEP[fc3] - naloop;
			if (TEP[fc2] < 0) TEP[fc2] = 0;
		}
		if (VAS4[fc1] <= VAS4[fc2]) naloop = VAS4[fc2] - VAS4[fc1];
		else                        naloop = VAS4[fc2] - VAS4[fc1] + CTYD;

		if ((((Int16)inst_TIJD(kpteg12)+(Int16)inst_TIJD(kptdm12))/10) < naloop) {
			naloop = ((Int16)inst_TIJD(kpteg12)+(Int16)inst_TIJD(kptdm12))/10;
		}
		if ((TEP[fc2] - naloop) < TEP[fc1]) TEP[fc1] = TEP[fc2] - naloop;
		if (TEP[fc1] < 0) TEP[fc1] = 0;

		if (  G(fc1) && (TEG_OV[fc1] >  0)) HG_hki[i][fc2] |= BIT4;
		if ((!G(fc1) || (TEG_OV[fc1] == 0)) && (KNP[fc2] == 0)) HG_hki[i][fc2] &= (~BIT4);

		if (fc3 >= 0) {
			if (( G(fc2) && (TEG_OV[fc2] >  0)) || (HG_hki[i][fc2]&BIT4)) HG_hki[i][fc3] |= BIT4;
			if ((!G(fc2) || (TEG_OV[fc2] == 0)) && (KNP[fc3] == 0) && !(HG_hki[i][fc2]&BIT4)) HG_hki[i][fc3] &= (~BIT4);
		}

	} else {				/* koppeling is niet aktief */

		HG_hki[i][fc2] &= (~BIT4);
		if (fc3 >= 0) HG_hki[i][fc3] &= (~BIT4);

	}
    }

    for (j=0; j<NUMSG_CS; j++) {		/* bepaal HG[]&BIT4 per signaalgroep */
	HG[j] &= (~BIT4);
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (HG_hki[i][j]&BIT4) {
			HG[j]   |= BIT4;
			PVAS[j] |= BIT2;	/* volgrichting volgt prioriteit voeding */
		}
	}
    }
 }
}

/* PROCEDURE CORRIGEER TSP[] VOOR SERIELE KOPPELINGEN */
/* ================================================== */

void proc_ctsp_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,x;
 Int16 kptvs12,kptsg12;
 Int16 kptvs23,kptsg23;
 Int16 voorstart,start_kop;

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	kptsg12 = hki[i][3];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	kptsg23 = hki[i][12];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (fc3 >= 0) {
			voorstart = (Int16)inst_TIJD(kptvs23)/10;
			start_kop = (Int16)inst_TIJD(kptsg23)/10;

			if ((TSP[fc2] + voorstart) < TSP[fc3]) TSP[fc2] = TSP[fc3] - voorstart;
			if ((TSP[fc2] + start_kop) > TEP[fc3]) TSP[fc2] = TEP[fc3] - start_kop;
			if (TSP[fc2] < 0) TSP[fc2] = 255;

			if (!G(fc3) && ((TEP[fc3] - TSP[fc3]) < ALTM[fc3])) { TSP[fc2] = 255; TSP[fc1] = 255; }
		}

		voorstart = (Int16)inst_TIJD(kptvs12)/10;
		start_kop = (Int16)inst_TIJD(kptsg12)/10;

		if ((TSP[fc1] + voorstart) < TSP[fc2]) TSP[fc1] = TSP[fc2] - voorstart;
		if ((TSP[fc1] + start_kop) > TEP[fc2]) TSP[fc1] = TEP[fc2] - start_kop;
		if (TSP[fc1] < 0) TSP[fc1] = 255;

		if (!G(fc2) && ((TEP[fc2] - TSP[fc2]) < ALTM[fc2])) TSP[fc1] = 255;
	}
    }
 }
}

/* PROCEDURE CORRIGEER DSSP[] VOOR SERIELE KOPPELINGEN */
/* =================================================== */

void proc_cdssp_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,x;
 Int16 kptvs12,kptsg12;
 Int16 kptvs23,kptsg23;
 Int16 voorstart,start_kop;

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	kptsg12 = hki[i][3];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	kptsg23 = hki[i][12];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (fc3 >= 0) {
			voorstart = (Int16)inst_TIJD(kptvs23)/10;
			start_kop = (Int16)inst_TIJD(kptsg23)/10;

			if ((DSSP[fc2] + voorstart) < TSP[fc3]) DSSP[fc2] = TSP[fc3] - voorstart;
			if ((DSSP[fc2] + start_kop) > TEP[fc3]) DSSP[fc2] = TEP[fc3] - start_kop;
			if (DSSP[fc2] < 0) DSSP[fc2] = 255;

			if (!G(fc3) && ((TEP[fc3] - TSP[fc3]) < ALTM[fc3])) { DSSP[fc2] = 255; DSSP[fc1] = 255; }
		}

		voorstart = (Int16)inst_TIJD(kptvs12)/10;
		start_kop = (Int16)inst_TIJD(kptsg12)/10;

		if ((DSSP[fc1] + voorstart) < TSP[fc2]) DSSP[fc1] = TSP[fc2] - voorstart;
		if ((DSSP[fc1] + start_kop) > TEP[fc2]) DSSP[fc1] = TEP[fc2] - start_kop;
		if (DSSP[fc1] < 0) DSSP[fc1] = 255;

		if (!G(fc2) && ((TEP[fc2] - TSP[fc2]) < ALTM[fc2])) DSSP[fc1] = 255;
	}
    }
 }
}

/* PROCEDURE CORRIGEER PVAS[] VOOR SERIELE KOPPELINGEN */
/* =================================================== */

void proc_cpvas_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat;
 Int16 i,j,k,x;

 for (x=0; x<3; x++) {					/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	fc3     = hki[i][10];
	stat    = hki[i][20];

	if (stat >= 2) {						/* koppeling is aktief */

		if (R(fc1) && (PVAS[fc1]&BIT2)) {			/* voeding fc1 heeft prioriteit */
			for (j=0; j<aant_dgc[fc2]; j++) {		/* primaire conflicten fc2 */
   				k = gcf[fc2][j];
				PVAS[k] |= BIT3;
			}
			for (j=0; j<aant_dfc[fc2]; j++) {		/* fictieve conflicten fc2 */
   				k = fcf[fc2][j];
				PVAS[k] |= BIT3;
			}

			if (fc3 >= 0) {
				for (j=0; j<aant_dgc[fc3]; j++) {	/* primaire conflicten fc3 */
   					k = gcf[fc3][j];
					PVAS[k] |= BIT3;
				}
				for (j=0; j<aant_dfc[fc3]; j++) {	/* fictieve conflicten fc3 */
   					k = fcf[fc3][j];
					PVAS[k] |= BIT3;
				}
			}
   		}

		if (R(fc2) && (PVAS[fc2]&BIT2)) {			/* voeding fc2 heeft prioriteit */
			if (fc3 >= 0) {
				for (j=0; j<aant_dgc[fc3]; j++) {	/* primaire conflicten fc3 */
   					k = gcf[fc3][j];
					PVAS[k] |= BIT3;
				}
				for (j=0; j<aant_dfc[fc3]; j++) {	/* fictieve conflicten fc3 */
   					k = fcf[fc3][j];
					PVAS[k] |= BIT3;
				}
			}
		}

		if (fc3 >= 0) {
			if (PVAS[fc3]&BIT3) {
				PVAS[fc2] |= BIT3;			/* terugschrijven naar voeding */
				PVAS[fc1] |= BIT3;
			}
		}

		if (PVAS[fc2]&BIT3) PVAS[fc1] |= BIT3;			/* terugschrijven naar voeding */
	}
    }
 }
}

/* PROCEDURE CORRIGEER TEG_OV[] VOOR SERIELE KOPPELINGEN */
/* ===================================================== */

void proc_ctegov_crsv_hki()
{
 Int16 fc1,fc2,fc3,i,j,x;
 Int16 kptsg12,kpteg12,kptdm12;
 Int16 kptsg23,kpteg23,kptdm23;
 Int16 stat;
 Int16 naloop;
 Bool _start;

 for (x=0; x<3; x++) {					/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptsg12 = hki[i][3];
	kpteg12 = hki[i][4];
	kptdm12 = hki[i][5];
	fc3     = hki[i][10];
	kptsg23 = hki[i][12];
	kpteg23 = hki[i][13];
	kptdm23 = hki[i][14];
	stat    = hki[i][20];

	if (stat >= 2) {				/* koppeling is aktief */

		if (VAS4[fc1] <= VAS4[fc2]) naloop = VAS4[fc2] - VAS4[fc1];
		else                        naloop = VAS4[fc2] - VAS4[fc1] + CTYD;

		_start = FALSE;
		if (TIJD(kptsg12)) {
			if ((((Int16)inst_TIJD(kptsg12)-(Int16)waarde_TIJD(kptsg12))/10) >
			    (((Int16)inst_TIJD(kpteg12)+(Int16)inst_TIJD(kptdm12))/10)) {
				if ((((Int16)inst_TIJD(kptsg12)-(Int16)waarde_TIJD(kptsg12))/10) < naloop) {
					naloop = ((Int16)inst_TIJD(kptsg12)-(Int16)waarde_TIJD(kptsg12))/10;
					_start = TRUE;
				}
			}
		}

		if (!_start) {
			if ((((Int16)inst_TIJD(kpteg12)+(Int16)inst_TIJD(kptdm12))/10) < naloop) {
				naloop = ((Int16)inst_TIJD(kpteg12)+(Int16)inst_TIJD(kptdm12))/10;
			}
		}

		if (G(fc1) && (TEG_OV[fc1] > 0)) {
			KNP_hki[i][fc2] = naloop + 1;
			if (TEG_OV[fc2] < TEG_OV[fc1] + KNP_hki[i][fc2]) TEG_OV[fc2] = TEG_OV[fc1] + KNP_hki[i][fc2];
			PVAS_hki[i][fc2] |= BIT1;
		}

		if ((!G(fc1) || (TEG_OV[fc1] == 0)) && (HG[fc2] || G(fc2)) && (PVAS_hki[i][fc2]&BIT1)) {
			if (TEG_OV[fc2] < KNP_hki[i][fc2]) TEG_OV[fc2] = KNP_hki[i][fc2];
			if (KNP_hki[i][fc2] == 0) PVAS_hki[i][fc2] &= (~BIT1);
		}

		if ((begin_G(fc1) && !TEG_OV[fc1]) || (!G(fc2) && !HG[fc2]) || einde_G(fc2)) {
			PVAS_hki[i][fc2] &= (~BIT1);
		}

		if (fc3 != NG) {

			if (VAS4[fc2] <= VAS3[fc3]) naloop = VAS4[fc3] - VAS4[fc2];
			else                        naloop = VAS4[fc3] - VAS4[fc2] + CTYD;

			_start = FALSE;
			if (TIJD(kptsg23)) {
				if ((((Int16)inst_TIJD(kptsg23)-(Int16)waarde_TIJD(kptsg23))/10) >
				    (((Int16)inst_TIJD(kpteg23)+(Int16)inst_TIJD(kptdm23))/10)) {
					if ((((Int16)inst_TIJD(kptsg23)-(Int16)waarde_TIJD(kptsg23))/10) < naloop) {
						naloop = ((Int16)inst_TIJD(kptsg23)-(Int16)waarde_TIJD(kptsg23))/10;
						_start = TRUE;
					}
				}
			}

			if (!_start) {
				if ((((Int16)inst_TIJD(kpteg23)+(Int16)inst_TIJD(kptdm23))/10) < naloop) {
					naloop = ((Int16)inst_TIJD(kpteg23)+(Int16)inst_TIJD(kptdm23))/10;
				}
			}

			if ((HG[fc2] || G(fc2)) && (TEG_OV[fc2] > 0)) {
				KNP_hki[i][fc3] = naloop + 1;
				if (TEG_OV[fc3] < TEG_OV[fc2] + KNP_hki[i][fc3]) TEG_OV[fc3] = TEG_OV[fc2] + KNP_hki[i][fc3];
				PVAS_hki[i][fc3] |= BIT1;
			}

			if (((!HG[fc2] && !G(fc2)) || (TEG_OV[fc2] == 0)) && (HG[fc3] || G(fc3)) && (PVAS_hki[i][fc3]&BIT1)) {
				if (TEG_OV[fc3] < KNP_hki[i][fc3]) TEG_OV[fc3] = KNP_hki[i][fc3];
				if (KNP_hki[i][fc3] == 0) PVAS_hki[i][fc3] &= (~BIT1);
			}

			if ((begin_G(fc1) && !TEG_OV[fc1]) || (begin_G(fc2) && !TEG_OV[fc2]) || (!G(fc3) && !HG[fc3]) || einde_G(fc3)) {
				PVAS_hki[i][fc3] &= (~BIT1);
			}
		}

	} else {					/* koppeling is niet aktief */
		 KNP_hki[i][fc2] = 0;
		PVAS_hki[i][fc2] &= (~BIT1);
		if (fc3 >= 0) {
			 KNP_hki[i][fc3] = 0;
			PVAS_hki[i][fc3] &= (~BIT1);
		}
	}
    }

    for (j=0; j<NUMSG_CS; j++) {
	KNP[j] = 0;					/* bepaal KNP per signaalgroep */
	PVAS[j] &= (~BIT1);				/* bepaal PVAS[]&BIT1 per signaalgroep */
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (KNP_hki[i][j] > KNP[j]) {
			KNP[j] = KNP_hki[i][j];
		}
		if (PVAS_hki[i][j]&BIT1) {
			PVAS[j] |= BIT1;
		}
	}
    }
 }
}

/* PROCEDURE BEHANDEL KLOK NA AFLOOP PRIORITEIT */
/* ============================================ */

void proc_knp_crsv_hki()
{
 Int16 fc1,fc2,fc3,i,j,x;
 Int16 stat;

 for (x=0; x<3; x++) {					/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	fc3     = hki[i][10];
	stat    = hki[i][20];

	if (stat >= 2) {				/* koppeling is aktief */

		if ((!G(fc1) || (TEG_OV[fc1] == 0)) && (HG[fc2] || G(fc2)) && (PVAS_hki[i][fc2]&BIT1)) {
			if (TS && (x == 0) && (KNP_hki[i][fc2] > 0)) KNP_hki[i][fc2]--;
		}
		if (einde_G(fc2) || !(PVAS_hki[i][fc2]&BIT1)) KNP_hki[i][fc2] = 0;

		if (fc3 != NG) {
			if (((!HG[fc2] && !G(fc2)) || (TEG_OV[fc2] == 0)) && (HG[fc3] || G(fc3)) && (PVAS_hki[i][fc3]&BIT1)) {
				if (TS && (x == 0) && (KNP_hki[i][fc3] > 0)) KNP_hki[i][fc3]--;
			}
			if (einde_G(fc3) || !(PVAS_hki[i][fc3]&BIT1)) KNP_hki[i][fc3] = 0;
		}
	} else {					/* koppeling is niet aktief */
		 KNP_hki[i][fc2] = 0;
		PVAS_hki[i][fc2] &= (~BIT1);
		if (fc3 >= 0) {
			 KNP_hki[i][fc3] = 0;
			PVAS_hki[i][fc3] &= (~BIT1);
		}
	}
    }

    for (j=0; j<NUMSG_CS; j++) {
	KNP[j] = 0;					/* bepaal KNP per signaalgroep */
	PVAS[j] &= (~BIT1);				/* bepaal PVAS[]&BIT1 per signaalgroep */
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (KNP_hki[i][j] > KNP[j]) {
			KNP[j] = KNP_hki[i][j];
		}
		if (PVAS_hki[i][j]&BIT1) {
			PVAS[j] |= BIT1;
		}
	}
    }
 }
}

/* PROCEDURE CORRIGEER TTP[] EN CTTP[] VOOR FIETS.VOETGANGERSKOPPELINGEN */
/* ===================================================================== */

void proc_cttp_crsv_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 (vtg)	*/
	Int16 fc2,	/* Signaalgroep 2 (vtg)	*/
	Int16 fc3,	/* Gekoppelde.fietsr. 1	*/
	Int16 fc4,	/* Gekoppelde.fietsr. 2	*/
	Int16 fc5,	/* Gekoppelde.fietsr. 3	*/
	Int16 fc6,	/* Gekoppelde.fietsr. 4	*/
	Int16 fc7)	/* Signaalgroep 3e voetganger */
{
 Int16 _maxTTP = 0;
 Int16 _maxCTTP= 0;
 Int16 i,_fc[7];
 Bool  _RR2 = FALSE;

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=fc7;

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if ( TTP[_fc[i]] > _maxTTP)  _maxTTP =  TTP[_fc[i]];
     if (CTTP[_fc[i]] > _maxCTTP) _maxCTTP= CTTP[_fc[i]];
     if (RR[_fc[i]]&BIT2) _RR2 = TRUE;
   }
 }
 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
	TTP[_fc[i]] = _maxTTP;
	if (TTP[_fc[i]] > UTTP[_fc[i]]) TTP[_fc[i]] = UTTP[_fc[i]];
	CTTP[_fc[i]] = _maxCTTP;
	if (_RR2 && (!HG[_fc[i]] || !ROG(_fc[i]) && !RVG(_fc[i])) && !(YM[_fc[i]]&BIT2)) {
		RR[_fc[i]] |= BIT2;
		BAR[_fc[i]] = TRUE;
	}
   }
 }
}

/* PROCEDURE CORRIGEER TTP[] VOOR SERIELE KOPPELING */
/* ================================================ */

void proc_cttp_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,x;
 Int16 kptvs12;
 Int16 kptvs23;
 Int16 voorstart;

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (fc3 >= 0) {
			voorstart = (Int16)inst_TIJD(kptvs23)/10;
			if (!G(fc2) && !G(fc3) && (RR[fc3]&BIT2)) {
				BAR[fc2] |= !G(fc2);
				if ((TTP[fc3] > 0) && (TTP[fc2] < 255) && (TTP[fc3] < 255)) {
					if (TTP[fc2] + voorstart < TTP[fc3]) {
						TTP[fc2] = TTP[fc3] - voorstart;
						if (UTTP[fc2] < TTP[fc2]) TTP[fc2] = UTTP[fc2];
					}
				}
				if (TTP[fc2] > 0) RR[fc2] |= BIT2;
			}
		}

		if (!G(fc1) && !G(fc2) && (RR[fc2]&BIT2)) {
			voorstart = (Int16)inst_TIJD(kptvs12)/10;
			BAR[fc1] |= !G(fc1);
			if ((TTP[fc2] > 0) && (TTP[fc1] < 255) && (TTP[fc2] < 255)) {
				if (TTP[fc1] + voorstart < TTP[fc2]) {
					TTP[fc1] = TTP[fc2] - voorstart;
					if (UTTP[fc1] < TTP[fc1]) TTP[fc1] = UTTP[fc1];
				}
			}
			if (TTP[fc1] > 0) RR[fc1] |= BIT2;
		}
	}
    }
 }
}

/* PROCEDURE BEPAAL PRIMAIRE REALISATIE */
/* ==================================== */

void proc_prim_crsv()
{
 Int16 i,j,k;
 Int16 ontruim;
 Int16 o_tijd,gltijd;
 Bool  ppv;

 if (AKTPRG) {

   for (i=0; i<NUMSG_CS; i++) {
	ppv = FALSE;

	/* Bepaal overslag bij start VAS-programma */
	/* --------------------------------------- */
	if (SVAS) {
	  if (((HVAS[i]&BIT0) || (TTP[i]<=TTW[i])) && !G(i)) {
	    		HVAS[i] |= BIT3;
	    		 TTP[i]  = UTTP[i] = 255;
	       		   X[i] |= BIT1;		/* Registratie overslag */
	  }
	  if (!(HVAS[i]&BIT3)) {
	    for (j=0; j<aant_dgc[i]; j++) {
	      k = gcf[i][j];
							/* Conflict is groen */
	      if (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) {

		/* Bepaal overslag door alternatief conflict */
		/* ----------------------------------------- */
		gltijd = 0;
		o_tijd = 0;
		if (j<aant_gcf[i]) {
		  gltijd =(Int16)inst_GL_TIJD(k)/10;
		  o_tijd =(Int16)inst_O_TIJD(k,i)/10;
		}

	        ontruim = gltijd + o_tijd + TEG[k];
		if (TEG_OV[k] > TEG[k]) ontruim = gltijd + o_tijd + TEG_OV[k];

	        if (TTP[i]<=ontruim) {
		  HVAS[i] |= BIT3;
		   TTP[i]  = UTTP[i] = 255;
		     X[i] |= BIT1;	/* Registratie overslag */
	        }
	      }
	    }
	  }
	}

	/* Bepaal primair gerealiseerd */
	/* --------------------------- */

	if ((HVAS[i]&BIT0) && !(HVAS[i]&BIT3) && R(i) && !GR_TIJD(i)) {
		if (HVAS[i]&BIT5) { VA[i] |= BIT2; }
		if (VA[i]) 	  {  B[i] |= BIT1; }
		else { if (!(FCA[i]&BIT3)) HVAS[i] |= BIT3; }
		if (RR[i]&BIT2) B[i] &= (~BIT1);
	}
	if ((HVAS[i]&BIT0) && (MVG(i) && !RW[i] && !(HVAS[i]&BIT2)
							 || einde_G(i) && !(PVS2[i]&BIT4)))
	     HVAS[i] |= BIT3;
	if  (HVAS[i]&BIT3) {
		TTP[i] = UTTP[i] = 255;
		PVS2[i] &= (~BIT4);
	}

	/* Bepaal afkappen/blokkeren conflicterende groenrealisaties */
	/* --------------------------------------------------------- */

	if (!(HVAS[i]&BIT3)) {
	  ppv = TRUE;
	  for (j=0; j<aant_dgc[i]; j++) {
	    k = gcf[i][j];

	    gltijd = 0;
	    o_tijd = 0;
	    if (j<aant_gcf[i]) {
	      gltijd =(Int16)inst_GL_TIJD(k)/10;
	      o_tijd =(Int16)inst_O_TIJD(k,i)/10;
	    }
	    ontruim = gltijd + o_tijd + TEG[k];

					/* Conflict is groen */

	    if (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) {

	      /* Bepaal overslag door alternatief conflict */
	      /* ----------------------------------------- */
                                                        /* @#@ Fik150201 */
	      if ((TTP[i]<=ontruim) && ((TTP[k]>TTP[i]) || HKV[k] && (G(k) || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7)))) && R(i)
				    && !GR_TIJD(i) && !(HVAS[i]&BIT5) 
				    && !FCA[i] && (!einde_GR_TIJD(i) || !(RR[i]&BIT2))
				    && (!VA[i] || (VA[i]&BIT7))) {
		HVAS[i] |= BIT3;
		 TTP[i]  = UTTP[i] = 255;
		   X[i] |= BIT1;	/* Registratie overslag */
	      }
	      
	      if (!(HVAS[i]&BIT3)) {

	        ontruim = gltijd + o_tijd;

		/* Bepaal tijd tot afkappen door primair conflict */
		/* ---------------------------------------------- */

		if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5)
						  	 ||   FCA[i]) {
		  if (TTP[i]<=ontruim)		    { TTK[k] = FALSE; }
		  else if ((TTP[i]-ontruim)<TTK[k]) { TTK[k] = TTP[i]-ontruim;}
		}

	        if ((TTP[i] <= ontruim)
		   && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim))
		   && ((TTP[k]>TTP[i]) ||  (TTP[k]==0))) {

		  if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5)
						  	   ||   FCA[i]) {
		    if (!(YM[i]&BIT2)) BAR[k] |= TRUE;
		    if (G(k))		 Z[k] |= BIT1;
		  }
	        } else { ppv = FALSE; }

	        if (!((VTTP[i] <= ontruim)
		   && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim))
		   && ((TTP[k]>VTTP[i]) ||  (TTP[k]==0)))) ppv = FALSE;

		if (FCA[k]&BIT0) {     /* Fic.aanv. gekoppelde.vtg. aanwezig */
				       /* danwel voedende fietser aanwezig   */

		  ontruim = gltijd + o_tijd + TTR[k] + ALTM[k];

	          if ((TTP[i] <= ontruim)
		     && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim))
		     && ((TTP[k]>TTP[i]) ||  (TTP[k]==0))) {

		    if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5)
						             ||   FCA[i]) {
		      if (!(YM[i]&BIT2)) BAR[k] |= TRUE;
		    }
	          } else { ppv = FALSE; }

	          if (!((VTTP[i] <= ontruim)
		     && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim))
		     && ((TTP[k]>VTTP[i]) ||  (TTP[k]==0)))) ppv = FALSE;

		}
	      
	      }
	    } else {			/* Conflict is NIET groen */
	      
	      ontruim = gltijd + o_tijd + ALTM[k];

	      if ((TTP[i] <= ontruim + TTR[k]) 
		  && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim + TTR[k]))
		  && (TTP[k]>TTP[i])) {

		if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5)
						 	 ||   FCA[i]) {
		  if (!(YM[i]&BIT2)) BAR[k] |= TRUE;
		}
	      } else { ppv = FALSE; }

	      if (!((VTTP[i] <= ontruim + TTR[k]) 
		  && (!(RR[i]&BIT2) || (UTTP[i] <= ontruim + TTR[k]))
		  && (TTP[k]>VTTP[i]))) ppv = FALSE;

	      /* Bepaal tijd tot afkappen door primair conflict */
	      /* ---------------------------------------------- */

	      if (!(HVAS[i]&BIT3)) {

	        ontruim = gltijd + o_tijd;

		/* Bepaal tijd tot afkappen door primair conflict */
		/* ---------------------------------------------- */

		if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5)
						  	 ||   FCA[i]) {
		  if (TTP[i]<=ontruim)		    { TTK[k] = FALSE; }
		  else if ((TTP[i]-ontruim)<TTK[k]) { TTK[k] = TTP[i]-ontruim;}
		}
	      }
	    }
	  }
	  for (j=0; j<aant_dfc[i]; j++) {
	    k = fcf[i][j];
	    if (TTP[i] >TTP[k]) ppv = FALSE;
	    if (VTTP[i]>TTP[k]) ppv = FALSE;
	  }
	}

	/* Bepaal versnelde primaire realisatie */
	/* ------------------------------------ */

	if (RR[i]&BIT2) { ppv = FALSE; VA[i] &= (~BIT4); }

	if ((ppv || (VA[i]&BIT4)) && !(HVAS[i]&BIT0) && !(HVAS[i]&BIT3) && !(HVAS[i]&BIT1) && !(HVAS[i]&BIT6)) {
		if (G(i)) {
			   HVAS[i] |=  BIT4;
			     RW[i] |=  BIT1;
			     VA[i] &=(~BIT4);
			  }
		else { if ((ROG(i) || RVG(i)) && !BL_OP(i)) VA[i] |= BIT4;
		     }
	} else { VA[i] &= (~BIT4);	/* Resetten indien alsnog RR[i] */
	       }

	/* Bepaal blokkeer overgang naar groen */
	/* ----------------------------------- */

	if ((HVAS[i]&BIT1) && !G(i)) {                         /* Fik150315 toegevoegd || (HVAS[i]&BIT3) */
		if ((TTR[i] < TTU[i]) && !ROG(i) && !RVG(i) || (HVAS[i]&BIT3)) {
				      BAR[i]  = TRUE;
		}
		if (!(B[i]&BIT4) || !RVG(i)) X[i] |= BIT2;
	}

	/* Bepaal forceer overgang naar rood */
	/* --------------------------------- */

	if (HVAS[i]&BIT6) {
		if (!G(i) && !ppv)   {
			if ((TTR[i] < TTU[i]) && !ROG(i) && !RVG(i)) {
				      BAR[i]  = TRUE;
			}
			if (!(B[i]&BIT4) || !RVG(i)) X[i] |= BIT2;
		}
		if (G(i) && (TEG_OV[i] == 0) && ((TTPR[i] != 0) || !(PVS2[i]&BIT1))) {
			Z[i] |= BIT2;
		}
	}

	/* Bepaal vasthouden in VAG2e */
	/* -------------------------- */

	if ((HVAS[i]&BIT2) && G(i)) RW[i] |= BIT1;

	/* Reset realisatie-geheugen op einde primaire gebied */
	/* -------------------------------------------------- */

	if ((STAP==VAS4[i]) && (TS || N_ts)) {
				     HVAS[i] &= (~BIT3);
				     HVAS[i] &= (~BIT4); }
   }
 }
 for (i=0; i<aant_fts; i++) {
   proc_cprm_crsv_vtg_fts(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_cprm_crsv_vtg_fts(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
 }
 for (i=0; i<aant_gov; i++) {
   proc_cprm_crsv_vtg_fts(gov[i][0],gov[i][1],gov[i][7]
			 ,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
 }
}

/* PROCEDURE CORRIGEER OVERSLAG VOOR FTS.VTG.KOPPELINGEN */
/* ===================================================== */

void proc_covs_crsv_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 */
	Int16 fc2)	/* Signaalgroep 2 */
{
 if (fc1 >= 0) {
   if ((X[fc1]&BIT1) || G(fc1) && (RW[fc1]&BIT1)) {
     if (fc2 >= 0) {
       if ((X[fc1]&BIT1) || !G(fc2)) {
	 if ((HVAS[fc1]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc2] |= BIT3;
		 TTP[fc2]  = UTTP[fc2] = 255;
	 }
       }
     }
   }
 }
}

/* PROCEDURE CORRIGEER PRIMAIRE REALISATIE VOOR FTS.VTG.KOPPELINGEN */
/* ================================================================ */

void proc_cprm_crsv_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 */
	Int16 fc2,	/* Signaalgroep 2 */
	Int16 fc3,	/* Signaalgroep 3 */
	Int16 fc4,	/* Signaalgroep 4 */
	Int16 fc5,	/* Signaalgroep 5 */
	Int16 fc6,	/* Signaalgroep 6 */
	Int16 fc7)	/* Signaalgroep 3e voetganger */
{
 Int16 i,j,_fc[7];

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=fc7;

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if (G(_fc[i]) && (HVAS[_fc[i]]&BIT4)) {
	for (j=0; j<7; j++) {
	  if (i != j) {
	    if (_fc[j] >= 0) {
	      if (G(_fc[j]) && !(HVAS[_fc[j]]&BIT0) && !(HVAS[_fc[j]]&BIT3)
						    && !(HVAS[_fc[j]]&BIT4)) {
		HVAS[_fc[j]] |=  BIT4;
		  RW[_fc[j]] |=  BIT1;
		  VA[_fc[j]] &=(~BIT4);
	      }
	    }
	  }
	}
     }
   }
 }
}

/* PROCEDURE BEPAAL TOESTEMMING ALTERNATIEVE REALISATIE DOOR CRSV-MODULE */
/* ===================================================================== */

void proc_altt_crsv()
{
 Int16 i,j,k;

 for (i=0; i<NUMSG_CS; i++) {

  if (!BAR[i] && R(i) && !GR_TIJD(i)) {

    for (j=0; j<aant_dgc[i]; j++) {	/* Primaire conflicten */
      k = gcf[i][j];
      if (B[k] || ROG(k) || RVG(k)
			 ||  HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))
			 ||   G(k) && !(YM[k]&BIT2) && !MVG(k)
			 || MVG(k) && !(YM[k]&BIT2) && RW[k]) BAR[i] = TRUE;
    }

    for (j=0; j<aant_dfc[i]; j++) {	/* Fictieve conflicten */
      k = fcf[i][j];
      if (B[k] || ROG(k) || RVG(k)
	       || HG[k] && ((HG[k]&BIT2) || (HG[k]&BIT7) || (TTP[k] <= TTP[i]))) BAR[i] = TRUE;
    }

  } else { if (!G(i)) BAR[i] = TRUE; }
 }
 for (i=0; i<aant_fts; i++) {
   proc_cbar_crsv_vtg_fts(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_cbar_crsv_vtg_fts(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
 }
 for (i=0; i<aant_gov; i++) {
   proc_cbar_crsv_vtg_fts(gov[i][0],gov[i][1],gov[i][7]
			 ,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
 }
 proc_cbar_crsv_hki();
}

/* PROCEDURE BEPAAL TOESTEMMING ALTERNATIEVE REALISATIE DOOR APPLICATIE */
/* ==================================================================== */

void proc_altt_appl(
	Int16 fc,	/* Signaalgroep    */
	Int16 hfbar)	/* Hulpfunctie BAR */
{
 Int16 i;

 if (HF(hfbar)) BAR[fc] = TRUE;

 for (i=0; i<aant_fts; i++) {
   proc_cbar_crsv_vtg_fts(fts[i][0],NIET,fts[i][1],NIET,fts[i][2],NIET,NIET);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_cbar_crsv_vtg_fts(bbv[i][0],bbv[i][1],bbv[i][4],NIET,bbv[i][5],NIET,NIET);
 }
 for (i=0; i<aant_gov; i++) {
   proc_cbar_crsv_vtg_fts(gov[i][0],gov[i][1],gov[i][7]
			 ,gov[i][8],gov[i][13],gov[i][14],gov[i][22]);
 }
 proc_cbar_crsv_hki();
}

/* PROCEDURE CORRIGEER BAR[] VOOR FIETS.VOETGANGERSKOPPELINGEN */
/* =========================================================== */

void proc_cbar_crsv_vtg_fts(
	Int16 fc1,	/* Signaalgroep 1 (vtg)	*/
	Int16 fc2,	/* Signaalgroep 2 (vtg)	*/
	Int16 fc3,	/* Gekoppelde.fietsr. 1	*/
	Int16 fc4,	/* Gekoppelde.fietsr. 2	*/
	Int16 fc5,	/* Gekoppelde.fietsr. 3	*/
	Int16 fc6,	/* Gekoppelde.fietsr. 4	*/
	Int16 fc7)	/* Signaalgroep 3e voetganger */
{
 Bool _BAR   = FALSE;
 Bool _BAR_a = FALSE;

 Int16 i,j,_fc[7];

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=fc7;

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if (BAR[_fc[i]]) _BAR = TRUE;
     if (GL(_fc[i]) || GR_TIJD(_fc[i])
	 || BAR[_fc[i]] && R(_fc[i]) && VA[_fc[i]]) _BAR_a=TRUE;
   }
 }
 if (_BAR) {
	if (fc1 >= 0) {
		BAR[fc1] = TRUE;
		if (R(fc1) && VA[fc1]) _BAR_a=TRUE;
	}
	if (fc2 >= 0) {
		BAR[fc2] = TRUE;
		if (R(fc2) && VA[fc2]) _BAR_a=TRUE;
	}
	if (fc7 >= 0) {
		BAR[fc7] = TRUE;
		if (R(fc7) && VA[fc7]) _BAR_a=TRUE;
	}
 }
 if ((fc3 >= 0) && (fc4 >= 0)) {
	if (BAR[fc3] || BAR[fc4]) {
		BAR[fc3] = BAR[fc4] = TRUE;
		if (R(fc3) && VA[fc3]) _BAR_a=TRUE;
		if (R(fc4) && VA[fc4]) _BAR_a=TRUE;
	}
 }
 if ((fc5 >= 0) && (fc6 >= 0)) {
	if (BAR[fc5] || BAR[fc6]) {
		BAR[fc5] = BAR[fc6] = TRUE;
		if (R(fc5) && VA[fc5]) _BAR_a=TRUE;
		if (R(fc6) && VA[fc6]) _BAR_a=TRUE;
	}
 }
 if (_BAR_a) {
    for (i=0; i<7; i++) {
	if (_fc[i] >= 0) BAR[_fc[i]] = TRUE;
    }
 }

 /* Correctie BAR i.v.m. aanhouden mvg gekoppelde richtingen */
 /* -------------------------------------------------------- */

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if (!G(_fc[i]) && !BAR[_fc[i]]) {
	for (j=0; j<7; j++) {
	  if (i != j) {
	    if (_fc[j] >= 0) {
	      if (G(_fc[j]) && (TTR[_fc[i]]>=TTK[_fc[j]])) BAR[_fc[i]] = TRUE;
	    }
	  }
	}
     }
   }
 }
}

/* PROCEDURE BEPAAL HULPWAARDEN VOOR INRIJDEN ONDER GROEN CONFLICTEN VOLGRICHTING(EN) */
/* ---------------------------------------------------------------------------------- */

void proc_TTK_hki_crsv()
{
 Int16 i,j,k,x;
 Int16 ontruim_ik,ontruim_ki;
 Int16 o_tijd_ki,gltijd_k;
 Int16 o_tijd_ik,gltijd_i;
 Int16 _hulp_teg;
 Int16 fc1,fc2,fc3,stat;
 Int16 kptvs12,kptvs23;
 Int16 kopvs12,kopvs23;

   for (i=0; i<NUMSG_CS; i++) {
	_HG[i] = FALSE;
	if (!HG[i] || G(i)) {
		TTR_HK[i] = 255;
		_TTR_HK[i] = FALSE;
	}
	TTR_HK_oud[i] = TTR_HK[i];
   }

   if (AKTPRG) {

	for (x=0; x<3; x++) {			/* 3x doorlopen ivm mogelijke geneste koppelingen */
		for (i=0; i<aant_hki; i++) {
			fc1     = hki[i][0];
			fc2     = hki[i][1];
			kptvs12 = hki[i][2];
			fc3     = hki[i][10];
			kptvs23 = hki[i][11];
			stat    = hki[i][20];
			if (stat >= 2) {

				kopvs12 = (Int16)inst_TIJD(kptvs12)/10;
				if (fc3 >= 0) {
					kopvs23 = (Int16)inst_TIJD(kptvs23)/10;
				} else {
					kopvs23 = 0;
				}

				if (HG[fc1]) _HG[fc2] = TRUE;
				if (fc3 >= 0) {
					if (HG[fc2]) _HG[fc3] = TRUE;
				}
						/* bepaal TTR_HK[] */
				if (HG[fc1]) {
					if ((TTR[fc1] + kopvs12) < TTR_HK[fc2]) TTR_HK[fc2] = TTR[fc1] + kopvs12;
					if (fc3 >= 0) {
						if ((TTR_HK[fc2] + kopvs23) < TTR_HK[fc3]) TTR_HK[fc3] = TTR_HK[fc2] + kopvs23;
					}
				}

				if (G(fc1)) {
					if (KG[fc1] >= kopvs12) TTR_HK[fc2] = 0;
					else {
						if ((kopvs12 - KG[fc1]) < TTR_HK[fc2]) TTR_HK[fc2] = kopvs12 - KG[fc1];
					}
					if (fc3 >= 0) {
						if (KG[fc1] >= kopvs12 + kopvs23) TTR_HK[fc3] = 0;
						else {
							if ((kopvs12 + kopvs23 - KG[fc1]) < TTR_HK[fc3]) TTR_HK[fc3] = kopvs12 + kopvs23 - KG[fc1];
						}
					}
				}

				if (einde_G(fc1)) {
					_TTR_HK[fc2] = TRUE;
					if (fc3 >= 0) _TTR_HK[fc3] = TRUE;
				}

			}
		}
	}

	for (i=0; i<NUMSG_CS; i++) {
		if (TTR_HK[i] < TTR_HK_oud[i]) _TTR_HK[i] = FALSE;		/* idg is er kennelijk een andere voeding aktief (G of HG) en maatgevend */
		/* if ((TS || N_ts) && _TTR_HK[i] && (TTR_HK[i] > 0)) TTR_HK[i]--; aftellen _TTR_HK[] verplaatst naar proc_reset_crsv_einde() */
										/* ... want mag maar 1x per machineslag worden doorlopen !!!  */

		TTK_hki[i] = 255;	/* eerstvolgend conflict kapt fc i af na 255 seconden */
		TEG_hki[i] = 0;		/* lopend conflict zorgt dat fc i kan starten na 0 seconden */

		TSPR[i] = 255;
		TEPR[i] = 0;

		if (G(i) && !VG(i) && !WG(i) && (KG[i] >= MAXG[i])) {
			for (j=0; j<aant_dgc[i]; j++) {
				k = gcf[i][j];

				gltijd_k  = 0;
				o_tijd_ki = 0;

				gltijd_i  = 0;
				o_tijd_ik = 0;

				if (j<aant_gcf[i]) {
					gltijd_k  =(Int16)inst_GL_TIJD(k)/10;
					o_tijd_ki =(Int16)inst_O_TIJD(k,i)/10;

					gltijd_i  =(Int16)inst_GL_TIJD(i)/10;
					o_tijd_ik =(Int16)inst_O_TIJD(i,k)/10;
				}

				if (HG[k] || _HG[k]) {
					if (TTR_HK[k] <= (gltijd_i + o_tijd_ik)) {
						Z[i] |= BIT7;
						/* YV[i] &= (~BIT2); */
#ifdef RWSC_old
						/* reset_H1e_TIJD(i); */
						/* reset_H2e_TIJD(i); */
#else
						/* reset_H1e_loopt(i); */
						/* reset_H2e_loopt(i); */
#endif
					}
					if (_HG[k]) BHK[i] = TRUE;
				}
			}
		}

		if ((VAS2[i] != 0) && (VAS4[i] != 0) && (VAS2[i] != VAS4[i])) {

			if (TTP[i] == 255) {
				if (STAP <= VAS2[i]) TSPR[i] = VAS2[i] - STAP;
				else                 TSPR[i] = CTYD    - STAP + VAS2[i];

				/* Fik130216 -> als richting vooruit is gerealiseerd dan TSPR[i] corrigeren */
				if (TSPR[i] < CTYD - MAXG[i]) TSPR[i] = CTYD + TSPR[i];

			} else {
				TSPR[i] = TTP[i];
			}

			if (HVAS[i]&BIT0) {
				if (STAP <= VAS4[i]) TEPR[i] = VAS4[i] - STAP;
				else                 TEPR[i] = CTYD    - STAP + VAS4[i];
			}
		}
	}

	for (i=0; i<NUMSG_CS; i++) {

		for (j=0; j<aant_dgc[i]; j++) {

			k = gcf[i][j];
			gltijd_k  = 0;
			o_tijd_ki = 0;

			gltijd_i  = 0;
			o_tijd_ik = 0;

			if (j<aant_gcf[i]) {
				gltijd_k  =(Int16)inst_GL_TIJD(k)/10;
				o_tijd_ki =(Int16)inst_O_TIJD(k,i)/10;

				gltijd_i  =(Int16)inst_GL_TIJD(i)/10;
				o_tijd_ik =(Int16)inst_O_TIJD(i,k)/10;
			}

        		ontruim_ki = gltijd_k + o_tijd_ki;
        		ontruim_ik = gltijd_i + o_tijd_ik;

			if (G(i) || GL(i) || GR_TIJD(i) || VA[i] || (HVAS[i]&BIT5) || FCA[i]) {

				if (TTP[i] > 0) {

					if (TSPR[i] <= ontruim_ki)		  { TTK_hki[k] = FALSE; }
					else if ((TSPR[i]-ontruim_ki)<TTK_hki[k]) { TTK_hki[k] = TSPR[i]-ontruim_ki; }

					if ((KG[i] > MAXG[i]) || MVG(i) && !RW[i]) _hulp_teg = 0; /* Fik130302 */
					else                                       _hulp_teg = MAXG[i] - KG[i];

					if (G(i) && (TEG_hki[k] < (   TEG[i]+ontruim_ik))) TEG_hki[k] =    TEG[i]+ontruim_ik;
					if (G(i) && (TEG_hki[k] < (_hulp_teg+ontruim_ik))) TEG_hki[k] = _hulp_teg+ontruim_ik;

				} else {

					if (!G(i)) TTK_hki[k] = FALSE;

					if (G(i) && (TEG_hki[k] < ( TEG[i]+ontruim_ik))) TEG_hki[k] =  TEG[i]+ontruim_ik;
					if (G(i) && (TEG_hki[k] < (TEPR[i]+ontruim_ik))) TEG_hki[k] = TEPR[i]+ontruim_ik;
				}

				if ((TTPR[i] > 0) && (TTPR[i] < 255)) {

					if (TTPR[i]<=ontruim_ki)		  { TTK_hki[k] = FALSE; }
					else if ((TTPR[i]-ontruim_ki)<TTK_hki[k]) { TTK_hki[k] = TTPR[i]-ontruim_ki; }

					if (G(i) && (TEG_hki[k] < (TEG_OV[i]+ontruim_ik))) TEG_hki[k] = TEG_OV[i]+ontruim_ik;

				} else {
					if (!G(i) && (TTPR[i] == 0)) TTK_hki[k] = FALSE;
					if ( G(i) && (TEG_hki[k] < (TEG_OV[i]+ontruim_ik))) TEG_hki[k] = TEG_OV[i]+ontruim_ik;
				}
			}
		}
	}
    }
}   

/* PROCEDURE CORRIGEER BAR[] VOOR SERIELE KOPPELINGEN */
/* ================================================== */

void proc_cbar_crsv_hki()
{
 Int16 fc1,fc2,fc3,stat,i,x;
 Int16 kptvs12,kptsg12,kpteg12,kptdm12;
 Int16 kptvs23,kptsg23,kpteg23,kptdm23;

 Int16 kopvs12,kopsg12,kopeg12,kopdm12;
 Int16 kopvs23,kopsg23,kopeg23,kopdm23;

 Int16 tijd_tot_sg2,tijd_tot_eg2;

 proc_TTK_hki_crsv();				/* bepaal hulpwaarden TTK_hki[] en TEG_hki[] */

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	kptsg12 = hki[i][3];
	kpteg12 = hki[i][4];
	kptdm12 = hki[i][5];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	kptsg23 = hki[i][12];
	kpteg23 = hki[i][13];
	kptdm23 = hki[i][14];
	stat    = hki[i][20];

	kopvs12 = (Int16)inst_TIJD(kptvs12)/10;
	kopsg12 = (Int16)inst_TIJD(kptsg12)/10;
	kopeg12 = (Int16)inst_TIJD(kpteg12)/10;
	kopdm12 = (Int16)inst_TIJD(kptdm12)/10;

	if (fc3 >= 0) {
		kopvs23 = (Int16)inst_TIJD(kptvs23)/10;
		kopsg23 = (Int16)inst_TIJD(kptsg23)/10;
		kopeg23 = (Int16)inst_TIJD(kpteg23)/10;
		kopdm23 = (Int16)inst_TIJD(kptdm23)/10;
	} else {
		kopvs23 = 0;
		kopsg23 = 0;
		kopeg23 = 0;
		kopdm23 = 0;
	}

	if (stat >= 2) {			/* koppeling is aktief */

		if (!G(fc1)) {
			if (ALTM[fc1] + kopeg12 > kopsg12) {
				tijd_tot_eg2 = TTR[fc1]+ALTM[fc1]+kopeg12+kopdm12;
			} else {
				tijd_tot_eg2 = TTR[fc1]+kopsg12+kopdm12;
			}
			if ((TTR[fc2] + ALTM[fc2]) > tijd_tot_eg2) tijd_tot_eg2 = TTR[fc2] + ALTM[fc2];
			tijd_tot_sg2 = tijd_tot_eg2 - ALTM[fc1];

			if (G(fc2)) {
				if (ALTM[fc1] + kopeg12 > kopsg12) {
					if ((TTR[fc1]+ALTM[fc1]+kopeg12+kopdm12) >= TTK[fc2]) BAR[fc1] |= TRUE;
				} else {
					if ((TTR[fc1]          +kopsg12+kopdm12) >= TTK[fc2]) BAR[fc1] |= TRUE;
				}
			} else {
				if (TTP[fc2]>kopvs12) {
					/* if (BAR[fc2] || somfbk(fc2)) BAR[fc1] |= TRUE; */
                                        /* && somfbk(fc2) toegevoegd Fik130408 */
					if (somfbk(fc2) && ((TTR[fc2] > kopvs12) || (TEG_hki[fc2] > kopvs12))) BAR[fc1] |= TRUE;
					if (ALTM[fc1] + kopeg12 > kopsg12) {
						if ((TTR[fc1]+ALTM[fc1]+kopeg12+kopdm12) >= TTK_hki[fc2]) BAR[fc1] |= TRUE;
					} else {
						if ((TTR[fc1]          +kopsg12+kopdm12) >= TTK_hki[fc2]) BAR[fc1] |= TRUE;
					}
				 }
			}

			if (fc3 >= 0) {

				if (G(fc3)) {
					if (ALTM[fc2] + kopeg23 > kopsg23) {
						if ((tijd_tot_eg2+kopeg23+kopdm23) >= TTK[fc3]) BAR[fc1] |= TRUE;
					} else {
						if ((tijd_tot_sg2+kopsg23+kopdm23) >= TTK[fc3]) BAR[fc1] |= TRUE;
					}

				} else {
					if (TTP[fc3] > (tijd_tot_sg2 + kopvs23)) {
						if ((TTR[fc3] > (tijd_tot_sg2 + kopvs23)) || (TEG_hki[fc2] > (tijd_tot_sg2 + kopvs23))) BAR[fc1] |= TRUE;
						if (ALTM[fc2] + kopeg23 > kopsg23) {
							if ((tijd_tot_eg2+kopeg23+kopdm23) >= TTK_hki[fc3]) BAR[fc1] |= TRUE;
						} else {
							if ((tijd_tot_sg2+kopsg23+kopdm23) >= TTK_hki[fc3]) BAR[fc1] |= TRUE;
						}
				 	}
				}
			}

		} else {			/* Voedende richting is groen     */
			if (!G(fc2)) {		/* ... maar volgrichting nog niet */
				/* if ((TEG[fc2] >= TTK[fc2]) && (TTP[fc2] > TTK[fc2])) BAR[fc1] |= TRUE; Fik110806 */
				if ((TEG[fc2] >= TTK[fc2]) && (TTP[fc2] > TTK[fc2]) && (TTK[fc2] > 0)) BAR[fc1] |= TRUE;
			}
			if (fc3 >= 0) {
				if (!G(fc3)) {
					/* if ((TEG[fc3] >= TTK[fc3]) && (TTP[fc3] > TTK[fc3])) BAR[fc1] |= TRUE; Fik110806 */
					if ((TEG[fc3] >= TTK[fc3]) && (TTP[fc3] > TTK[fc3]) && (TTK[fc3] > 0)) BAR[fc1] |= TRUE;
				}
			}
		}

		if (fc3 >= 0) {
			if (!G(fc2) && !HG[fc2]) {
				if (G(fc3)) {
					if (ALTM[fc2] + kopeg23 > kopsg23) {
						if ((TTR[fc2]+ALTM[fc2]+kopeg23+kopdm23) >= TTK[fc3]) BAR[fc2] |= TRUE;
					} else {
						if ((TTR[fc2]          +kopsg23+kopdm23) >= TTK[fc3]) BAR[fc2] |= TRUE;
					}
				} else {
					if (TTP[fc3]>kopvs23) {
						/* if (BAR[fc3] || somfbk(fc3)) BAR[fc2] |= TRUE; */
                                                /* Fik130408 && somfbk(fc3) toegevoegd */
						if (somfbk(fc3) && ((TTR[fc3] > kopvs23) || (TEG_hki[fc3] > kopvs23))) BAR[fc2] |= TRUE;
						if (ALTM[fc2] + kopeg23 > kopsg23) {
							if ((TTR[fc2]+ALTM[fc2]+kopeg23+kopdm23) >= TTK_hki[fc3]) BAR[fc2] |= TRUE;
						} else {
							if ((TTR[fc2]          +kopsg23+kopdm23) >= TTK_hki[fc3]) BAR[fc2] |= TRUE;
						}
				 	}
				}
			} else {		/* Voedende richting is groen     */
				if (!G(fc3)) {	/* ... maar volgrichting nog niet */
					if ((TEG[fc3] >= TTK[fc3]) && (TTP[fc3] > TTK[fc3]) && (TTK[fc3] > 0) && BW_hki[i][fc2]) BAR[fc2] |= TRUE;
				}
			}
		}
	}
    }
 }
}

/* PROCEDURE BEPAAL ALTERNATIEVE REALISATIE */
/* ======================================== */

void proc_altr_crsv()
{
 Int16 i,j,k,x,y;
 Int16 fc1,fc2,fc3,stat;
 Bool  altr,bewaak;

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	fc3     = hki[i][10];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (B[fc1] || ROG(fc1) || RVG(fc1) || (PVS2[fc1]&BIT4)
			 ||   G(fc1) && !(YM[fc1]&BIT2) && !MVG(fc1)
			 || MVG(fc1) && !(YM[fc1]&BIT2) && RW[fc1]) {

			for (y=0; y<aant_dgc[fc2]; y++) {
				k = gcf[fc2][y];
				if (!G(fc1) && !(PVS2[fc1]&BIT4) ||
				     G(fc2) || HG[fc2] && ((HG[fc2]&BIT2) || (HG[fc2]&BIT7) || (TTP[fc2] <= TTP[k]))) if (!G(k)) BAR[k] |= TRUE;
			}

			if (B[fc1] || ROG(fc1) || RVG(fc1) || (PVS2[fc1]&BIT4)) {
				for (y=0; y<aant_dfc[fc2]; y++) {
					k = fcf[fc2][y];
					if (!G(k)) BAR[k] |= TRUE;
				}
			}

			if (fc3 >= 0) {

				for (y=0; y<aant_dgc[fc3]; y++) {
					k = gcf[fc3][y];
					if (!G(fc1) && !(PVS2[fc1]&BIT4) ||
					     G(fc3) || HG[fc3] && ((HG[fc3]&BIT2) || (HG[fc3]&BIT7) || (TTP[fc3] <= TTP[k]))) if (!G(k)) BAR[k] |= TRUE;
				}

				if (B[fc1] || ROG(fc1) || RVG(fc1) || (PVS2[fc1]&BIT4)) {
					for (y=0; y<aant_dfc[fc3]; y++) {
						k = fcf[fc3][y];
						if (!G(k)) BAR[k] |= TRUE;
					}
				}
			}
   		}

		if (fc3 >= 0) {

			if (B[fc2] || ROG(fc2) || RVG(fc2) || (PVS2[fc2]&BIT4)
				 ||   G(fc2) && !(YM[fc2]&BIT2) && !MVG(fc2)
				 || MVG(fc2) && !(YM[fc2]&BIT2) && RW[fc2]) {

				for (y=0; y<aant_dgc[fc3]; y++) {
					k = gcf[fc3][y];
					if (!G(fc2) && !(PVS2[fc2]&BIT4) ||
					     G(fc3) || HG[fc3] && ((HG[fc3]&BIT2) || (HG[fc3]&BIT7) || (TTP[fc3] <= TTP[k]))) if (!G(k)) BAR[k] |= TRUE;
				}

				if (B[fc2] || ROG(fc2) || RVG(fc2) || (PVS2[fc2]&BIT4)) {
					for (y=0; y<aant_dfc[fc3]; y++) {
						k = fcf[fc3][y];
						if (!G(k)) BAR[k] |= TRUE;
					}
				}
	   		}
		}

		if (!BAR[fc1] && R(fc1) && !GR_TIJD(fc1) && VA[fc1]) {

			for (y=0; y<aant_dgc[fc2]; y++) {
				k = gcf[fc2][y];
				if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc1])) BAR[fc1] |= TRUE;
				if (B[fc1] || !BAR[fc1] && (KRA[fc1]> KRA[k]  )) BAR[k]   |= TRUE;
			}

			for (y=0; y<aant_dfc[fc2]; y++) {
				k = fcf[fc2][y];
				if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc1])) BAR[fc1] |= TRUE;
				if (B[fc1] || !BAR[fc1] && (KRA[fc1]> KRA[k]  )) BAR[k]   |= TRUE;
			}

			if (fc3 >= 0) {

				for (y=0; y<aant_dgc[fc3]; y++) {
					k = gcf[fc3][y];
					if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc1])) BAR[fc1] |= TRUE;
					if (B[fc1] || !BAR[fc1] && (KRA[fc1]> KRA[k]  )) BAR[k]   |= TRUE;
				}

				for (y=0; y<aant_dfc[fc3]; y++) {
					k = fcf[fc3][y];
					if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc1])) BAR[fc1] |= TRUE;
					if (B[fc1] || !BAR[fc1] && (KRA[fc1]> KRA[k]  )) BAR[k]   |= TRUE;
				}

			}
		}

		if (fc3 >= 0) {

			if (!BAR[fc2] && R(fc2) && !GR_TIJD(fc2) && VA[fc2]) {

				for (y=0; y<aant_dgc[fc3]; y++) {
					k = gcf[fc3][y];
					if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc2])) BAR[fc2] |= TRUE;
					if (B[fc2] || !BAR[fc2] && (KRA[fc2]> KRA[k]  )) BAR[k]   |= TRUE;
				}

				for (y=0; y<aant_dfc[fc3]; y++) {
					k = fcf[fc3][y];
					if (B[k]   || !BAR[k]   && (KRA[k]  >=KRA[fc2])) BAR[fc2] |= TRUE;
					if (B[fc2] || !BAR[fc2] && (KRA[fc2]> KRA[k]  )) BAR[k]   |= TRUE;
				}
			}
		}
	}
    }
 }

 for (i=0; i<NUMSG_CS; i++) {

	if (!BAR[i] && R(i) && !GR_TIJD(i) && VA[i] && !(VA[i]&BIT7)) {

		altr = TRUE;
		for (j=0; j<aant_dgc[i]; j++) {	/* Primaire conflicten */
			k = gcf[i][j];
			if (B[k] || !BAR[k] && (KRA[k]>KRA[i])) altr = FALSE;
		}

		for (j=0; j<aant_dfc[i]; j++) {	/* Fictieve conflicten */
			k = fcf[i][j];
			if (B[k] || !BAR[k] && (KRA[k]>KRA[i])) altr = FALSE;
		}

		if (altr && !somfbk(i) && AKTPRG) B[i] |= BIT2;
  	}
	if ((ROG(i) || RVG(i)) && (BAR[i] || somfbk(i)) && !(B[i]&BIT4) && !(HVAS[i]&BIT0)) RR[i] |= BIT1;
 }


 /* Fik130408 nooit meer dan 1x alternatief per machineslag indien dit een voedende hki richting betreft */
 bewaak = FALSE;
 for (i=0; i<NUMSG_CS; i++) {
   if (R(i) && (B[i] == BIT2) && !RVG(i)) {
     for (x=0; x<aant_hki; x++) {
       fc1     = hki[x][0];
       fc2     = hki[x][1];
       stat    = hki[x][20];
       if (stat >= 2) {
         if ((i == fc1) || (i == fc2)) bewaak = TRUE;
       }
     }
   }
 }

 if (bewaak) {
   for (i=0; i<NUMSG_CS; i++) {
     if (R(i) && (B[i] == BIT2) && !RVG(i)) {
       for (j=0; j<NUMSG_CS; j++) {
         if (R(j) && (B[j] == BIT2) && !RVG(j) && (i != j)) {
           if (KRA[j] > KRA[i]) B[i] &= (~BIT2); 
           else                 B[j] &= (~BIT2); 
         }
       }
     }
   }
 }

}

/* PROCEDURE VOETGANGERS.FIETSOVERSTEEK */
/* ==================================== */

void proc_vtg_fts_crsv(
	Int16 fc1,	/* Signaalgroep 1 (vtg)	  */
	Int16 fc2,	/* Signaalgroep 2 (fts 1) */
	Int16 fc3,	/* Signaalgroep 3 (fts 2) */
	Int16 mre23,	/* Meerea.fts 1 met fts 2 */
	Int16 mre32)	/* Meerea.fts 2 met fts 1 */
{
 Bool xu1,xu2,xu3;
 Bool _BLW = FALSE;
 Bool _REA = FALSE;

 Int16 i,j,_fc[3];

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;

 /* Altijd gelijktijdig starten wachtstand */
 /* -------------------------------------- */

 for (i=0; i<3; i++) {
   if (_fc[i] >= 0) {
     if (GL(_fc[i]) || GR_TIJD(_fc[i]) || K[_fc[i]]
      || (R(_fc[i]) && (BAR[_fc[i]] || RR[_fc[i]]))) _BLW = TRUE;
   }
 }
 if (_BLW) {
   for (i=0; i<3; i++) {
     if (_fc[i] >= 0) BLW[_fc[i]] = TRUE;
   }
 }

 /* Opzetten cyc.prim.aanvraag indien gekoppelde richting versneld inkomt */
 /* --------------------------------------------------------------------- */

 for (i=0; i<3; i++) {
   if (_fc[i] >= 0) {
     if (R(_fc[i]) && !GR_TIJD(_fc[i]) && (HVAS[_fc[i]]&BIT5)) {
       for (j=0; j<3; j++) {
	 if (i != j) {
	   if (_fc[j] >= 0) {
	     if (VA[_fc[j]]&BIT4) { VA[_fc[i]] |= BIT2; VA[_fc[i]] |= BIT4; }
	   }
	 }
       }
     }
   }
 }

 /* Doorschrijven koppelaanvragen */
 /* ----------------------------- */

 if (fc2 >= 0) VA[fc2] &= (~BIT3);
 if (fc3 >= 0) VA[fc3] &= (~BIT3);

 if (fc1 >= 0) {
   if (R(fc1) && !GR_TIJD(fc1) && VA[fc1]) {
     if (fc2 >= 0) {
	if (!BL_OP(fc2) || G(fc2)) VA[fc2] |= BIT3;
     }
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
   }
 }
 if (fc2 >= 0) {
   if (R(fc2) && !GR_TIJD(fc2) && VA[fc2]) {
     if ((fc3 >= 0) && (mre32 >= 0)) {
	if (SCH(mre32) && (!BL_OP(fc3) || G(fc3))) VA[fc3] |= BIT3;
     }
   }
 }
 if (fc3 >= 0) {
   if (R(fc3) && !GR_TIJD(fc3) && VA[fc3]) {
     if ((fc2 >= 0) && (mre23 >= 0)) {
	if (SCH(mre23) && (!BL_OP(fc2) || G(fc2))) VA[fc2] |= BIT2;
     }
   }
 }

 /* Beurt t.b.v. gelijke start */
 /* -------------------------- */

 for (i=0; i<3; i++) {
   if (_fc[i] >= 0) {
     if ((B[_fc[i]] || ROG(_fc[i]) || RVG(_fc[i]))
	 && VA[_fc[i]] && !RR[_fc[i]]) _REA = TRUE;
   }
 }
 if (_REA) {
   for (i=0; i<3; i++) {
     if (_fc[i] >= 0) {
	if (R(_fc[i]) && !GR_TIJD(_fc[i]) && VA[_fc[i]]) {
	  B[_fc[i]] |= BIT3;
	  RR[_fc[i]] = FALSE;
	}
     }
   }
 }

 /* Vasthouden meeverlenggroen */
 /* -------------------------- */

 if (fc1 >= 0) {
   if ((B[fc1] || ROG(fc1) || RVG(fc1)) && !RR[fc1]) {
     if (fc2 >= 0) { if (G(fc2)) YM[fc2] |= BIT3; }
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
   }
   if (G(fc1) && (!WG(fc1) || begin_WG(fc1)) && (!MVG(fc1) || (RW[fc1]&BIT3))){
     if (fc2 >= 0) { if (G(fc2) && !somfbk(fc2)) YM[fc2] |= BIT1; }
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
   }
 }
 if (fc2 >= 0) {
   if ((B[fc2] || ROG(fc2) || RVG(fc2)) && !RR[fc2]) {
     if (fc1 >= 0) { if (G(fc1)) YM[fc1] |= BIT3; }
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
   }
 }
 if (fc3 >= 0) {
   if ((B[fc3] || ROG(fc3) || RVG(fc3)) && !RR[fc3]) {
     if (fc1 >= 0) { if (G(fc1)) YM[fc1] |= BIT3; }
     if (fc2 >= 0) { if (G(fc2)) YM[fc2] |= BIT3; }
   }
 }

 /* Uitstel t.b.v. gelijke start */
 /* ---------------------------- */

 xu1 = xu2 = xu3 = TRUE;

 if (fc1 >= 0) {
   if (RVG(fc1) && !K[fc1]  && !X[fc1] && !RR[fc1] || G(fc1)
   || (WR(fc1) || ROG(fc1)) && !GR_TIJD(fc1) && !VA[fc1]) xu1 = FALSE;
 } else {
   xu1 = FALSE;
 }
 if (fc2 >= 0) {
   if (RVG(fc2) && !K[fc2]  && !X[fc2] && !RR[fc2] || G(fc2)
   || (WR(fc2) || ROG(fc2)) && !GR_TIJD(fc2) && !VA[fc2]) xu2 = FALSE;
 } else {
   xu2 = FALSE;
 }
 if (fc3 >= 0) {
   if (RVG(fc3) && !K[fc3]  && !X[fc3] && !RR[fc3] || G(fc3)
   || (WR(fc3) || ROG(fc3)) && !GR_TIJD(fc3) && !VA[fc3]) xu3 = FALSE;
 } else {
   xu3 = FALSE;
 }
 if (xu1 || xu2 || xu3) { if (fc1 >= 0) X[fc1] |= BIT3;
			  if (fc2 >= 0) X[fc2] |= BIT3;
			  if (fc3 >= 0) X[fc3] |= BIT3;
 }

 /* Altijd gelijktijdig overslag */
 /* ---------------------------- */

 if (fc1 >= 0) {
   proc_covs_crsv_vtg_fts(fc1,fc2);
   proc_covs_crsv_vtg_fts(fc1,fc3);
 }
 if (fc2 >= 0) {
   proc_covs_crsv_vtg_fts(fc2,fc1);
   proc_covs_crsv_vtg_fts(fc2,fc3);
 }
 if (fc3 >= 0) {
   proc_covs_crsv_vtg_fts(fc3,fc1);
   proc_covs_crsv_vtg_fts(fc3,fc2);
 }

 /* Voorkom doorsnijden koppeling langzaam verkeer */
 /* ---------------------------------------------- */

 for (i=0; i<3; i++) {
   if (_fc[i] >= 0) {
	PVS2[_fc[i]] |= BIT2;
   }
 }
}

/* PROCEDURE PROGRESSIEVE VOETGANGERSOVERSTEEK */
/* =========================================== */
void proc_bb_vtg_crsv(
	Int16 fc1,	/* Signaalgroep 1	 */
	Int16 fc2,	/* Signaalgroep 2	 */
	Int16 kpt12,	/* KoppelTIJD eg1 -> eg2 */
	Int16 fc3,	/* Gekoppelde fietser 1  */
	Int16 fc4,	/* Gekoppelde fietser 2  */
	Int16 mre34,	/* Meerea. fiets 1 met 2 */
	Int16 mre43)	/* Meerea. fiets 2 met 1 */
{
 Bool xu1,xu2,xu3,xu4;
 Bool _BLW = FALSE;
 Bool _REA = FALSE;

 Int16 i,j,_fc[4];
 Int16 kop12 = 0;
 if ((fc1 >= 0) && (fc2 >= 0)) kop12 = (Int16)inst_TIJD(kpt12)/10;

 _fc[0]=fc1; _fc[1]=fc2;
 _fc[2]=fc3; _fc[3]=fc4;

 /* Altijd gelijktijdig starten wachtstand */
 /* -------------------------------------- */

 for (i=0; i<4; i++) {
   if (_fc[i] >= 0) {
     if (GL(_fc[i]) || GR_TIJD(_fc[i]) || K[_fc[i]]
      || (R(_fc[i]) && (BAR[_fc[i]] || RR[_fc[i]]))) _BLW = TRUE;
   }
 }
 if (_BLW) {
   for (i=0; i<4; i++) {
     if (_fc[i] >= 0) BLW[_fc[i]] = TRUE;
   }
 }

 /* Opzetten cyc.prim.aanvraag indien gekoppelde richting versneld inkomt */
 /* --------------------------------------------------------------------- */

 for (i=0; i<4; i++) {
   if (_fc[i] >= 0) {
     if (R(_fc[i]) && !GR_TIJD(_fc[i]) && (HVAS[_fc[i]]&BIT5)) {
       for (j=0; j<4; j++) {
	 if (i != j) {
	   if (_fc[j] >= 0) {
	     if (VA[_fc[j]]&BIT4) { VA[_fc[i]] |= BIT2; VA[_fc[i]] |= BIT4; }
	   }
	 }
       }
     }
   }
 }

 /* Doorschrijven koppelaanvragen */
 /* ----------------------------- */

 if (fc2 >= 0) VA[fc2] &= (~BIT3);
 if (fc3 >= 0) VA[fc3] &= (~BIT3);
 if (fc4 >= 0) VA[fc4] &= (~BIT3);

 if ((fc1 >= 0) && (fc2 >= 0)) {	/* voetgangerskoppeling */
   if ((R(fc1) && !GR_TIJD(fc1) && VA[fc1]
				|| G(fc1)) && (!BL_OP(fc2) || G(fc2)))
      VA[fc2] |= BIT3;
 }
 if (fc1 >= 0) {			/* fietsers met voetgangers */
   if (R(fc1) && !GR_TIJD(fc1) && VA[fc1]) {
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
     if (fc4 >= 0) {
	if (!BL_OP(fc4) || G(fc4)) VA[fc4] |= BIT3;
     }
   }
 }
 if (fc2 >= 0) {
   if (R(fc2) && !GR_TIJD(fc2) && VA[fc2]) {
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
     if (fc4 >= 0) {
	if (!BL_OP(fc4) || G(fc4)) VA[fc4] |= BIT3;
     }
   }
 }
 if (fc3 >= 0) {			/* fietsers met fietsers */
   if (R(fc3) && !GR_TIJD(fc3) && VA[fc3]) {
     if ((fc4 >= 0) && (mre43 >= 0)) {
	if (SCH(mre43) && (!BL_OP(fc4) || G(fc4))) VA[fc4] |= BIT3;
     }
   }
 }
 if (fc4 >= 0) {
   if (R(fc4) && !GR_TIJD(fc4) && VA[fc4]) {
     if ((fc3 >= 0) && (mre34 >= 0)) {
	if (SCH(mre34) && (!BL_OP(fc3) || G(fc3))) VA[fc3] |= BIT3;
     }
   }
 }

 /* Herstart koppeltijd */
 /* ------------------- */

 if ((fc1 >= 0) && (fc2 >= 0)) {
   if (G(fc1)) {
	herstart_TIJD(kpt12);
	VA[fc1] |= BIT6;
   }
 }

 /* Vasthouden groen naloop-richting */
 /* -------------------------------- */

 if ((fc1 >= 0) && (fc2 >= 0)) {
   if (G(fc1) || TIJD(kpt12) || B[fc1] || ROG(fc1) || RVG(fc1))
	RW[fc2] |= BIT3;

   if ((VAG2e(fc2) || MVG(fc2)) && (RW[fc2]&BIT3)) YM[fc2] |=  BIT2;
   else						   YM[fc2] &=(~BIT2);

   if ((HVAS[fc1]&BIT3) && G(fc2) && (YM[fc2]&BIT2)) {
	if ((HVAS[fc1]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc2] |= BIT3;
		 TTP[fc2]  = UTTP[fc2] = 255;
	}
   }
 }

 /* Beurt t.b.v. gelijke start */
 /* -------------------------- */

 for (i=0; i<4; i++) {
   if (_fc[i] >= 0) {
     if ((B[_fc[i]] || ROG(_fc[i]) || RVG(_fc[i]))
	 && VA[_fc[i]] && !RR[_fc[i]]) _REA = TRUE;
   }
 }
 if (_REA) {
   for (i=0; i<4; i++) {
     if (_fc[i] >= 0) {
	if (R(_fc[i]) && !GR_TIJD(_fc[i]) && VA[_fc[i]]) {
	  B[_fc[i]] |= BIT3;
	  RR[_fc[i]] = FALSE;
	}
     }
   }
 }

 /* Vasthouden meeverlenggroen */
 /* -------------------------- */

 if (fc1 >= 0) {
   if ((B[fc1] || ROG(fc1) || RVG(fc1)) && !RR[fc1]) {
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
   }
   if (G(fc1) && (!WG(fc1) || begin_WG(fc1)) && (!MVG(fc1) || (RW[fc1]&BIT3))){
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
     if (fc4 >= 0) { if (G(fc4) && !somfbk(fc4)) YM[fc4] |= BIT1; }
   }
 }
 if (fc2 >= 0) {
   if ((B[fc2] || ROG(fc2) || RVG(fc2)) && !RR[fc2]) {
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
   }
   if (G(fc2) && (!WG(fc2) || begin_WG(fc2)) && (!MVG(fc2) || (RW[fc2]&BIT3))){
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
     if (fc4 >= 0) { if (G(fc4) && !somfbk(fc4)) YM[fc4] |= BIT1; }
   }
 }
 if (fc3 >= 0) {
   if ((B[fc3] || ROG(fc3) || RVG(fc3)) && !RR[fc3]) {
     if (fc1 >= 0) { if (G(fc1)) YM[fc1] |= BIT3; }
     if (fc2 >= 0) { if (G(fc2)) YM[fc2] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
   }
 }
 if (fc4 >= 0) {
   if ((B[fc4] || ROG(fc4) || RVG(fc4)) && !RR[fc4]) {
     if (fc1 >= 0) { if (G(fc1)) YM[fc1] |= BIT3; }
     if (fc2 >= 0) { if (G(fc2)) YM[fc2] |= BIT3; }
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
   }
 }

 /* Uitstel t.b.v. gelijke start */
 /* ---------------------------- */

 xu1 = xu2 = xu3 = xu4 = TRUE;

 if (fc1 >= 0) {
   if (RVG(fc1) && !K[fc1]  && !X[fc1] && !RR[fc1] || G(fc1)
   || (WR(fc1) || ROG(fc1)) && !GR_TIJD(fc1) && !VA[fc1]) xu1 = FALSE;
 } else {
   xu1 = FALSE;
 }
 if (fc2 >= 0) {
   if (RVG(fc2) && !K[fc2]  && !X[fc2] && !RR[fc2] || G(fc2)
   || (WR(fc2) || ROG(fc2)) && !GR_TIJD(fc2) && !VA[fc2]) xu2 = FALSE;
 } else {
   xu2 = FALSE;
 }
 if (fc3 >= 0) {
   if (RVG(fc3) && !K[fc3]  && !X[fc3] && !RR[fc3] || G(fc3)
   || (WR(fc3) || ROG(fc3)) && !GR_TIJD(fc3) && !VA[fc3]) xu3 = FALSE;
 } else {
   xu3 = FALSE;
 }
 if (fc4 >= 0) {
   if (RVG(fc4) && !K[fc4]  && !X[fc4] && !RR[fc4] || G(fc4)
   || (WR(fc4) || ROG(fc4)) && !GR_TIJD(fc4) && !VA[fc4]) xu4 = FALSE;
 } else {
   xu4 = FALSE;
 }
 if (xu1 || xu2 || xu3 || xu4) { if (fc1 >= 0) X[fc1] |= BIT3;
				 if (fc2 >= 0) X[fc2] |= BIT3;
				 if (fc3 >= 0) X[fc3] |= BIT3;
				 if (fc4 >= 0) X[fc4] |= BIT3;
 }

 /* Beeindig groen voedende richting */
 /* -------------------------------- */

 if ((fc1 >= 0) && (fc2 >= 0)) {
   if (G(fc1) && G(fc2) && (TTK[fc2] <= kop12) && !(HVAS[fc1]&BIT0)) {
	Z[fc1] |= BIT1;
   }
 }

 /* Altijd gelijktijdig overslag */
 /* ---------------------------- */

 if (fc1 >= 0) {
   proc_covs_crsv_vtg_fts(fc1,fc2);
   proc_covs_crsv_vtg_fts(fc1,fc3);
   proc_covs_crsv_vtg_fts(fc1,fc4);
 }
 if (fc2 >= 0) {
   proc_covs_crsv_vtg_fts(fc2,fc1);
   proc_covs_crsv_vtg_fts(fc2,fc3);
   proc_covs_crsv_vtg_fts(fc2,fc4);
 }
 if (fc3 >= 0) {
   proc_covs_crsv_vtg_fts(fc3,fc1);
   proc_covs_crsv_vtg_fts(fc3,fc2);
   proc_covs_crsv_vtg_fts(fc3,fc4);
 }
 if (fc4 >= 0) {
   proc_covs_crsv_vtg_fts(fc4,fc1);
   proc_covs_crsv_vtg_fts(fc4,fc2);
   proc_covs_crsv_vtg_fts(fc4,fc3);
 }

 /* Voorkom doorsnijden koppeling langzaam verkeer */
 /* ---------------------------------------------- */

 for (i=0; i<4; i++) {
   if (_fc[i] >= 0) {
	PVS2[_fc[i]] |= BIT2;
   }
 }
}

/* PROCEDURE GESCHEIDEN VOETGANGERSOVERSTEEK */
/* ========================================= */

void proc_go_vtg_crsv(
	Int16 fc1,	/* Signaalgroep 1	      */
	Int16 fc2,	/* Signaalgroep 2	      */
	Int16 kpa12,	/* Koppelaanvraag sg1 -> sg2  */
	Int16 kpa21,	/* Koppelaanvraag sg2 -> sg1  */
	Int16 kpt12,	/* KoppelTIJD     sg1 -> eg2  */
	Int16 kpt21,	/* KoppelTIJD	  sg2 -> eg1  */
	Int16 fc3,	/* Gekoppelde fietser 1       */
	Int16 fc4,	/* Gekoppelde fietser 1 volg  */
	Int16 mre34,	/* Naloop nooit zonder voeding*/
	Int16 kpt3s,	/* Koppeltijd vanaf start fc3 */
	Int16 kpt3e,	/* Koppeltijd vanaf einde fc3 */
	Int16 hfk3e,	/* (HF)start naloop einde fc3 */
	Int16 fc5,	/* Gekoppelde fietser 2       */
	Int16 fc6,	/* Gekoppelde fietser 2 volg  */
	Int16 mre56,	/* Naloop nooit zonder voeding*/
	Int16 kpt5s,	/* Koppeltijd vanaf start fc5 */
	Int16 kpt5e,	/* Koppeltijd vanaf einde fc5 */
	Int16 hfk5e,	/* (HF)start naloop einde fc5 */
	Int16 mre35,	/* Meerea. fietser 1 met 2    */
	Int16 mre53,	/* Meerea. fietser 2 met 1    */

	Int16 vtg3,     /* Signaalgroep 3e voetganger */
	Int16 kpa31,    /* Kop.aanvr. sg3 -> sg1      */
	Int16 kpa32,    /* Kop.aanvr. sg3 -> sg2      */
	Int16 kpt13,    /* KoppelTIJD sg1 -> eg3      */
	Int16 kpt23,    /* KoppelTIJD sg2 -> eg3      */
	Int16 kpt31,    /* KoppelTIJD sg3 -> eg1      */
	Int16 kpt32)    /* KoppelTIJD sg3 -> eg2      */
{
 Bool xu1,xu2,xu3,xu4,xu5,xu6,xu7;
 Bool _BLW = FALSE;
 Bool _REA = FALSE;
 Int16 i,j,_fc[7];

 Int16 kop34 = 0;
 Int16 kop56 = 0;

 if ((fc3 >= 0) && (fc4 >=0)) kop34 = (Int16)inst_TIJD(kpt3e)/10;
 if ((fc5 >= 0) && (fc6 >=0)) kop56 = (Int16)inst_TIJD(kpt5e)/10;

 _fc[0]=fc1; _fc[1]=fc2; _fc[2]=fc3;
 _fc[3]=fc4; _fc[4]=fc5; _fc[5]=fc6; _fc[6]=vtg3;

 /* Alleen naar RVG() indien gekoppelde richting ook kan inkomen */
 /* ------------------------------------------------------------ */

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 < 0)) {
   if ((B[fc1] || RVG(fc1)) && somfbk(fc2)) { B[fc1] = FALSE; RR[fc1] |= BIT3; }
   if ((B[fc2] || RVG(fc2)) && somfbk(fc1)) { B[fc2] = FALSE; RR[fc2] |= BIT3; }
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) {
   if ((B[fc1]  || ROG(fc1)  || RVG(fc1) ) && (somfbk(fc2) || somfbk(vtg3))) { B[fc1]  = FALSE; RR[fc1]  |= BIT3; }
   if ((B[fc2]  || ROG(fc2)  || RVG(fc2) ) && (somfbk(fc1) || somfbk(vtg3))) { B[fc2]  = FALSE; RR[fc2]  |= BIT3; }
   if ((B[vtg3] || ROG(vtg3) || RVG(vtg3)) && (somfbk(fc1) || somfbk(fc2) )) { B[vtg3] = FALSE; RR[vtg3] |= BIT3; }
 }

 /* Altijd gelijktijdig starten wachtstand */
 /* -------------------------------------- */

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if (GL(_fc[i]) || GR_TIJD(_fc[i]) || K[_fc[i]]
      || (R(_fc[i]) && (BAR[_fc[i]] || RR[_fc[i]]))) _BLW = TRUE;
   }
 }
 if (_BLW) {
   for (i=0; i<7; i++) {
     if (_fc[i] >= 0) BLW[_fc[i]] = TRUE;
   }
 }

 /* Opzetten cyc.prim.aanvraag indien gekoppelde richting versneld inkomt */
 /* --------------------------------------------------------------------- */

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if (R(_fc[i]) && !GR_TIJD(_fc[i]) && (HVAS[_fc[i]]&BIT5)) {
       for (j=0; j<7; j++) {
	 if (i != j) {
	   if (_fc[j] >= 0) {
	     if (VA[_fc[j]]&BIT4) { VA[_fc[i]] |= BIT2; VA[_fc[i]] |= BIT4; }
	   }
	 }
       }
     }
   }
 }

 /* Doorschrijven koppelaanvragen */
 /* ----------------------------- */

 if (fc1  >= 0) VA[fc1]  &= (~BIT3);
 if (fc2  >= 0) VA[fc2]  &= (~BIT3);
 if (vtg3 >= 0) VA[vtg3] &= (~BIT3);
 if (fc3  >= 0) VA[fc3]  &= (~BIT3);
 if (fc4  >= 0) VA[fc4]  &= (~BIT3);
 if (fc5  >= 0) VA[fc5]  &= (~BIT3);
 if (fc6  >= 0) VA[fc6]  &= (~BIT3);

 if (kpa12 >= 0) { if (R(fc1) && D(kpa12)) DRK[kpa12] = TRUE; }
 if (kpa21 >= 0) { if (R(fc2) && D(kpa21)) DRK[kpa21] = TRUE; }
 if (kpa31 >= 0) { if (R(fc3) && D(kpa31)) DRK[kpa31] = TRUE; }
 if (kpa32 >= 0) { if (R(fc3) && D(kpa32)) DRK[kpa32] = TRUE; }

 if (kpa12 >= 0) { if (einde_G(fc1)) DRK[kpa12] = FALSE; }
 if (kpa21 >= 0) { if (einde_G(fc2)) DRK[kpa21] = FALSE; }
 if (kpa31 >= 0) { if (einde_G(fc3)) DRK[kpa31] = FALSE; }
 if (kpa32 >= 0) { if (einde_G(fc3)) DRK[kpa32] = FALSE; }

 if ((fc1  >= 0) && (kpa12 >= 0)) { if (R(fc1)  && DRK[kpa12] && !BL_OP(fc1)) VA[fc1] |= BIT6; }
 if ((fc2  >= 0) && (kpa21 >= 0)) { if (R(fc2)  && DRK[kpa21] && !BL_OP(fc2)) VA[fc2] |= BIT6; }
 if ((vtg3 >= 0) && (kpa31 >= 0)) { if (R(vtg3) && DRK[kpa31] && !BL_OP(fc3)) VA[fc3] |= BIT6; }
 if ((vtg3 >= 0) && (kpa32 >= 0)) { if (R(vtg3) && DRK[kpa32] && !BL_OP(fc3)) VA[fc3] |= BIT6; }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 < 0)) {	          /* voetgangerskoppeling 2 vtg */
   if (R(fc1) && !GR_TIJD(fc1) && (VA[fc1]&BIT6)
			       && (!BL_OP(fc2) || G(fc2))) VA[fc2] |= BIT3;
   if (R(fc2) && !GR_TIJD(fc2) && (VA[fc2]&BIT6)
			       && (!BL_OP(fc1) || G(fc1))) VA[fc1] |= BIT3;
   if (HG[fc1]) VA[fc1] |= BIT3;
   if (HG[fc2]) VA[fc2] |= BIT3;
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) {	          /* voetgangerskoppeling 3 vtg */
   if (R(fc1) && !GR_TIJD(fc1) && (VA[fc1]&BIT6)) {
     if (!BL_OP(fc2)  || G(fc2) ) VA[fc2]  |= BIT3;
     if (!BL_OP(vtg3) || G(vtg3)) VA[vtg3] |= BIT3;
   }
   if (R(fc2) && !GR_TIJD(fc2) && (VA[fc2]&BIT6)) {
     if (!BL_OP(fc1)  || G(fc1) ) VA[fc1]  |= BIT3;
     if (!BL_OP(vtg3) || G(vtg3)) VA[vtg3] |= BIT3;
   }
   if (R(vtg3) && !GR_TIJD(vtg3)) {
     if (kpa31 >= 0) { if (DRK[kpa31] && (!BL_OP(fc1) || G(fc1))) VA[fc1] |= BIT3; }
     if (kpa32 >= 0) { if (DRK[kpa32] && (!BL_OP(fc2) || G(fc2))) VA[fc2] |= BIT3; }
   }
   if (HG[fc1] ) VA[fc1]  |= BIT3;
   if (HG[fc2] ) VA[fc2]  |= BIT3;
   if (HG[vtg3]) VA[vtg3] |= BIT3;
 }

 if (fc1 >= 0) {			/* fietsers met voetgangers */
   if (R(fc1) && !GR_TIJD(fc1) && VA[fc1]) {
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
     if (fc5 >= 0) {
	if (!BL_OP(fc5) || G(fc5)) VA[fc5] |= BIT3;
     }
   }
 }

 if (fc2 >= 0) {
   if (R(fc2) && !GR_TIJD(fc2) && VA[fc2]) {
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
     if (fc5 >= 0) {
	if (!BL_OP(fc5) || G(fc5)) VA[fc5] |= BIT3;
     }
   }
 }

 if (vtg3 >= 0) {
   if (R(vtg3) && !GR_TIJD(vtg3) && VA[vtg3]) {
     if (fc3 >= 0) {
	if (!BL_OP(fc3) || G(fc3)) VA[fc3] |= BIT3;
     }
     if (fc5 >= 0) {
	if (!BL_OP(fc5) || G(fc5)) VA[fc5] |= BIT3;
     }
   }
 }

 if (fc4 >= 0) {			/* terugschrijven naar voeding */
   if (R(fc4) && !GR_TIJD(fc4) && VA[fc4]) {
     if ((fc3 >= 0) && (mre34 >= 0)) {
	if (SCH(mre34) && (!BL_OP(fc3) || G(fc3))) VA[fc3] |= BIT3;
     }
   }
 }

 if (fc6 >= 0) {
   if (R(fc6) && !GR_TIJD(fc6) && VA[fc6]) {
     if ((fc5 >= 0) && (mre56 >= 0)) {
	if (SCH(mre56) && (!BL_OP(fc5) || G(fc5))) VA[fc5] |= BIT3;
     }
   }
 }

 if (fc3 >= 0) {			/* fietsers met fietsers */
   if (R(fc3) && !GR_TIJD(fc3) && VA[fc3]) {
     if ((fc5 >= 0) && (mre53 >= 0)) {
	if (SCH(mre53) && (!BL_OP(fc5) || G(fc5))) VA[fc5] |= BIT3;
     }
   }
 }

 if (fc5 >= 0) {
   if (R(fc5) && !GR_TIJD(fc5) && VA[fc5]) {
     if ((fc3 >= 0) && (mre35 >= 0)) {
	if (SCH(mre35) && (!BL_OP(fc3) || G(fc3))) VA[fc3] |= BIT3;
     }
   }
 }

 if ((fc3 >= 0) && (fc4 >= 0)) {	/* volgrichting fietsers */
   if ((R(fc3) && !GR_TIJD(fc3) && VA[fc3]
				|| G(fc3)) && (!BL_OP(fc4) || G(fc4)))
      VA[fc4] |= BIT3;
 }

 if ((fc5 >= 0) && (fc6 >= 0)) {
   if ((R(fc5) && !GR_TIJD(fc5) && VA[fc5]
				|| G(fc5)) && (!BL_OP(fc6) || G(fc6)))
      VA[fc6] |= BIT3;
 }

 /* Herstart koppeltijden voetgangers */
 /* --------------------------------- */

 if ((fc1 >= 0) && (fc2 >= 0)) {
   if (begin_G(fc1) && (VA[fc1]&BIT6)) {
     herstart_TIJD(kpt12);
     if (vtg3 >= 0) herstart_TIJD(kpt13);
   }
   if (begin_G(fc2) && (VA[fc2]&BIT6)) {
     herstart_TIJD(kpt21);
     if (vtg3 >= 0) herstart_TIJD(kpt23);
   }
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) {
   if (kpa31 >= 0) { if (begin_G(vtg3) && DRK[kpa31]) herstart_TIJD(kpt31); }
   if (kpa32 >= 0) { if (begin_G(vtg3) && DRK[kpa32]) herstart_TIJD(kpt32); }
 }

					/* Reset koppelaanvraag */
 if (fc1  >= 0) { if (begin_G(fc1) ) VA[fc1]  &= (~BIT6); }
 if (fc2  >= 0) { if (begin_G(fc2) ) VA[fc2]  &= (~BIT6); }
 if (vtg3 >= 0) { if (begin_G(vtg3)) VA[vtg3] &= (~BIT6); }

 /* Vasthouden groen naloop-richting voetgangers */
 /* -------------------------------------------- */

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 < 0)) {
   if (begin_G(fc1) && (VA[fc1]&BIT6) || TIJD(kpt12) || B[fc1] || ROG(fc1)
		 		      || RVG(fc1)) RW[fc2] |=  BIT3;
   if ((VAG2e(fc2) || MVG(fc2)) && (RW[fc2]&BIT3)) YM[fc2] |=  BIT2;
   else						   YM[fc2] &=(~BIT2);

   if (begin_G(fc2) && (VA[fc2]&BIT6) || TIJD(kpt21) || B[fc2] || ROG(fc2)
		 		      || RVG(fc2)) RW[fc1] |=  BIT3;
   if ((VAG2e(fc1) || MVG(fc1))	&& (RW[fc1]&BIT3)) YM[fc1] |=  BIT2;
   else						   YM[fc1] &=(~BIT2);

   if ((HVAS[fc1]&BIT3) && G(fc2) && (YM[fc2]&BIT2)) {
	if ((HVAS[fc1]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc2] |= BIT3;
		 TTP[fc2]  = UTTP[fc2] = 255;
	}
   }
   if ((HVAS[fc2]&BIT3) && G(fc1) && (YM[fc1]&BIT2)) {
	if ((HVAS[fc1]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc1] |= BIT3;
		 TTP[fc1]  = UTTP[fc1] = 255;
	}
   }
 }

 if ((fc1 >= 0) && (fc2 >= 0) && (vtg3 >= 0)) {
   if (begin_G(fc1)  && (VA[fc1]&BIT6) || TIJD(kpt12) || B[fc1]  || ROG(fc1) || RVG(fc1) ) RW[fc2]  |= BIT3;
   if (begin_G(fc1)  && (VA[fc1]&BIT6) || TIJD(kpt13) || B[fc1]  || ROG(fc1) || RVG(fc1) ) RW[vtg3] |= BIT3;

   if (begin_G(fc2)  && (VA[fc2]&BIT6) || TIJD(kpt21) || B[fc2]  || ROG(fc2) || RVG(fc2) ) RW[fc1]  |= BIT3;
   if (begin_G(fc2)  && (VA[fc2]&BIT6) || TIJD(kpt23) || B[fc2]  || ROG(fc2) || RVG(fc2) ) RW[vtg3] |= BIT3;

   if (kpa31 >= 0) {
     if (begin_G(vtg3) && DRK[kpa31]   || TIJD(kpt31) || B[vtg3] || ROG(fc3) || RVG(vtg3)) RW[fc1]  |= BIT3;
   else 
     if (                                 TIJD(kpt31) || B[vtg3] || ROG(fc3) || RVG(vtg3)) RW[fc1]  |= BIT3;
   }
   if (kpa32 >= 0) {
     if (begin_G(vtg3) && DRK[kpa32]   || TIJD(kpt32) || B[vtg3] || ROG(fc3) || RVG(vtg3)) RW[fc2]  |= BIT3;
   else 
     if (                                 TIJD(kpt32) || B[vtg3] || ROG(fc3) || RVG(vtg3)) RW[fc2]  |= BIT3;
   }

   if ((VAG2e(fc1)  || MVG(fc1))  && (RW[fc1]&BIT3) ) YM[fc1]  |=  BIT2;
   else                                               YM[fc1]  &=(~BIT2);

   if ((VAG2e(fc2)  || MVG(fc2))  && (RW[fc2]&BIT3) ) YM[fc2]  |=  BIT2;
   else                                               YM[fc2]  &=(~BIT2);

   if ((VAG2e(vtg3) || MVG(vtg3)) && (RW[vtg3]&BIT3)) YM[vtg3] |=  BIT2;
   else                                               YM[vtg3] &=(~BIT2);

   if ((HVAS[fc1]&BIT3) && G(fc2) && (YM[fc2]&BIT2)) {
	if ((HVAS[fc1]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc2] |= BIT3;
		 TTP[fc2]  = UTTP[fc2] = 255;
	}
   }
   if ((HVAS[fc1]&BIT3) && G(vtg3) && (YM[vtg3]&BIT2)) {
	if ((HVAS[fc1]&BIT7) == (HVAS[vtg3]&BIT7)) {
		HVAS[vtg3] |= BIT3;
		 TTP[vtg3]  = UTTP[vtg3] = 255;
	}
   }
   if ((HVAS[fc2]&BIT3) && G(fc1) && (YM[fc1]&BIT2)) {
	if ((HVAS[fc2]&BIT7) == (HVAS[fc1]&BIT7)) {
		HVAS[fc1] |= BIT3;
		 TTP[fc1]  = UTTP[fc1] = 255;
	}
   }
   if ((HVAS[fc2]&BIT3) && G(vtg3) && (YM[vtg3]&BIT2)) {
	if ((HVAS[fc2]&BIT7) == (HVAS[vtg3]&BIT7)) {
		HVAS[vtg3] |= BIT3;
		 TTP[vtg3]  = UTTP[vtg3] = 255;
	}
   }
   if ((HVAS[vtg3]&BIT3) && G(fc1) && (YM[fc1]&BIT2)) {
	if ((HVAS[vtg3]&BIT7) == (HVAS[fc1]&BIT7)) {
		HVAS[fc1] |= BIT3;
		 TTP[fc1]  = UTTP[fc1] = 255;
	}
   }
   if ((HVAS[vtg3]&BIT3) && G(fc2) && (YM[fc2]&BIT2)) {
	if ((HVAS[vtg3]&BIT7) == (HVAS[fc2]&BIT7)) {
		HVAS[fc2] |= BIT3;
		 TTP[fc2]  = UTTP[fc2] = 255;
	}
   }
 }

 /* Herstart koppeltijden fietsers */
 /* ------------------------------ */

 if ((fc3 >= 0) && (fc4 >= 0)) {
   if (begin_G(fc3)) {
	herstart_TIJD(kpt3s);
	VA[fc3] |= BIT6;
   }
   if (G(fc3) && HF(hfk3e)) {
	herstart_TIJD(kpt3e);
   }
 }

 if ((fc5 >= 0) && (fc6 >= 0)) {
   if (begin_G(fc5)) {
	herstart_TIJD(kpt5s);
	VA[fc5] |= BIT6;
   }
   if (G(fc5) && HF(hfk5e)) {
	herstart_TIJD(kpt5e);
   }
 }

 /* Vasthouden groen naloop-richting fietsers */
 /* ----------------------------------------- */

 if ((fc3 >= 0) && (fc4 >= 0)) {
   if (G(fc3) || TIJD(kpt3s) || TIJD(kpt3e) || B[fc3] || ROG(fc3) || RVG(fc3))
	RW[fc4] |= BIT3;

   if ((VAG2e(fc4) || MVG(fc4)) && (RW[fc4]&BIT3)) YM[fc4] |=  BIT2;
   else						   YM[fc4] &=(~BIT2);

   if ((HVAS[fc3]&BIT3) && G(fc4) && (YM[fc4]&BIT2)) {
	if ((HVAS[fc3]&BIT7) == (HVAS[fc4]&BIT7)) {
		HVAS[fc4] |= BIT3;
		 TTP[fc4]  = UTTP[fc4] = 255;
	}
   }
 }

 if ((fc5 >= 0) && (fc6 >= 0)) {
   if (G(fc5) || TIJD(kpt5s) || TIJD(kpt5e) || B[fc5] || ROG(fc5) || RVG(fc5))
	RW[fc6] |= BIT3;

   if ((VAG2e(fc6) || MVG(fc6)) && (RW[fc6]&BIT3)) YM[fc6] |=  BIT2;
   else						   YM[fc6] &=(~BIT2);

   if ((HVAS[fc5]&BIT3) && G(fc6) && (YM[fc6]&BIT2)) {
	if ((HVAS[fc5]&BIT7) == (HVAS[fc6]&BIT7)) {
		HVAS[fc6] |= BIT3;
		 TTP[fc6]  = UTTP[fc6] = 255;
	}
   }
 }

 /* Beurt t.b.v. gelijke start */
 /* -------------------------- */

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
     if ((B[_fc[i]] || ROG(_fc[i]) || RVG(_fc[i]))
	 && VA[_fc[i]] && !RR[_fc[i]]) _REA = TRUE;
   }
 }
 if (_REA) {
   for (i=0; i<7; i++) {
     if (_fc[i] >= 0) {
	if (R(_fc[i]) && !GR_TIJD(_fc[i]) && VA[_fc[i]]) {
	  B[_fc[i]] |= BIT3;
	  RR[_fc[i]] = FALSE;
	}
     }
   }
 }



 /* Vasthouden meeverlenggroen */
 /* -------------------------- */

 if (fc1 >= 0) {
   if ((B[fc1] || ROG(fc1) || RVG(fc1)) && !RR[fc1]) {
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
     if (fc5 >= 0) { if (G(fc5)) YM[fc5] |= BIT3; }
     if (fc6 >= 0) { if (G(fc6)) YM[fc6] |= BIT3; }
   }
   if (G(fc1) && (!WG(fc1) || begin_WG(fc1)) && (!MVG(fc1) || (RW[fc1]&BIT3))) {
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
     if (fc5 >= 0) { if (G(fc5) && !somfbk(fc5)) YM[fc5] |= BIT1; }
   }
 }
 if (fc2 >= 0) {
   if ((B[fc2] || ROG(fc2) || RVG(fc2)) && !RR[fc2]) {
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
     if (fc5 >= 0) { if (G(fc5)) YM[fc5] |= BIT3; }
     if (fc6 >= 0) { if (G(fc6)) YM[fc6] |= BIT3; }
   }
   if (G(fc2) && (!WG(fc2) || begin_WG(fc2)) && (!MVG(fc2) || (RW[fc2]&BIT3))) {
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
     if (fc5 >= 0) { if (G(fc5) && !somfbk(fc5)) YM[fc5] |= BIT1; }
   }
 }
 if (vtg3 >= 0) {
   if ((B[vtg3] || ROG(vtg3) || RVG(vtg3)) && !RR[vtg3]) {
     if (fc3 >= 0) { if (G(fc3)) YM[fc3] |= BIT3; }
     if (fc4 >= 0) { if (G(fc4)) YM[fc4] |= BIT3; }
     if (fc5 >= 0) { if (G(fc5)) YM[fc5] |= BIT3; }
     if (fc6 >= 0) { if (G(fc6)) YM[fc6] |= BIT3; }
   }
   if (G(vtg3) && (!WG(vtg3) || begin_WG(vtg3)) && (!MVG(vtg3) || (RW[vtg3]&BIT3))) {
     if (fc3 >= 0) { if (G(fc3) && !somfbk(fc3)) YM[fc3] |= BIT1; }
     if (fc5 >= 0) { if (G(fc5) && !somfbk(fc5)) YM[fc5] |= BIT1; }
   }
 }

 if (fc3 >= 0) {
   if ((B[fc3] || ROG(fc3) || RVG(fc3)) && !RR[fc3]) {
     if (fc1  >= 0) { if (G(fc1) ) YM[fc1]  |= BIT3; }
     if (fc2  >= 0) { if (G(fc2) ) YM[fc2]  |= BIT3; }
     if (vtg3 >= 0) { if (G(vtg3)) YM[vtg3] |= BIT3; }
     if (fc4  >= 0) { if (G(fc4) ) YM[fc4]  |= BIT3; }
     if (fc5  >= 0) { if (G(fc5) ) YM[fc5]  |= BIT3; }
     if (fc6  >= 0) { if (G(fc6) ) YM[fc6]  |= BIT3; }
   }
 }
 if (fc4 >= 0) {
   if ((B[fc4] || ROG(fc4) || RVG(fc4)) && !RR[fc4]) {
     if (fc1  >= 0) { if (G(fc1) ) YM[fc1]  |= BIT3; }
     if (fc2  >= 0) { if (G(fc2) ) YM[fc2]  |= BIT3; }
     if (vtg3 >= 0) { if (G(vtg3)) YM[vtg3] |= BIT3; }
     if (fc3  >= 0) { if (G(fc3) ) YM[fc3]  |= BIT3; }
     if (fc5  >= 0) { if (G(fc5) ) YM[fc5]  |= BIT3; }
     if (fc6  >= 0) { if (G(fc6) ) YM[fc6]  |= BIT3; }
   }
 }
 if (fc5 >= 0) {
   if ((B[fc5] || ROG(fc5) || RVG(fc5)) && !RR[fc5]) {
     if (fc1  >= 0) { if (G(fc1) ) YM[fc1]  |= BIT3; }
     if (fc2  >= 0) { if (G(fc2) ) YM[fc2]  |= BIT3; }
     if (vtg3 >= 0) { if (G(vtg3)) YM[vtg3] |= BIT3; }
     if (fc3  >= 0) { if (G(fc3) ) YM[fc3]  |= BIT3; }
     if (fc4  >= 0) { if (G(fc4) ) YM[fc4]  |= BIT3; }
     if (fc6  >= 0) { if (G(fc6) ) YM[fc6]  |= BIT3; }
   }
 }
 if (fc6 >= 0) {
   if ((B[fc6] || ROG(fc6) || RVG(fc6)) && !RR[fc6]) {
     if (fc1  >= 0) { if (G(fc1) ) YM[fc1]  |= BIT3; }
     if (fc2  >= 0) { if (G(fc2) ) YM[fc2]  |= BIT3; }
     if (vtg3 >= 0) { if (G(vtg3)) YM[vtg3] |= BIT3; }
     if (fc3  >= 0) { if (G(fc3) ) YM[fc3]  |= BIT3; }
     if (fc4  >= 0) { if (G(fc4) ) YM[fc4]  |= BIT3; }
     if (fc5  >= 0) { if (G(fc5) ) YM[fc5]  |= BIT3; }
   }
 }

 /* Uitstel t.b.v. gelijke start */
 /* ---------------------------- */

 if ((fc3 >= 0) || (fc4 >= 0) || (fc5 >= 0) || (fc6 >= 0)) {

   xu1 = xu2 = xu3 = xu4 = xu5 = xu6 = xu7 = TRUE;

   if (fc1 >= 0) {
     if (RVG(fc1) && !K[fc1]  && !X[fc1] && !RR[fc1] || G(fc1)
     || (WR(fc1) || ROG(fc1)) && !GR_TIJD(fc1) && !VA[fc1]) xu1 = FALSE;
   } else {
     xu1 = FALSE;
   }
   if (fc2 >= 0) {
     if (RVG(fc2) && !K[fc2]  && !X[fc2] && !RR[fc2] || G(fc2)
     || (WR(fc2) || ROG(fc2)) && !GR_TIJD(fc2) && !VA[fc2]) xu2 = FALSE;
   } else {
     xu2 = FALSE;
   }
   if (fc3 >= 0) {
     if (RVG(fc3) && !K[fc3]  && !X[fc3] && !RR[fc3] || G(fc3)
     || (WR(fc3) || ROG(fc3)) && !GR_TIJD(fc3) && !VA[fc3]) xu3 = FALSE;
   } else {
     xu3 = FALSE;
   }
   if (fc4 >= 0) {
     if (RVG(fc4) && !K[fc4]  && !X[fc4] && !RR[fc4] || G(fc4)
     || (WR(fc4) || ROG(fc4)) && !GR_TIJD(fc4) && !VA[fc4]) xu4 = FALSE;
   } else {
     xu4 = FALSE;
   }
   if (fc5 >= 0) {
     if (RVG(fc5) && !K[fc5]  && !X[fc5] && !RR[fc5] || G(fc5)
     || (WR(fc5) || ROG(fc5)) && !GR_TIJD(fc5) && !VA[fc5]) xu5 = FALSE;
   } else {
     xu5 = FALSE;
   }
   if (fc6 >= 0) {
     if (RVG(fc6) && !K[fc6]  && !X[fc6] && !RR[fc6] || G(fc6)
     || (WR(fc6) || ROG(fc6)) && !GR_TIJD(fc6) && !VA[fc6]) xu6 = FALSE;
   } else {
     xu6 = FALSE;
   }
   if (vtg3 >= 0) {
     if (RVG(vtg3) && !K[vtg3]  && !X[vtg3] && !RR[vtg3] || G(vtg3)
     || (WR(vtg3) || ROG(vtg3)) && !GR_TIJD(vtg3) && !VA[vtg3]) xu7 = FALSE;
   } else {
     xu7 = FALSE;
   }

 } else {	/* er is geen gekoppelde fietser aanwezig */

   xu1 = xu2 = xu7 = TRUE;
   xu3 = xu4 = xu5 = xu6 = FALSE;

   if (fc1 >= 0) {
     if (RVG(fc1) && (!K[fc1] || !(VA[fc1]&BIT6) && ((VA[fc2]&BIT6) || G(fc2)))
					     && !X[fc1] && !RR[fc1] || G(fc1)
     || (WR(fc1) || ROG(fc1)) && !GR_TIJD(fc1) && !VA[fc1]) xu1 = FALSE;
   } else {
     xu1 = FALSE;
   }
   if (fc2 >= 0) {
     if (RVG(fc2) && (!K[fc2] || !(VA[fc2]&BIT6) && ((VA[fc1]&BIT6) || G(fc1)))
					     && !X[fc2] && !RR[fc2] || G(fc2)
     || (WR(fc2) || ROG(fc2)) && !GR_TIJD(fc2) && !VA[fc2]) xu2 = FALSE;
   } else {
     xu2 = FALSE;
   }
   if (vtg3 >= 0) {
     if (RVG(vtg3) && (!K[vtg3] || G(fc1) || G(fc2)) && !X[vtg3] && !RR[vtg3] || G(vtg3)
     || (WR(vtg3) || ROG(vtg3)) && !GR_TIJD(vtg3) && !VA[vtg3]) xu7 = FALSE;
   } else {
     xu7 = FALSE;
   }
 }

 if (xu1 || xu2 || xu3 || xu4 || xu5 || xu6 || xu7) { if (fc1  >= 0) X[fc1]  |= BIT3;
					              if (fc2  >= 0) X[fc2]  |= BIT3;
			              	              if (fc3  >= 0) X[fc3]  |= BIT3;
					              if (fc4  >= 0) X[fc4]  |= BIT3;
					              if (fc5  >= 0) X[fc5]  |= BIT3;
					              if (fc6  >= 0) X[fc6]  |= BIT3;
					              if (vtg3 >= 0) X[vtg3] |= BIT3;
 }

/* Garandeer nalooprichting voetgangerskoppeling */
/* --------------------------------------------- */
 if ((fc1 >= 0) && (fc2 >= 0)) {
   if (HG[fc1] && (ROG(fc1) || RVG(fc1)) && VA[fc1]) {
	B[fc1]  |= BIT3; 
	RR[fc1]  = X[fc1] = FALSE;
	YM[fc2] |= BIT3;
        if (vtg3 >= 0) YM[vtg3] |= BIT3;
   }
   if (HG[fc2] && (ROG(fc2) || RVG(fc2)) && VA[fc2]) {
	B[fc2]  |= BIT3; 
	RR[fc2]  = X[fc2] = FALSE;
	YM[fc1] |= BIT3;
        if (vtg3 >= 0) YM[vtg3] |= BIT3;
   }
   if (vtg3 >= 0) {
     if (HG[vtg3] && (ROG(vtg3) || RVG(vtg3)) && VA[vtg3]) {
	B[vtg3]  |= BIT3; 
	RR[vtg3]  = X[vtg3] = FALSE;
	YM[fc1]  |= BIT3;
	YM[fc2]  |= BIT3;
     }
   }
 }

 /* Beeindig groen voedende richting */
 /* -------------------------------- */

 if ((fc3 >= 0) && (fc4 >= 0)) {
   if (G(fc3) && G(fc4) && (TTK[fc4] <= kop34) && !(HVAS[fc3]&BIT0)) {
	Z[fc3] |= BIT1;
   }
 }
 if ((fc5 >= 0) && (fc6 >= 0)) {
   if (G(fc5) && G(fc6) && (TTK[fc6] <= kop56) && !(HVAS[fc5]&BIT0)) {
	Z[fc5] |= BIT1;
   }
 }

 /* Altijd gelijktijdig overslag */
 /* ---------------------------- */

 if (fc1 >= 0) {
   proc_covs_crsv_vtg_fts(fc1,fc2);
   proc_covs_crsv_vtg_fts(fc1,fc3);
   proc_covs_crsv_vtg_fts(fc1,fc4);
   proc_covs_crsv_vtg_fts(fc1,fc5);
   proc_covs_crsv_vtg_fts(fc1,fc6);
   proc_covs_crsv_vtg_fts(fc1,vtg3);
 }
 if (fc2 >= 0) {
   proc_covs_crsv_vtg_fts(fc2,fc1);
   proc_covs_crsv_vtg_fts(fc2,fc3);
   proc_covs_crsv_vtg_fts(fc2,fc4);
   proc_covs_crsv_vtg_fts(fc2,fc5);
   proc_covs_crsv_vtg_fts(fc2,fc6);
   proc_covs_crsv_vtg_fts(fc2,vtg3);
 }
 if (fc3 >= 0) {
   proc_covs_crsv_vtg_fts(fc3,fc1);
   proc_covs_crsv_vtg_fts(fc3,fc2);
   proc_covs_crsv_vtg_fts(fc3,fc4);
   proc_covs_crsv_vtg_fts(fc3,fc5);
   proc_covs_crsv_vtg_fts(fc3,fc6);
   proc_covs_crsv_vtg_fts(fc3,vtg3);
 }
 if (fc4 >= 0) {
   proc_covs_crsv_vtg_fts(fc4,fc1);
   proc_covs_crsv_vtg_fts(fc4,fc2);
   proc_covs_crsv_vtg_fts(fc4,fc3);
   proc_covs_crsv_vtg_fts(fc4,fc5);
   proc_covs_crsv_vtg_fts(fc4,fc6);
   proc_covs_crsv_vtg_fts(fc4,vtg3);
 }
 if (fc5 >= 0) {
   proc_covs_crsv_vtg_fts(fc5,fc1);
   proc_covs_crsv_vtg_fts(fc5,fc2);
   proc_covs_crsv_vtg_fts(fc5,fc3);
   proc_covs_crsv_vtg_fts(fc5,fc4);
   proc_covs_crsv_vtg_fts(fc5,fc6);
   proc_covs_crsv_vtg_fts(fc5,vtg3);
 }
 if (fc6 >= 0) {
   proc_covs_crsv_vtg_fts(fc6,fc1);
   proc_covs_crsv_vtg_fts(fc6,fc2);
   proc_covs_crsv_vtg_fts(fc6,fc3);
   proc_covs_crsv_vtg_fts(fc6,fc4);
   proc_covs_crsv_vtg_fts(fc6,fc5);
   proc_covs_crsv_vtg_fts(fc6,vtg3);
 }
 if (vtg3 >= 0) {
   proc_covs_crsv_vtg_fts(vtg3,fc1);
   proc_covs_crsv_vtg_fts(vtg3,fc2);
   proc_covs_crsv_vtg_fts(vtg3,fc3);
   proc_covs_crsv_vtg_fts(vtg3,fc4);
   proc_covs_crsv_vtg_fts(vtg3,fc5);
   proc_covs_crsv_vtg_fts(vtg3,fc6);
 }

 /* Voorkom doorsnijden koppeling langzaam verkeer */
 /* ---------------------------------------------- */

 for (i=0; i<7; i++) {
   if (_fc[i] >= 0) {
	PVS2[_fc[i]] |= BIT2;
   }
 }
}

/* PROCEDURE SERIELE KOPPELING */
/* =========================== */

void proc_hki_crsv()
{
 Int16 fc1,fc2,fc3,stat,i,j,x;
 Int16 kptvs12,kptsg12,kpteg12,kptdm12;
 Int16 kptvs23,kptsg23,kpteg23,kptdm23;
 Int16 de11,de12,de13,de21,de22,de23;
 Int16 kopvs12 = 0;
 Int16 kopvs23 = 0;
 Bool hki_gebied12 = FALSE; 
 Bool hki_gebied23 = FALSE; 

 for (i=0; i<aant_hki; i++) {			/* reset bits voor richtingen die onderdeel zijn van tenminste 1 seriele koppeling */
	fc2 = hki[i][1];
	fc3 = hki[i][10];
	  YM[fc2] &= (~BIT2);
	PVS2[fc2] &= (~BIT2);
	if (fc3 >= 0) {
		  YM[fc3] &= (~BIT2);
		PVS2[fc3] &= (~BIT2);
	} else {
		BW_hki[i][fc2] = FALSE;		/* VLAG wordt waar als fc2 door groen (of naloop) vanaf fc1 wordt vastgehouden */
	}
 }

 for (x=0; x<3; x++) {				/* 3x doorlopen ivm mogelijke geneste koppelingen */
    for (i=0; i<aant_hki; i++) {
	fc1     = hki[i][0];
	fc2     = hki[i][1];
	kptvs12 = hki[i][2];
	kptsg12 = hki[i][3];
	kpteg12 = hki[i][4];
	kptdm12 = hki[i][5];
	de11    = hki[i][6];
	de12    = hki[i][7];
	de13    = hki[i][8];
	fc3     = hki[i][10];
	kptvs23 = hki[i][11];
	kptsg23 = hki[i][12];
	kpteg23 = hki[i][13];
	kptdm23 = hki[i][14];
	de21    = hki[i][15];
	de22    = hki[i][16];
	de23    = hki[i][17];
	stat    = hki[i][20];

	if (stat >= 2) {			/* koppeling is aktief */

		if (kptvs12 >= 0) kopvs12 = (Int16)inst_TIJD(kptvs12)/10;
		if (kptvs23 >= 0) kopvs23 = (Int16)inst_TIJD(kptvs23)/10;

		/* Set HG bit volgrichting bij alternatieve realisatie voeding */
		/* ----------------------------------------------------------- */
		if (begin_G(fc1) && !(HVAS[fc1]&BIT0) && !(HVAS[fc1]&BIT4) && (TTP[fc1] > 0) && (TTPR[fc1] > 0)) HG_hki[i][fc2] |= BIT6;
		if (G(fc2)) HG_hki[i][fc2] &= (~BIT6);

		if (fc3 >= 0) {
			if (begin_G(fc2) && !(HVAS[fc2]&BIT0) && !(HVAS[fc2]&BIT4) && (TTP[fc2] > 0) && (TTPR[fc2] > 0)) HG_hki[i][fc3] |= BIT6;
			if (G(fc3)) HG_hki[i][fc3] &= (~BIT6);
		}

		/* Voedende richting alleen wachtstand indien naloop-richting kan inkomen */
		/* ---------------------------------------------------------------------- */
		if (GL(fc2) || GR_TIJD(fc2) || K[fc2] || (R(fc2) && (BAR[fc2] || RR[fc2]))) {
			BLW[fc1] = TRUE;
		}

		if (fc3 >= 0) {
			if (GL(fc3) || GR_TIJD(fc3) || K[fc3] || (R(fc3) && (BAR[fc3] || RR[fc3]))) {
				BLW[fc1] = BLW[fc2] = TRUE;
			}
		}


		/* Doorschrijven koppelaanvraag */
		/* ---------------------------- */
		if (G(fc1) && (!BL_OP(fc2) || G(fc2))) VA[fc2] |= BIT3;

		if (fc3 >= 0) {
			if (G(fc2) && BW_hki[i][fc2] && (!BL_OP(fc3) || G(fc3))) VA[fc3] |= BIT3;
		}

		/* Herstart koppeltijden */
		/* --------------------- */
		if (G(fc1)) {
			if (begin_G(fc1)) herstart_TIJD(kptsg12);
			if (de11 >= 0) {
				if (D(de11)) herstart_TIJD(kpteg12);
			}
			if (de12 >= 0) {
				if (D(de12)) herstart_TIJD(kpteg12);
			}
			if (de13 >= 0) {
				if (D(de13)) herstart_TIJD(kpteg12);
			}
			if (!(de11 >= 0) && !(de12 >= 0) && !(de13 >= 0)) herstart_TIJD(kpteg12);
			if (G(fc2)) VA[fc1] |= BIT6;
 		}
		if (TIJD(kptsg12) || TIJD(kpteg12)) herstart_TIJD(kptdm12);

#ifdef RWSC_old
		if (!G(fc1) && !TIJD(kptsg12) && !TIJD(kpteg12) && !VG1[fc2] && !H2e_TIJD(fc2) ) {
#else
		if (!G(fc1) && !TIJD(kptsg12) && !TIJD(kpteg12) && !VG1[fc2] && !H2e_loopt(fc2)) {
#endif
			reset_TIJD(kptdm12);
			PVAS_hki[i][fc2] &= (~BIT1);
		}

		if (fc3 >= 0) {
			if (G(fc2)) {
				if (begin_G(fc2)) herstart_TIJD(kptsg23);
				if (BW_hki[i][fc2]) {
					if (de21 >= 0) {
						if (D(de21)) herstart_TIJD(kpteg23);
					}
					if (de22 >= 0) {
						if (D(de22)) herstart_TIJD(kpteg23);
					}
					if (de23 >= 0) {
						if (D(de23)) herstart_TIJD(kpteg23);
					}
					if (!(de21 >= 0) && !(de22 >= 0) && !(de23 >= 0)) herstart_TIJD(kpteg23);
				}
				if (G(fc3)) VA[fc2] |= BIT6;
	 		}
			if (TIJD(kptsg23) || TIJD(kpteg23)) herstart_TIJD(kptdm23);

#ifdef RWSC_old
			if ((!G(fc2) || !(BW_hki[i][fc2])) && !TIJD(kptsg23) && !TIJD(kpteg23) && !VG1[fc3] && !H2e_TIJD(fc3) ) {
#else
			if ((!G(fc2) || !(BW_hki[i][fc2])) && !TIJD(kptsg23) && !TIJD(kpteg23) && !VG1[fc3] && !H2e_loopt(fc3)) {
#endif
				reset_TIJD(kptdm23);
				PVAS_hki[i][fc3] &= (~BIT1);
			}
		}

		/* Vasthouden groen naloop-richting */
		/* -------------------------------- */
		if (G(fc1) || (PVS2[fc1]&BIT4) || TIJD(kptsg12) || TIJD(kpteg12) || TIJD(kptdm12)) {
			RW[fc2] |= BIT3;
			RW_hki[i][fc2] |= BIT3;
			BW_hki[i][fc2] = TRUE;
		}

		if ((VAG2e(fc2) || MVG(fc2)) && (RW[fc2]&BIT3)) YM[fc2] |= BIT2;
		if (B[fc1] || ROG(fc1) || RVG(fc1) || (PVS2[fc1]&BIT4)) YM[fc2] |= BIT3;

		if (fc3 >= 0) {
			if (G(fc2) && BW_hki[i][fc2] || (PVS2[fc2]&BIT4) || TIJD(kptsg23) || TIJD(kpteg23) || TIJD(kptdm23)) {
				RW[fc3] |= BIT3;
				RW_hki[i][fc3] |= BIT3;
			}

			if ((VAG2e(fc3) || MVG(fc3)) && (RW[fc3]&BIT3)) YM[fc3] |= BIT2;
			if (B[fc2] || ROG(fc2) || RVG(fc2) || HG[fc2] || (PVS2[fc2]&BIT4)) YM[fc3] |= BIT3;
		}

		/* Uitstel voedende richting */
		/* ------------------------- */
		if ((TTP[fc1]>0) && (TTP[fc2]> kopvs12) && (TTR[fc2]>kopvs12)) X[fc1] |= BIT3;
		if (fc3 >= 0) {
			if ((TTP[fc1]>0) && (TTP[fc3]>(kopvs12+kopvs23)) && (TTR[fc3]>(kopvs12+kopvs23))) X[fc1] |= BIT3;
			if ((TTP[fc2]>0) && (TTP[fc3]> kopvs23)          && (TTR[fc3]> kopvs23))          X[fc2] |= BIT3;
		}

		/* Beurt naloop-richting */
		/* --------------------- */	/* WR() && !somfbk() && (HG_hki[i][fc2]&BIT6) toegevoegd Fik110216 */
		if (HG[fc2] && (WR(fc2) && !somfbk(fc2) && (HG_hki[i][fc2]&BIT6) || ROG(fc2) || RVG(fc2)) && VA[fc2]) {
			B[fc2] |= BIT3; 
			RR[fc2] = FALSE;
		}

		if (fc3 >= 0) {
			if (HG[fc3] && (WR(fc3) && !somfbk(fc3) && (HG_hki[i][fc2]&BIT6) || ROG(fc3) || RVG(fc3)) && VA[fc3]) {
				B[fc3] |= BIT3; 
				RR[fc3] = FALSE;
			}
		}

		/* Beeindig groen voedende richting */
		/* -------------------------------- */						/* toegevoegd: (HG_hki[]&BIT6) Fik110216 */
		if (G(fc1) && (G(fc2) || HG[fc2]) && (!(HVAS[fc1]&BIT0) || (KG[fc1] > ALTM[fc1]))
                           && (TTK[fc2] <= TEG[fc2]) && ((TTK[fc2] > 0) || G(fc2)) && ((HG_hki[i][fc2]&BIT6) || RVG(fc2) || G(fc2) || (TTK[fc2] > TTP[fc2]))) {
			Z[fc1] |= BIT1;
		}

		if (fc3 >= 0) {
			if (G(fc1) && (G(fc3) || HG[fc3]) && (!(HVAS[fc1]&BIT0) || (KG[fc1] > ALTM[fc1]))
                                   && (TTK[fc3] <= TEG[fc3]) && ((TTK[fc3] > 0) || G(fc3)) && ((HG_hki[i][fc3]&BIT6) || RVG(fc3) || G(fc3) || (TTK[fc3] > TTP[fc3]))) {
				Z[fc1] |= BIT1;
			}
			if (G(fc2) && (G(fc3) || HG[fc3]) && (!(HVAS[fc2]&BIT0) || (KG[fc2] > ALTM[fc2]))
                                   && (TTK[fc3] <= TEG[fc3]) && ((TTK[fc3] > 0) || G(fc3)) && ((HG_hki[i][fc3]&BIT6) || RVG(fc3) || G(fc3) || (TTK[fc3] > TTP[fc3]))) {
				if ((x > 0) && !(RW[fc2]&BIT3)) Z[fc2] |= BIT1;			/* in 1e rondje worden de RW-bitjes geset */
				if (G(fc1)) Z[fc1] |= BIT1;
			}
		}

		/* Overslag voedende richting bij overslag naloop-richting */
		/* ------------------------------------------------------- */
		hki_gebied12 = hki_gebied23 = FALSE;

		if (fc3 >= 0) {
			if ((VAS2[fc2] != 0) && (VAS4[fc2] != 0) && (VAS2[fc2] != VAS4[fc2]) &&
			    (VAS2[fc3] != 0) && (VAS4[fc3] != 0) && (VAS2[fc3] != VAS4[fc3])) {

				if (VAS4[fc3]>=VAS4[fc2]) {	/* einde primair fc2 VOOR einde primair fc3 */

					if ((STAP>=VAS4[fc2]) && (STAP<VAS4[fc3])) hki_gebied23 = TRUE;

				} else {			/* einde primair fc2 NA   einde primair fc3 */

					if ((STAP>=VAS4[fc2]) || (STAP<VAS4[fc3])) hki_gebied23 = TRUE;
				}

				if (!hki_gebied23 && (HVAS[fc3]&BIT3)) HVAS[fc2] |= BIT3;
				if (!hki_gebied23 && (HVAS[fc3]&BIT0) && !(HVAS[fc2]&BIT3)) {
					RW[fc3] |= BIT3;
					RW_hki[i][fc3] |= BIT3;
				}
			}
		}

		if ((VAS2[fc1] != 0) && (VAS4[fc1] != 0) && (VAS2[fc1] != VAS4[fc1]) &&
		    (VAS2[fc2] != 0) && (VAS4[fc2] != 0) && (VAS2[fc2] != VAS4[fc2])) {

			if (VAS4[fc2]>=VAS4[fc1]) {	/* einde primair fc1 VOOR einde primair fc2 */

				if ((STAP>=VAS4[fc1]) && (STAP<VAS4[fc2])) hki_gebied12 = TRUE;

			} else {			/* einde primair fc1 NA   einde primair fc2 */

				if ((STAP>=VAS4[fc1]) || (STAP<VAS4[fc2])) hki_gebied12 = TRUE;
			}

			if (!hki_gebied12 && (HVAS[fc2]&BIT3)) HVAS[fc1] |= BIT3;
			if (!hki_gebied12 && (HVAS[fc2]&BIT0) && !(HVAS[fc1]&BIT3)) {
				RW[fc2] |= BIT3;
				RW_hki[i][fc2] |= BIT3;
			}
		}

		/* Buffer RW[] agv koppeling tbv blokkeren doorsnijden */
		/* --------------------------------------------------- */
		if ((RW[fc2]&BIT3) || B[fc1] || ROG(fc1) || RVG(fc1)) PVS2[fc2] |= BIT2;

		if (fc3 >= 0) {
			if ((RW[fc3]&BIT3) || B[fc2] || ROG(fc2) || RVG(fc2) || HG[fc2] || PVS2[fc2]) PVS2[fc3] |= BIT2;
		}

		/* Reset BW_hki[][] */
		/* ---------------- */
		if (fc3 >= 0) {
			if (!(G(fc1) || (PVS2[fc1]&BIT4) || TIJD(kptsg12) || TIJD(kpteg12) || TIJD(kptdm12))) {
				if (!(HG_hki[i][fc2]&BIT1)) {
					if (G(fc3) || !(HG_hki[i][fc3]&BIT1)) BW_hki[i][fc2] = FALSE;
				}
			}
		}

		/* Voorkom onterecht inkomen op SVAS */
		/* --------------------------------- */
		if (SVAS && !G(fc1)) RR[fc1] |= BIT3;

		if (fc3 >= 0) {
			if (SVAS && !G(fc2) && !G(fc1)) RR[fc2] |= BIT3;
		}
	} else {					/* koppeling is niet aktief */
		  HG_hki[i][fc2] &= (~BIT6);
		PVAS_hki[i][fc2] &= (~BIT1);
		if (fc3 >= 0) {
			  HG_hki[i][fc3] &= (~BIT6);
			PVAS_hki[i][fc3] &= (~BIT1);
		}
	}
    }

    for (j=0; j<NUMSG_CS; j++) {
	PVAS[j] &= (~BIT1);				/* bepaal PVAS[]&BIT1 per signaalgroep */
    }

    for (i=0; i<aant_hki; i++) {
	for (j=0; j<NUMSG_CS; j++) {
		if (PVAS_hki[i][j]&BIT1) {
			PVAS[j] |= BIT1;
		}
	}
    }
 }
}

/* PROCEDURE BEPAAL FICTIEVE WACHTSTAND GROEN AANVRAAG */
/* =================================================== */

void proc_wsgr_fca_crsv()
{
 Int16 i,j,k;
 Int16 fc1,fc2,fc3;
 Bool  stat;

 for (i=0; i<NUMSG_CS; i++) {
	if (VA[i] || B[i] || ROG(i) || RVG(i) || G(i) || GL(i) || GR_TIJD(i)) {
	  FCA[i] |= BIT6;	/* Blok.fic.confl.wachtstand-aanvraag */
	}
	FCA[i] |= BIT7; 	/* Fictieve wachtstand-aanvraag */
 }
 for (i=0; i<aant_hki; i++) {
	fc1 = hki[i][0];
	fc2 = hki[i][1];
	fc3 = hki[i][10];
	stat= hki[i][20];

	if (stat >= 2) {
		if (FCA[fc1]&BIT6) FCA[fc2] |= BIT6;

		if (fc3 >= 0) {
			if (FCA[fc2]&BIT6) FCA[fc3] |= BIT6;
		}
	}

 } 
 for (i=0; i<NUMSG_CS; i++) {
	for (j=0; j<aant_dgc[i]; j++) {    /* Primaire conflicten */
   		k = gcf[i][j];
   		if (FCA[k]&BIT6) FCA[i] &= (~BIT7);
	}
	for (j=0; j<aant_dfc[i]; j++) {    /* Fictieve conflicten */
   		k = fcf[i][j];
   		if (FCA[k]&BIT6) FCA[i] &= (~BIT7);
   	}
 }
 for (i=0; i<aant_hki; i++) {
	fc1 = hki[i][0];
	fc2 = hki[i][1];
	fc3 = hki[i][10];
	stat= hki[i][20];

	if (stat >= 2) {
		if (fc3 >= 0) {
			if (!(FCA[fc3]&BIT7)) FCA[fc2] &= (~BIT7);
		}
		if (!(FCA[fc2]&BIT7)) FCA[fc1] &= (~BIT7);
	}
 }
}

/* PROCEDURE AFWIKKELING WACHTSTAND GROEN */
/* ====================================== */

void proc_wsgr_crsv(
	Int16 fc,	/* Signaalgroep */
	Int16 wgr)	/* SCH(WGR)	*/

{
 Bool  wacht = TRUE;

 if (!SCH(wgr) || GL(fc) || GR_TIJD(fc) || K[fc] || !(FCA[fc]&BIT7)
	       || (R(fc) && (BAR[fc] || BLW[fc] || RR[fc] || BHK[fc]))) wacht = FALSE;
 if (wacht) {
	if (!BL_OP(fc) || G(fc)) VA[fc] |= BIT5;
 } else { if (!B[fc] && !ROG(fc) && !RVG(fc)) VA[fc] &= (~BIT5); }
}

/* PROCEDURE AFWIKKELING MEEVERLENGGROEN */
/* ===================================== */

void proc_mvgr_crsv(
	Int16 fc,	/* Signaalgroep */
	Int16 mvg)	/* SCH(MVG)	*/

{
 Int16 i,j,k,x;
 Int16 fc1,fc2,fc3;
 Bool  t_gcf;
 Bool  stat;

 /* Fik130408 */
 /* Nooit meeverlengen als voedende richting van conflicterende hki reeds RVG() geworden is */

 if (MVG(fc) && !BHK[fc]) {
   for (j=0; j<aant_dgc[fc]; j++) {
     k = gcf[fc][j];
     for (i=0; i<aant_hki; i++) {
       fc1  = hki[i][0];
       fc2  = hki[i][1];
       fc3  = hki[i][10];
       stat = hki[i][20];
       if (stat >= 2) {
         if ((k == fc3) && RVG(fc2) && !RR[fc2] || (k == fc2) && RVG(fc1) && !RR[fc1]) BHK[fc] = TRUE;
       }
     }
   }
   for (j=0; j<aant_dfc[fc]; j++) {
     k = fcf[fc][j];
     for (i=0; i<aant_hki; i++) {
       fc1  = hki[i][0];
       fc2  = hki[i][1];
       fc3  = hki[i][10];
       stat = hki[i][20];
       if (stat >= 2) {
         if ((k == fc3) && RVG(fc2) && !RR[fc2] || (k == fc2) && RVG(fc1) && !RR[fc1]) BHK[fc] = TRUE;
       }
     }
   }
 }

 if (VA[fc]&BIT6) {	/* Voedende richting van interne koppeling */

	t_gcf = TRUE;
	for (j=0; j<aant_dgc[fc]; j++) {
   	  k = gcf[fc][j];
   	  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
	}
	for (j=0; j<aant_dfc[fc]; j++) {
   	  k = fcf[fc][j];
   	  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
	}

	for (i=0; i<aant_hki; i++) {
	  stat = hki[i][20];
	  if (stat >= 2) {
	    if (fc == hki[i][0]) {
		x = hki[i][1];
		for (j=0; j<aant_dgc[x]; j++) {
   		  k = gcf[x][j];
   		  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
		}
		for (j=0; j<aant_dfc[x]; j++) {
   		  k = fcf[x][j];
   		  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
		}

		x = hki[i][10];
		if (x >= 0) {
			for (j=0; j<aant_dgc[x]; j++) {
   			  k = gcf[x][j];
   			  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
			}
			for (j=0; j<aant_dfc[x]; j++) {
   			  k = fcf[x][j];
   			  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
			}
		}
	    }
	    if (fc == hki[i][1]) {
		x = hki[i][10];
		if (x >= 0) {
			for (j=0; j<aant_dgc[x]; j++) {
   			  k = gcf[x][j];
   			  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
			}
			for (j=0; j<aant_dfc[x]; j++) {
   			  k = fcf[x][j];
   			  if (R(k) && !GR_TIJD(k) && VA[k] && !BAR[k]) t_gcf = FALSE;
			}
		}
	    }
	  }
	}

	if (SCH(mvg) && !somfbk(fc) && !BHK[fc] && t_gcf && hfkp_mvg()) YM[fc] |= BIT0;
 }
 else {			/* Overige signaalgroepen */

	if (SCH(mvg) && !somfbk(fc) && !BHK[fc]) YM[fc] |= BIT0;
 }
}

/* PROCEDURE RESET VARIABELEN BIJ EINDE SIGNAALGROEPSTURING */
/* ======================================================== */

void proc_reset_crsv_einde()
{
 Int16 i;

 for (i=0; i<NUMSG_CS; i++) {
   FCA[i] &= (~BIT6);
   FCA[i] &= (~BIT7);
   if ((B[i] || ROG(i) || RVG(i)) && !VA[i]) RR[i] = TRUE;
   if (SVAS)				    KRA[i] = FALSE;
   if ((TS || N_ts) && _TTR_HK[i] && (TTR_HK[i] > 0)) TTR_HK[i]--;
 }
}

/* PROCEDURE BEPAAL TIJD TOT PRIMAIR GROEN, TTPG[] TBV WT-VOORSPELLER */
/* ================================================================== */

void proc_ttpg_crsv()
{
 Int16 i,j,k;
 Bool  ppv;

 for (i=0; i<NUMSG_CS; i++) {

	CON_BUS[i] = FALSE;
	if (AKTPRG) {			 /* Bepaal TTPG[]   */
	  if (G(i)) { TTPG[i] = FALSE; } /* 0: indien groen */
	  else {
	    if (GL(i) || R(i) && !VA[i] && !(HVAS[i]&BIT5) || BL_OP(i) ||
	       (VAS2[i] == 0) || (VAS4[i] == 0) || (VAS2[i] == VAS4[i])) {
		 TTPG[i] = 2550;	 /* 2550: indien geel       */
					 /* OF rood zonder aanvraag */
					 /* OF blokkeer_optie AAN   */
					 /* OF geen prim.realisatie */
	    } else {
	      /* Bepaal TTPG[] ogv stappenraster */

	      /* if (TS || SVAS) {  iedere machineslag aanroepen */

		if (STAP<VAS2[i]) { TTPG[i] = (VAS2[i] - STAP)*10; }
		else {
		  if (STAP == VAS2[i]) { TTPG[i] = 0; }
	       	  else { TTPG[i] = (CTYD - STAP + VAS2[i])*10; }
		}

		/* Corrigeer indien versneld afgesloten */

		if (HVAS[i]&BIT3) {
		 if ((VAS4[i]>VAS2[i]) && ((STAP<=VAS2[i]) || (STAP>=VAS4[i]))
		 ||  (VAS4[i]<VAS2[i]) &&  (STAP<=VAS2[i]) && (STAP>=VAS4[i])){
			TTPG[i] += (CTYD*10);
		 }
		}

		/* Corrigeer indien TTP[] verder ligt agv een busprioriteit */

		if (!(HVAS[i]&BIT3) && (TTP[i]<255) && ((TTP[i]*10)>TTPG[i])) {
			TTPG[i] = (TTP[i]*10);
#ifdef WTV_BUS
			CON_BUS[i] = TRUE;
#endif
		}

		/* Corrigeer indien versnelde realisatie aktief */

		ppv = TRUE;
		for (j=0; j<aant_dgc[i]; j++) {
		  k = gcf[i][j];
		  if (TTP[i]>TTP[k]) ppv = FALSE;
		}
		for (j=0; j<aant_dfc[i]; j++) {
		  k = fcf[i][j];
		  if (TTP[i]>TTP[k]) ppv = FALSE;
		}
		if ((WR(i) && B[i] && VA[i] || ROG(i) || RVG(i)) && !RR[i]
			&& ((VA[i]&BIT4) || ppv) /* && TS */
			&& (TTPG[i] > TTR_WV[i])) TTPG[i] = TTR_WV[i];

		/* Corrigeer indien UITSTEL aktief */
		if (TTPG[i]<(TTU[i]*10)) TTPG[i] = (TTU[i]*10);

		/* Indien RVG() dan altijd aftellen op basis van TTR_WV[] */
		if (RVG(i)) TTPG[i] = TTR_WV[i];

	   /* } */
	    }
	  }
	} else { TTPG[i] = 2550; }	 /* 2550: indien niet CRSV */
 }
 TS = SPR = SVAS = FALSE;		 /* Reset startpulsen */
}

/* BEPAAL AANTAL LAMPJES WACHTTIJD VOORSPELLER */
/* =========================================== */

void proc_wt_voorspeller_crsv(void)
{
   Int16 i,rest;

   for (i=0; i<NUMSG_CS; i++) {
	if (WTV_SG[i]) {
		if (HALT[i] > 0) {
			if (HALT[i] > TE) HALT[i] -= TE;
			else              HALT[i] = 0;
		}

		if (BL_OP(i) || CON_BUS[i] || (FIX && HFIX)) HALT[i] = 10;
		if (G(i) || GL(i)) ALED[i] = 0;
		if (R(i) && (VA[i]&BIT1) && !(VA[i]&BIT7) && (ALED[i] == 0)) {
			if (RR[i] || WR(i) && !B[i] && !(VA[i]&BIT5) || ROG(i) && !begin_ROG(i) || RVG(i) && !begin_RVG(i) || (KRA[i] >= 2)) {
				ALED[i] = 31;
				Adwt[i] = 0;
			}
		} else {
			if (TE && (Adwt[i] < 600)) Adwt[i] += TE;
			if ((TTPG[i] < 2550) && !BL_OP(i) && (ALED[i] > 0) && (!HALT[i] && (!FIX || !HFIX) || (HG[i]&BIT7) && !somgk(i))) {
				Tdwt[i] = (TTPG[i]+Adwt[i])/ALED[i];
				rest    = (TTPG[i]+Adwt[i])%ALED[i];
				if ((2*rest) >= ALED[i]) Tdwt[i]++;
				if (Tdwt[i] < 1)   Tdwt[i] = 1;
				if (Tdwt[i] > 600) Tdwt[i] = 600;
				if (Adwt[i] >= Tdwt[i]) {
					if (ALED[i] > 1) ALED[i]--;
					Adwt[i] = 0;
				}
			}
		}
		ABUS[i] = CON_BUS[i] && (ALED[i] > 0) && (!(HG[i]&BIT7) || somgk(i));

	} else {		/* Geen wachttijdvoorspeller! */
		ALED[i] = 0;
		ABUS[i] = FALSE;
		HALT[i] = 0;
		Adwt[i] = Tdwt[i] = 0;
	}
   }
}

/* PROCEDURE KOPPELING CRSV-MODULE -> CRS */
/* ====================================== */

void proc_crsv_to_crs()
{
 Int16 i;

 proc_reset_crsv_einde();

 for (i=0; i<NUMSG_CS; i++) {

   /* Bepaal aanvraag C-regelaar */
   /* -------------------------- */
#ifdef RWSC_old
   if ((WR(i) || ROG(i) || RVG(i)) && VA[i]) set_A(i);
   else	                                     reset_A(i);
#else
   if ((WR(i) || ROG(i) || RVG(i)) && VA[i]) CRSV_TO_CR[i][MA_CRSV] = 1;
   else                                      CRSV_TO_CR[i][MA_CRSV] = 0;
#endif

   /* Maak overgang van WR(i) naar RVG(i) via ROG(i) */
   /* ---------------------------------------------- */
#ifdef RWSC_old
   if (WR(i) && B[i] && VA[i] && !RR[i]) set_BEURT(i);
   else	                                 reset_BEURT(i);
#else
   if (WR(i) && B[i] && VA[i] && !RR[i]) CRSV_TO_CR[i][PPS_CRSV] = 1;
   else	                                 CRSV_TO_CR[i][PPS_CRSV] = 0;
#endif

   /* Bepaal retour WR(i) */
   /* ------------------- */
#ifdef RWSC_old
   if ((WR(i) || ROG(i) || RVG(i)) && RR[i]) set_RWR_OP(i);
   else	                                     reset_RWR_OP(i);
   if ((ROG(i) || RVG(i)) && !VA[i])         set_RWR_OP(i);
#else
   if ((WR(i) || ROG(i) || RVG(i)) && RR[i]) CRSV_TO_CR[i][RWR_CRSV] = 1;
   else	                                     CRSV_TO_CR[i][RWR_CRSV] = 0;
   if ((ROG(i) || RVG(i)) && !VA[i])         CRSV_TO_CR[i][RWR_CRSV] = 1;
#endif

   /* Bepaal aanhouden RVG(i) -> ALTIJD minimaal 1 machineslag */
   /* -------------------------------------------------------- */
#ifdef RWSC_old
   if (WR(i) || ROG(i) || X[i]) set_RVG_OP(i);
   else	                        reset_RVG_OP(i);
#else
   if (WR(i) || ROG(i) || X[i]) CRSV_TO_CR[i][VRVG_CRSV] = 1;
   else	                        CRSV_TO_CR[i][VRVG_CRSV] = 0;
#endif

   /* Bepaal aanhouden VAG2e(i) */
   /* ------------------------- */
#ifdef RWSC_old
   if (G(i) && (RW[i] || YV[i]) && !Z[i]) set_VAG_OP(i);
   else	                                  reset_VAG_OP(i);
#else
   if (G(i) && (RW[i] || YV[i]) && !Z[i]) CRSV_TO_CR[i][VVAG2e_CRSV] = 1;
   else                                   CRSV_TO_CR[i][VVAG2e_CRSV] = 0;
#endif

   /* Bepaal retour VAG2e(i) */
   /* ---------------------- */
#ifdef RWSC_old
   if (G(i) && RW[i] && !Z[i]) set_RVAG_OP(i);
   else	                       reset_RVAG_OP(i);
#else
   if (G(i) && RW[i] && !Z[i]) CRSV_TO_CR[i][RVAG2e_CRSV] = 1;
   else                        CRSV_TO_CR[i][RVAG2e_CRSV] = 0;
#endif

   /* Bepaal aanhouden MVG(i) */
   /* ----------------------- */
#ifdef RWSC_old
   if (G(i) && YM[i] && !Z[i] || FIX && HFIX) set_VMG_OP(i);
   else	                                      reset_VMG_OP(i);
#else
   if (G(i) && YM[i] && !Z[i] || FIX && HFIX) CRSV_TO_CR[i][VMVG_CRSV] = 1;
   else	                                      CRSV_TO_CR[i][VMVG_CRSV] = 0;
#endif

   /* Forceer einde groen */
   /* ------------------- */
#ifdef RWSC_old
   if (G(i) && Z[i]) set_AFK_OP(i);
   else	             reset_AFK_OP(i);
#else
   if (G(i) && Z[i]) CRSV_TO_CR[i][AFK_CRSV] = 1;
   else	             CRSV_TO_CR[i][AFK_CRSV] = 0;
#endif

   /* Wachtstandgroen */
   /* --------------- */

   if (G(i) && (VA[i]&BIT5)) set_WSGR_toewijzing(i);
   else {
	reset_WSGR_toewijzing(i);
	if (WG(i) && !(VA[i]&BIT5)) {
#ifdef RWSC_old
          set_AFK_OP(i);		  /* Forceer overgang naar 2eVAG     */
          set_VAG_OP(i);		  /* ... igv conflicterende aanvraag */
#else
          CRSV_TO_CR[i][AFK_CRSV] = 1;    /* Forceer overgang naar 2eVAG     */
          CRSV_TO_CR[i][VVAG2e_CRSV] = 1; /* ... igv conflicterende aanvraag */
#endif
	}
   }
 }

#ifndef CRSV_EN_BLOK
#ifndef RWSC_old

 for (i=0; i<NUMSG_CS; i++) {

   if (CRSV_TO_CR[i][MA_CRSV]     == 1) set_MA_OP(i);
   else                               reset_MA_OP(i);

   if (CRSV_TO_CR[i][PPS_CRSV]    == 1) set_PPS_OP(i);
   else                               reset_PPS_OP(i);

   if (CRSV_TO_CR[i][RWR_CRSV]    == 1) set_RWR_OP(i);
   else                               reset_RWR_OP(i);

   if (CRSV_TO_CR[i][VRVG_CRSV]   == 1) set_VRVG_OP(i);
   else                               reset_VRVG_OP(i);

   if (CRSV_TO_CR[i][VVAG2e_CRSV] == 1) set_VVAG2e_OP(i);
   else                               reset_VVAG2e_OP(i);

   if (CRSV_TO_CR[i][RVAG2e_CRSV] == 1) set_RVAG2e_OP(i);
   else                               reset_RVAG2e_OP(i);

   if (CRSV_TO_CR[i][VMVG_CRSV]   == 1) set_VMVG_OP(i);
   else                               reset_VMVG_OP(i);

   if (CRSV_TO_CR[i][AFK_CRSV]    == 1) set_AFK_OP(i);
   else                               reset_AFK_OP(i);

 }
#endif
#endif

 proc_ttpg_crsv();
 proc_wt_voorspeller_crsv();
}

/* PROCEDURES TBV COMBINERING FUNCTIE-AANROEPEN */
/* ============================================ */

/* Combinatie signaalgroepsturing 1e gedeelte */
/* ------------------------------------------ */

void CRSV_SG_main_1()
{
 proc_corr_kapm();
 proc_bteg_crsv();
 proc_bttr_crsv();
 proc_bttp_crsv();
 proc_prio_crsv();
 proc_prim_crsv();
 proc_altt_crsv();
}

/* Combinatie signaalgroepsturing 2e gedeelte */
/* ------------------------------------------ */

void CRSV_SG_main_2()
{
 Int16 i;

 proc_altr_crsv();
 
 for (i=0; i<aant_fts; i++) {
   proc_vtg_fts_crsv(fts[i][0],fts[i][1],fts[i][2],fts[i][3],fts[i][4]);
 }
 for (i=0; i<aant_bbv; i++) {
   proc_bb_vtg_crsv(bbv[i][0],bbv[i][1],bbv[i][2],bbv[i][4],bbv[i][5]
					,bbv[i][6],bbv[i][7]);
 }
 for (i=0; i<aant_gov; i++) {
   proc_go_vtg_crsv(gov[i][0],gov[i][1],gov[i][2],gov[i][3],gov[i][4]
		      ,gov[i][5],gov[i][7],gov[i][8],gov[i][9],gov[i][10]
		      ,gov[i][11],gov[i][12],gov[i][13],gov[i][14],gov[i][15]
		      ,gov[i][16],gov[i][17],gov[i][18],gov[i][19],gov[i][20]
		      ,gov[i][22],gov[i][23],gov[i][24],gov[i][25],gov[i][26],gov[i][27],gov[i][28]);
 }
 proc_hki_crsv();
 proc_wsgr_fca_crsv();
}
